AimTorqueGoal = {}
AimTorqueGoalMT = { __index = AimTorqueGoal }

setmetatable ( AimTorqueGoal, { __index = Goal } )
goals['aimTorque'] = AimTorqueGoal

function AimTorqueGoal:Create ( targetName, lookAhead, turnRate, maxTorque, ease )
	local goal = {}
	setmetatable ( goal, AimTorqueGoalMT )

	goal.targetName = targetName
	goal.lookAhead = lookAhead
	goal.turnRate = turnRate
	goal.maxTorque = maxTorque
	goal.ease = ease

	return goal
end
function AimTorqueGoal:Destroy ( )
    self.status = nil
	self.targetName = nil
	self.lookAhead = nil
	self.turnRate = nil
	self.maxTorque = nil
	self.ease = nil
end
function AimTorqueGoal:GetType ( )
    return 'aimTorque'
end
function AimTorqueGoal:Process ( delta, owner )
    local target = owner.world:FindBody ( self.targetName )
    if target == nil then
        return GOAL_FAILED, 0
    end

    -- factor in lookahead
    local lv = target.b2body:GetLinearVelocity ( )
    lv.x = lv.x * self.lookAhead
    lv.y = lv.y * self.lookAhead
    local position = b2Vec2 ( target.def.position.x + lv.x, target.def.position.y + lv.y )

	local used = owner:FaceTorque ( delta, position, self.turnRate, self.maxTorque, self.ease )

	if used < delta then
		return GOAL_COMPLETED, used
	end

	return GOAL_ACTIVE, delta
end
function AimTorqueGoal:CreateXML ( goal )
	local targetName = goal.target
	local lookAhead = tonumber ( goal.lookAhead )
	local turnRate = tonumber ( goal.turnRate )
	local maxTorque = tonumber ( goal.maxTorque )
	local ease = toboolean ( goal.ease )

	local g = AimTorqueGoal:Create ( targetName, lookAhead, angularVelocity, maxTorque, ease )
	return g
end
function AimTorqueGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.target = self.targetName
	g.lookAhead = self.lookAhead
	g.turnRate = self.turnRate
	g.maxTorque = self.maxTorque
	g.ease = self.ease
	return g
end

