ApplyImpulseGoal = {}
ApplyImpulseGoalMT = { __index = ApplyImpulseGoal }

setmetatable ( ApplyImpulseGoal, { __index = Goal } )
goals['applyImpulse'] = ApplyImpulseGoal

function ApplyImpulseGoal:Create ( impulse )
	local goal = {}
	setmetatable ( goal, ApplyImpulseGoalMT )

	goal.impulse = impulse

	return goal
end
function ApplyImpulseGoal:Destroy ( )
	self.impulse = nil
end
function ApplyImpulseGoal:GetType ( )
    return 'applyImpulse'
end
function ApplyImpulseGoal:Process ( delta, owner )
	owner.b2body:ApplyImpulse ( self.impulse, owner.def.position )
	
	return GOAL_COMPLETED, 0
end
function ApplyImpulseGoal:CreateXML ( goal )
	local impulse = tob2Vec2 ( goal.impulse )
	local g = ApplyImpulseGoal:Create ( impulse )
	return g
end
function ApplyImpulseGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.impulse = b2Vec2tostring ( self.impulse )
	return g
end

