DestroyBodyGoal = {}
DestroyBodyGoalMT = { __index = DestroyBodyGoal }

setmetatable ( DestroyBodyGoal, { __index = Goal } )
goals['destroyBody'] = DestroyBodyGoal

function DestroyBodyGoal:Create ( name )
	local goal = {}
	setmetatable ( goal, DestroyBodyGoalMT )

	goal.name = name

	return goal
end
function DestroyBodyGoal:Destroy ( )
	self.name = nil
end
function DestroyBodyGoal:GetType ( )
    return 'destroyBody'
end
function DestroyBodyGoal:Process ( delta, owner )
    local body
    if self.name == 'self' then
        body = owner
    else
        body = owner.world:FindBody ( self.name )
    end
	owner.world:DestroyBody ( body )
	return GOAL_COMPLETED, 0
end
function DestroyBodyGoal:CreateXML ( goal )
    local name = goal.name
	local g = DestroyBodyGoal:Create ( name )
	return g
end
function DestroyBodyGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.name = self.name
	return g
end

