FaceTorqueGoal = {}
FaceTorqueGoalMT = { __index = FaceTorqueGoal }

setmetatable ( FaceTorqueGoal, { __index = Goal } )
goals['faceTorque'] = FaceTorqueGoal

function FaceTorqueGoal:Create ( position, turnRate, maxTorque, ease )
	local goal = {}
	setmetatable ( goal, FaceTorqueGoalMT )

	goal.position = position
	goal.turnRate = turnRate
	goal.maxTorque = maxTorque
	goal.ease = ease

	return goal
end
function FaceTorqueGoal:Destroy ( )
	self.position = nil
	self.turnRate = nil
	self.maxTorque = nil
	self.ease = nil
end
function FaceTorqueGoal:GetType ( )
    return 'faceTorque'
end
function FaceTorqueGoal:Process ( delta, owner )
	local used = owner:FaceTorque ( delta, self.position, self.turnRate, self.maxTorque, self.ease )

	if used < delta then
		return GOAL_COMPLETED, used
	end

	return GOAL_ACTIVE, delta
end
function FaceTorqueGoal:CreateXML ( goal )
	local position = tob2Vec2 ( goal.position )
	local turnRate = tonumber ( goal.turnRate )
	local maxTorque = tonumber ( goal.maxTorque )
	local ease = toboolean ( goal.ease )

	local g = FaceTorqueGoal:Create ( position, angularVelocity, maxTorque, ease )
	return g
end
function FaceTorqueGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.position = b2Vec2tostring ( self.position )
	g.turnRate = self.turnRate
	g.maxTorque = self.maxTorque
	g.ease = self.ease
	return g
end

