MoveLVGoal = {}
MoveLVGoalMT = { __index = MoveLVGoal }

setmetatable ( MoveLVGoal, { __index = Goal } )
goals['moveLV'] = MoveLVGoal

function MoveLVGoal:Create ( reference, position, speed, transformed )
	local goal = {}
	setmetatable ( goal, MoveLVGoalMT )

    goal.reference = reference
	goal.position = position
	goal.speed = speed
	goal.transformed = transformed

	return goal
end
function MoveLVGoal:Destroy ( )
    self.reference = nil
	self.position = nil
	self.speed = nil
	self.transformed = nil
end
function MoveLVGoal:GetType ( )
    return 'moveLV'
end
function MoveLVGoal:Reset ( )
    self.transformed = nil
end
function MoveLVGoal:Process ( delta, owner )
	if self.transformed == nil then
        if self.reference == 'world' then
            self.transformed = self.position
        elseif self.reference == 'self' then
            self.transformed = owner.b2body:GetWorldPoint ( self.position )
        else
            local reference = owner.world:FindBody ( self.reference )
            if reference == nil then
                return GOAL_FAILED, 0
            end
            self.transformed = reference.b2body:GetWorldPoint ( self.position )
        end
    end
    
	local used = owner:MoveLV ( delta, self.transformed, self.speed )
	if used < delta then
        self:Reset ( )
        return GOAL_COMPLETED, used
	end
    return GOAL_ACTIVE, used
end
function MoveLVGoal:CreateXML ( goal )
    local reference = goal.reference
	local position = tob2Vec2 ( goal.position )
	local speed = tonumber ( goal.speed )
    local transformed = tob2Vec2 ( goal.transformed )
	local g = MoveLVGoal:Create ( reference, position, speed, transformed )
	return g
end
function MoveLVGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.reference = self.reference
	g.position = b2Vec2tostring ( self.position )
	g.speed = self.speed
	g.transformed = b2Vec2tostring ( self.transformed )
	return g
end


