RotateGoal = {}
RotateGoalMT = { __index = RotateGoal }

setmetatable ( RotateGoal, { __index = Goal } )
goals['rotate'] = RotateGoal

function RotateGoal:Create ( angle, turnRate )
	local goal = {}
	setmetatable ( goal, RotateGoalMT )

	goal.angle = angle
	goal.turnRate = turnRate

	return goal
end
function RotateGoal:Destroy ( )
	self.angle = nil
	self.turnRate = nil
end
function RotateGoal:GetType ( )
    return 'rotate'
end
function RotateGoal:Process ( delta, owner )
	if self.turnRate == nil then
		owner:SetAngle ( self.angle )
		return GOAL_COMPLETED, 0
	end
	local used = owner:Rotate ( delta, self.angle, self.turnRate )
	if used == delta then
		return GOAL_ACTIVE, used
	end
	return GOAL_COMPLETED, used
end
function RotateGoal:CreateXML ( goal )
	local angle = tonumber ( goal.angle )
	local turnRate = tonumber ( goal.turnRate )
	local g = RotateGoal:Create ( angle, turnRate )
	return g
end
function RotateGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.angle = self.angle
	g.turnRate = self.turnRate
	return g
end
