RotateAVGoal = {}
RotateAVGoalMT = { __index = RotateAVGoal }

setmetatable ( RotateAVGoal, { __index = Goal } )
goals['rotateAV'] = RotateAVGoal

function RotateAVGoal:Create ( angle, turnRate )
	local goal = {}
	setmetatable ( goal, RotateAVGoalMT )

	goal.angle = angle
	goal.turnRate = turnRate

	return goal
end
function RotateAVGoal:Destroy ( )
	self.angle = nil
	self.turnRate = nil
end
function RotateAVGoal:GetType ( )
    return 'rotateAV'
end
function RotateAVGoal:Process ( delta, owner )
	local used = owner:RotateAV ( delta, self.angle, self.turnRate )
	if used == delta then
		return GOAL_ACTIVE, used
	end
	return GOAL_COMPLETED, used

end
function RotateAVGoal:CreateXML ( goal )
	local angle = tonumber ( goal.angle )
	local turnRate = tonumber ( goal.turnRate )
	local g = RotateAVGoal:Create ( angle, turnRate )
	return g
end
function RotateAVGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.angle = self.angle
	g.turnRate = self.turnRate
	return g
end
