RotateTorqueGoal = {}
RotateTorqueGoalMT = { __index = RotateTorqueGoal }

setmetatable ( RotateTorqueGoal, { __index = Goal } )
goals['rotateTorque'] = RotateTorqueGoal

function RotateTorqueGoal:Create ( angle, turnRate, maxTorque, ease )
	local goal = {}
	setmetatable ( goal, RotateTorqueGoalMT )

	goal.angle = angle
	goal.turnRate = turnRate
	goal.maxTorque = maxTorque
	goal.ease = ease

	return goal
end
function RotateTorqueGoal:Destroy ( )
	self.angle = nil
	self.turnRate = nil
	self.maxTorque = nil
	self.ease = nil
end
function RotateTorqueGoal:GetType ( )
    return 'rotateTorque'
end
function RotateTorqueGoal:Process ( delta, owner )
	local used = owner:RotateTorque ( delta, self.angle, self.turnRate, self.maxTorque, self.ease )
	if used == delta then
		return GOAL_ACTIVE, used
	end
	return GOAL_COMPLETED, used
end
function RotateTorqueGoal:CreateXML ( goal )
	local angle = tonumber ( goal.angle )
	local turnRate = tonumber ( goal.turnRate )
	local maxTorque = tonumber ( goal.maxTorque )
	local ease = toboolean ( goal.ease )
	local g = RotateTorqueGoal:Create ( angle, turnRate, maxTorque, ease )
	return g
end
function RotateTorqueGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.angle = self.angle
	g.turnRate = self.turnRate
	g.maxTorque = self.maxTorque
	g.ease = self.ease
	return g
end


