ScaleGoal = {}
ScaleGoalMT = { __index = ScaleGoal }

setmetatable ( ScaleGoal, { __index = Goal } )
goals['scale'] = ScaleGoal

function ScaleGoal:Create ( scale, time, elapsed )
	local goal = {}
	setmetatable ( goal, ScaleGoalMT )

	goal.scale = scale
	goal.time = time or 0
	goal.elapsed = elapsed or 0

	return goal
end
function ScaleGoal:Destroy ( )
	self.scale = nil
	self.time = nil
	self.elapsed = nil
end
function ScaleGoal:GetType ( )
    return 'scale'
end
function ScaleGoal:Reset ( )
    self.elapsed = 0
end
function ScaleGoal:Process ( delta, owner )
	self.elapsed = self.elapsed + delta

	-- condition
	if self.elapsed >= self.time then
		owner:SetScale ( self.scale )
		local used = delta - ( self.elapsed - self.time )
		self.elapsed = 0
		return GOAL_COMPLETED, used
	end

	-- output
	local ratio = delta / ( self.time - ( self.elapsed - delta ) )
	owner:SetScale ( owner.scale + ( self.scale - owner.scale ) * ratio )

	return GOAL_ACTIVE, delta
end
function ScaleGoal:CreateXML ( goal )
	local scale = tonumber ( goal.scale )
	local time = tonumber ( goal.time )
	local elapsed = tonumber ( goal.elapsed )
	local g = ScaleGoal:Create ( scale, time, elapsed )
	return g
end
function ScaleGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.scale = self.scale
	g.time = self.time
	g.elapsed = self.elapsed
	return g
end


