StopGoal = {}
StopGoalMT = { __index = StopGoal }

setmetatable ( StopGoal, { __index = Goal } )
goals['stop'] = StopGoal

function StopGoal:Create ( time, elapsed )
	local goal = {}
	setmetatable ( goal, StopGoalMT )

	goal.time = time or 0
	goal.elapsed = elapsed or 0

	return goal
end
function StopGoal:Destroy ( )
	self.time = nil
	self.elapsed = nil
end
function StopGoal:GetType ( )
    return 'stop'
end
function StopGoal:Reset ( )
    self.elapsed = 0
end
function StopGoal:Process ( delta, owner )
	owner:Stop ( delta )

	self.elapsed = self.elapsed + delta
	if self.elapsed >= self.time then
	    local used = delta - ( self.elapsed - self.time )
		self.elapsed = 0
		return GOAL_COMPLETED, used
	end

	return GOAL_ACTIVE, delta
end
function StopGoal:CreateXML ( goal )
    local time = tonumber ( goal.time )
    local elapsed = tonumber ( goal.elapsed )
	local g = StopGoal:Create ( time, elapsed )
	return g
end
function StopGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.time = self.time
	g.elapsed = self.elapsed
	return g
end


