StopForceGoal = {}
StopForceGoalMT = { __index = StopForceGoal }

setmetatable ( StopForceGoal, { __index = Goal } )
goals['stopForce'] = StopForceGoal

function StopForceGoal:Create ( force, torque )
	local goal = {}
	setmetatable ( goal, StopForceGoalMT )

	goal.force = force
	goal.torque = torque

	return goal
end
function StopForceGoal:Destroy ( )
	self.force = nil
	self.torque = nil
end
function StopForceGoal:GetType ( )
    return 'stopForce'
end
function StopForceGoal:Process ( delta, owner )
    local used = owner:AccelerateLV ( delta, b2_b2Vec2, self.force )
	used = math.max ( used, owner:AccelerateAV ( delta, 0, self.torque ) )
	
	if used < delta then
	    return GOAL_COMPLETED, used
    end

	return GOAL_ACTIVE, delta
end
function StopForceGoal:CreateXML ( goal )
    local force = tonumber ( goal.force )
    local torque = tonumber ( goal.torque )
	local g = StopForceGoal:Create ( force, torque )
	return g
end
function StopForceGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.force = self.force
	g.torque = self.torque
	return g
end


