TransferGoal = {}
TransferGoalMT = { __index = TransferGoal }

setmetatable ( TransferGoal, { __index = Goal } )
goals['transfer'] = TransferGoal

function TransferGoal:Create ( destStreamFile )
	local goal = {}
	setmetatable ( goal, TransferGoalMT )

	goal.destStreamFile = destStreamFile

	return goal
end
function TransferGoal:Destroy ( )
	self.destStreamFile = nil
end
function TransferGoal:GetType ( )
    return 'transfer'
end
function TransferGoal:Process ( delta, owner )
	local game = owner.world.game
	local srcStreamFile = game:FindStreamFile ( owner.world )
	local srcStream = game:FindStream ( srcStreamFile )
	local destStream = game:FindStream ( self.destStreamFile )

	-- iterate all contacts that have occured within the last frame
	for i, v in pairs ( owner.contacts ) do
		-- make sure the body we have in the contact buffer hasn't been destroyed
		local b = owner.world:FindBody ( i )

		-- occurs when the body is destroyed in the same frame it was created
		-- assert ( b, "Contact body not found" )

		if b and b.name == 'player' then
            local old = b
            local lv = old.b2body:GetLinearVelocity ( )
            local av = old.b2body:GetAngularVelocity ( )

            destStream:Select ( )
            local new = destStream.world:DuplicateBody ( old, old.name )
            new.b2body:SetLinearVelocity ( lv )
            new.b2body:SetAngularVelocity ( av )
            new.Paint = old.Paint
            new:Paint ( )

            new.goal = old.goal

            srcStream.world:DestroyBody ( old )
            srcStream:DeSelect ( )

            game.player = destStream.world:FindBody ( "player" )
		end
	end

	return GOAL_ACTIVE, delta
end
function TransferGoal:CreateXML ( goal )
	local destStreamFile = goal.destStreamFile
	local g = TransferGoal:Create ( destStreamFile )
	return g
end
function TransferGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.destStreamFile = self.destStreamFile
	return g
end

