CollisionGoal = {}
CollisionGoalMT = { __index = CollisionGoal }

setmetatable ( CollisionGoal, { __index = Goal } )
goals['collision'] = CollisionGoal

function CollisionGoal:Create ( continuous )
	local goal = {}
	setmetatable ( goal, CollisionGoalMT )

	goal.continuous = continuous or false

	return goal
end
function CollisionGoal:Destroy ( )
	self.continuous = nil
end
function CollisionGoal:GetType ( )
    return 'collision'
end
function CollisionGoal:Process ( delta, owner )
    if #owner.collisions > 0 then
        return GOAL_COMPLETED, 0
    end
    if self.continuous == true then
        return GOAL_ACTIVE, delta
    else
        return GOAL_FAILED, 0
    end
end
function CollisionGoal:CreateXML ( goal )
	local continuous = goal.continuous
	local g = CollisionGoal:Create ( continuous )
	return g
end
function CollisionGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.continuous = self.continuous
	return g
end

