FrozenGoal = {}
FrozenGoalMT = { __index = FrozenGoal }

setmetatable ( FrozenGoal, { __index = Goal } )
goals['frozen'] = FrozenGoal

function FrozenGoal:Create ( isFrozen, continuous )
	local goal = {}
	setmetatable ( goal, FrozenGoalMT )

	goal.isFrozen = isFrozen
	goal.continuous = continuous

	return goal
end
function FrozenGoal:Destroy ( )
	self.isFrozen = nil
	self.continuous = nil
end
function FrozenGoal:GetType ( )
    return 'frozen'
end
function FrozenGoal:Process ( delta, owner )
    if owner.b2body:IsFrozen ( ) == goal.isFrozen then
        return GOAL_COMPLETED, 0
    end

    if self.continuous ~= true then
        return GOAL_FAILED, 0
    end

    return GOAL_ACTIVE, delta
end
function FrozenGoal:CreateXML ( goal )
	local isFrozen = toboolean ( goal.isFrozen )
	local continuous = toboolean ( goal.continuous )
	local g = FrozenGoal:Create ( isFrozen, continuous )
	return g
end
function FrozenGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.isFrozen = self.isFrozen
	g.continuous = self.continuous
	return g
end

