MessageReceiveGoal = {}
MessageReceiveGoalMT = { __index = MessageReceiveGoal }

setmetatable ( MessageReceiveGoal, { __index = Goal } )
goals['messageReceive'] = MessageReceiveGoal

function MessageReceiveGoal:Create ( message, received )
	local goal = {}
	setmetatable ( goal, MessageReceiveGoalMT )

	goal.message = message
	goal.received = received or false

	return goal
end
function MessageReceiveGoal:Destroy ( )
	self.message = nil
	self.received = nil
end
function MessageReceiveGoal:GetType ( )
    return 'messageReceive'
end
function MessageReceiveGoal:Reset ( )
    self.received = false
end
function MessageReceiveGoal:Process ( delta, owner )
    if self.received == true then
        self.received = false
        return GOAL_COMPLETED, 0
    end
	return GOAL_ACTIVE, delta
end
function MessageReceiveGoal:Message ( owner, type, ... )
    if self.message == type and self.received == false then
        self.received = true
        return true
    end
    return false
end
function MessageReceiveGoal:CreateXML ( goal )
    local message = goal.message
	local received = toBoolean ( goal.received )
	local g = MessageReceiveGoal:Create ( message, received )
	return g
end
function MessageReceiveGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.message = self.message
	g.received = self.received
	return g
end

