MessageSendGoal = {}
MessageSendGoalMT = { __index = MessageSendGoal }

setmetatable ( MessageSendGoal, { __index = Goal } )
goals['messageSend'] = MessageSendGoal

function MessageSendGoal:Create ( receiver, message )
	local goal = {}
	setmetatable ( goal, MessageSendGoalMT )

	goal.receiver = receiver
	goal.message = message

	return goal
end
function MessageSendGoal:Destroy ( )
	self.receiver = nil
	self.message = nil
end
function MessageSendGoal:GetType ( )
    return 'messageSend'
end
function MessageSendGoal:Process ( delta, owner )
    if self.receiver == 'contacts' then
        -- degenerated objects have no contacts
        if owner.contacts then
            for i, v in pairs ( owner.contacts ) do
                local receiver = owner.world:FindBody ( i )
                if receiver then
                    receiver:Message ( self.message )
                end
            end
        end
    elseif self.receiver == 'collisions' then
        -- degenerated objects have no collisions
        if owner.collisions then
            for i, v in pairs ( owner.collisions ) do
                local receiver = owner.world:FindBody ( v[1] )
                if receiver then
                    receiver:Message ( self.message )
                end
            end
        end
    else
        local receiver = owner.world:FindBody ( self.receiver )
        if receiver then
            receiver:Message ( self.message, owner )
        end
    end
	return GOAL_COMPLETED, 0
end
function MessageSendGoal:CreateXML ( goal )
	local receiver = goal.receiver
	local message = goal.message
	local g = MessageSendGoal:Create ( receiver, message )
	return g
end
function MessageSendGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.receiver = self.receiver
	g.message = self.message
	return g
end

