ContactGoal = {}
ContactGoalMT = { __index = ContactGoal }

setmetatable ( ContactGoal, { __index = Goal } )
goals['contact'] = ContactGoal

function ContactGoal:Create ( sensorName, targetName, continuous )
	local goal = {}
	setmetatable ( goal, ContactGoalMT )

	goal.sensorName = sensorName
	goal.targetName = targetName
	goal.continuous = continuous

	return goal
end
function ContactGoal:Destroy ( )
	self.sensorName = nil
	self.targetName = nil
	self.continuous = nil
end
function ContactGoal:GetType ( )
    return 'contact'
end
function ContactGoal:Process ( delta, owner )
	local sensor
    if self.sensorName == 'self' then
        sensor = owner
    else
        sensor = owner.world:FindBody ( self.sensorName )
    end

	local target = owner.world:FindBody ( self.targetName )
	if sensor and target then
        if sensor:IsTouching ( target ) == true then
            return GOAL_COMPLETED, 0
        end
	end

    if self.continuous ~= true then
        return GOAL_FAILED, 0
    end

    return GOAL_ACTIVE, delta
end
function ContactGoal:CreateXML ( goal )
	local sensorName = goal.sensorName
	local targetName = goal.targetName
	local continuous = toboolean ( goal.continuous )
	local g = ContactGoal:Create ( sensorName, targetName, continuous )
	return g
end
function ContactGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.sensorName = self.sensorName
	g.targetName = self.targetName
	g.continuous = self.continuous
	return g
end
