WaitGoal = {}
WaitGoalMT = { __index = WaitGoal }

setmetatable ( WaitGoal, { __index = Goal } )
goals['wait'] = WaitGoal

function WaitGoal:Create ( time, elapsed )
	local goal = {}
	setmetatable ( goal, WaitGoalMT )

	goal.time = time
	goal.elapsed = elapsed or 0

	return goal
end
function WaitGoal:Destroy ( )
	self.time = nil
	self.elapsed = nil
end
function WaitGoal:GetType ( )
    return 'wait'
end
function WaitGoal:Reset ( )
    self.elapsed = 0
end
function WaitGoal:Process ( delta, owner )
	self.elapsed = self.elapsed + delta

	-- is the waiting period over?
	if self.elapsed >= self.time then
	    local used = delta - ( self.elapsed - self.time )
		self.elapsed = 0
		return GOAL_COMPLETED, used
	end
	return GOAL_ACTIVE, delta
end
function WaitGoal:CreateXML ( goal )
	local time = tonumber ( goal.time )
	local elapsed = tonumber ( goal.elapsed )
	local g = WaitGoal:Create ( time, elapsed )
	return g
end
function WaitGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.time = self.time
	g.elapsed = self.elapsed
	return g
end
