FadeGoal = {}
FadeGoalMT = { __index = FadeGoal }

setmetatable ( FadeGoal, { __index = Goal } )
goals['fade'] = FadeGoal

function FadeGoal:Create ( alpha, time, elapsed )
	local goal = {}
	setmetatable ( goal, FadeGoalMT )

	goal.alpha = alpha
	goal.time = time
	self.elapsed = elapsed or 0

	return goal
end
function FadeGoal:Destroy ( )
	self.alpha = nil
	self.time = nil
	self.elapsed = nil
end
function FadeGoal:GetType ( )
    return 'fade'
end
function FadeGoal:Reset ( )
    self.elapsed = 0
end
function FadeGoal:Process ( delta, owner )
	self.elapsed = self.elapsed + delta

	-- condition
	if self.elapsed >= self.time then
		owner.sprite.alpha = self.alpha
		local used = delta - ( self.elapsed - self.time )
		self.elapsed = 0
		return GOAL_COMPLETED, used
	end

	-- output
	local ratio = delta / ( self.time - ( self.elapsed - delta ) )
	owner.sprite.alpha = owner.sprite.alpha + ( self.alpha - owner.sprite.alpha ) * ratio

	return GOAL_ACTIVE, delta
end
function FadeGoal:CreateXML ( goal )
	local alpha = tonumber ( goal.alpha )
	local time = tonumber ( goal.time )
	local elapsed = tonumber ( goal.elapsed )
	local g = FadeGoal:Create ( alpha, time, elapsed )
	return g
end
function FadeGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.alpha = self.alpha
	g.time = self.time
	g.elapsed = self.elapsed
	return g
end
