ModulateGoal = {}
ModulateGoalMT = { __index = ModulateGoal }

setmetatable ( ModulateGoal, { __index = Goal } )
goals['modulate'] = ModulateGoal

function ModulateGoal:Create ( color, time, elapsed )
	local goal = {}
	setmetatable ( goal, ModulateGoalMT )

	goal.color = color
	goal.time = time or 0
	goal.elapsed = elapsed or 0

	return goal
end
function ModulateGoal:Destroy ( )
	self.color = nil
	self.time = nil
	self.elapsed = nil
end
function ModulateGoal:GetType ( )
    return 'modulate'
end
function ModulateGoal:Reset ( )
    self.elapsed = 0
end
function ModulateGoal:Process ( delta, owner )
	self.elapsed = self.elapsed + delta

	-- condition
	if self.elapsed >= self.time then
		owner.sprite.color = self.color
	    local used = delta - ( self.elapsed - self.time )
		self.elapsed = 0
		return GOAL_COMPLETED, used
	end

	-- output
	local c = owner.sprite.color
	local ratio = delta / ( self.time - ( self.elapsed - delta ) )
	c.red = c.red + ( self.color.red - c.red ) * ratio
	c.green = c.green + ( self.color.green - c.green ) * ratio
	c.blue = c.blue + ( self.color.blue - c.blue ) * ratio

	return GOAL_ACTIVE, delta
end
function ModulateGoal:CreateXML ( goal )
	local color = toColor ( goal.color )
	local time = tonumber ( goal.time )
	local elapsed = tonumber ( goal.elapsed )
	local g = ModulateGoal:Create ( color, time, elapsed )
	return g
end
function ModulateGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.color = Colortostring ( self.color )
	g.time = self.time
	g.elapsed = self.elapsed
	return g
end


