PlayMusicGoal = {}
PlayMusicGoalMT = { __index = PlayMusicGoal }

setmetatable ( PlayMusicGoal, { __index = Goal } )
goals['playMusic'] = PlayMusicGoal

function PlayMusicGoal:Create ( sound, loop, volume )
	local goal = {}
	setmetatable ( goal, PlayMusicGoalMT )

	goal.music = sound
	goal.loop = loop or false
	goal.volume = volume or 1

	return goal
end
function PlayMusicGoal:Destroy ( )
	self.music = nil
	self.loop = nil
	self.volume = nil
end
function PlayMusicGoal:GetType ( )
    return 'playMusic'
end
function PlayMusicGoal:Process ( delta, owner )
    owner.world.game:PlayMusic ( self.music, self.loop, self.volume )
	return GOAL_COMPLETED, 0
end
function PlayMusicGoal:CreateXML ( goal )
	local music = goal.music
	local loop = toboolean ( goal.loop )
	local volume = tonumber ( goal.volume )
    local g = PlayMusicGoal:Create ( music, loop, volume )
	return g
end
function PlayMusicGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.music = self.music
	g.loop = self.loop
	g.volume = self.volume
	return g
end
