PlaySoundGoal = {}
PlaySoundGoalMT = { __index = PlaySoundGoal }

setmetatable ( PlaySoundGoal, { __index = Goal } )
goals['playSound'] = PlaySoundGoal

function PlaySoundGoal:Create ( sound, pan, pitch, volume )
	local goal = {}
	setmetatable ( goal, PlaySoundGoalMT )

	goal.sound = sound
	goal.pan = pan or 0
	goal.pitch = pitch or 1
	goal.volume = volume or 1

	return goal
end
function PlaySoundGoal:Destroy ( )
	self.sound = nil
	self.pan = nil
	self.pitch = nil
	self.volume = nil
end
function PlaySoundGoal:GetType ( )
    return 'playSound'
end
function PlaySoundGoal:Process ( delta, owner )
    local sound = owner.world.game:FindSound ( self.sound )
    if sound then
        local player = owner.world.game.audio:play ( sound )
        player.pan = self.pan
        --p.pitch = self.pitch
        player.volume = self.volume
    else
        owner.world.game:Log ( "Could not play sound '%s'", self.sound )
    end
	return GOAL_COMPLETED, 0
end
function PlaySoundGoal:CreateXML ( goal )
	local sound = goal.sound
	local pan = tonumber ( goal.pan )
	local pitch = tonumber ( goal.pitch )
	local volume = tonumber ( goal.volume )
    local g = PlaySoundGoal:Create ( sound, pan, pitch, volume )
	return g
end
function PlaySoundGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.sound = self.sound
	g.pan = self.pan
	g.pitch = self.pitch
	g.volume = self.volume
	return g
end
