SetImageGoal = {}
SetImageGoalMT = { __index = SetImageGoal }

setmetatable ( SetImageGoal, { __index = Goal } )
goals['setImage'] = SetImageGoal

function SetImageGoal:Create ( image, x, y )
	local goal = {}
	setmetatable ( goal, SetImageGoalMT )

	goal.image = image
	goal.x = x or 0
	goal.y = y or 0

	return goal
end
function SetImageGoal:Destroy ( )
	self.image = nil
	self.x = nil
	self.y = nil
end
function SetImageGoal:GetType ( )
    return 'setImage'
end
function SetImageGoal:Process ( delta, owner )
    owner:SetImage ( self.image, self.x, self.y )
	return GOAL_COMPLETED, 0
end
function SetImageGoal:CreateXML ( goal )
	local image = goal.image
	local x = tonumber ( goal.x )
	local y = tonumber ( goal.y )
	local g = SetImageGoal:Create ( image, x, y )
	return g
end
function SetImageGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.image = self.image
	g.x = self.x
	g.y = self.y
	return g
end
