--
-- Animation goals
--
SetVisibleGoal = {}
SetVisibleGoalMT = { __index = SetVisibleGoal }

setmetatable ( SetVisibleGoal, { __index = Goal } )
goals['setVisible'] = SetVisibleGoal

function SetVisibleGoal:Create ( visible )
	local goal = {}
	setmetatable ( goal, SetVisibleGoalMT )

	goal.visible = visible

	return goal
end
function SetVisibleGoal:Destroy ( )
	self.visible = nil
end
function SetVisibleGoal:GetType ( )
    return 'setVisible'
end
function SetVisibleGoal:Process ( delta, owner )
	owner.sprite.visible = self.visible
	return GOAL_COMPLETED, 0
end
function SetVisibleGoal:CreateXML ( goal )
	local visible = toboolean ( goal.visible )
	local g = SetVisibleGoal:Create ( visible )
	return g
end
function SetVisibleGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.visible = self.visible
	return g
end

