require ( 'LuaXml' )

function toboolean ( arg, default )
	if arg == 'true' then
		return true
	elseif arg == 'false' then
		return false
	else
		return default
	end
end

function tob2Vec2 ( arg, default )
    if arg == nil then
        return default
    end

	local i = string.find ( arg, ',', 1, true )
	if i == nil then 
		return default
	end

	local x = tonumber ( string.sub ( arg, 1, i - 1 ) )
	local y = tonumber ( string.sub ( arg, i + 1, -1 ) )

	if x == nil or y == nil then
		return default
	end

	return b2Vec2 ( x, y )
end

function b2Vec2tostring ( pt )
    if pt == nil then
        return nil
    end
	return string.format ( "%f, %f", pt.x, pt.y )
end

function Colortostring ( arg )
	return string.format ( "%f, %f, %f", arg.red, arg.green, arg.blue )
end

function toColor ( arg, default )
	local i1 = string.find ( arg, ',', 1, true )
	if i1 == nil then
		return default
	end
	local i2 = string.find ( arg, ',', i1 + 1, true )
	if i2 == nil then
		return default
	end

	local r = tonumber ( string.sub ( arg, 1, i1 - 1 ) )
	local g = tonumber ( string.sub ( arg, i1 + 1, i2 - 1 ) )
	local b = tonumber ( string.sub ( arg, i2 + 1, - 1 ) )

	if r == nil or g == nil or b == nil then
		return default
	end

	return Color ( r, g, b )
end

function toStatus ( status )
    if status == 'inactive' then
        return GOAL_INACTIVE
    elseif status == 'active' then
        return GOAL_ACTIVE
    elseif status == 'failed' then
        return GOAL_FAILED
    elseif status == 'completed' then
        return GOAL_COMPLETED
    end
end

function StatustoString ( status )
    if status == GOAL_INACTIVE then
        return 'inactive'
    elseif status == GOAL_ACTIVE then
        return 'active'
    elseif status == GOAL_FAILED then
        return 'failed'
    elseif status == GOAL_COMPLETED then
        return 'completed'
    end
end

function toPath ( p )
    local path = {}
    for i = 1, #p, 1 do
        local vertex = p[i]
        -- unknown tag in path
        assert ( xml.tag ( vertex ) == 'Vertex', "Unknown tag in path" )

        local v = tob2Vec2 ( vertex[1] )
        table.insert ( path, v )
    end
    
    return path
end

function Pathtostring ( path )
	local p = xml.new ( "Path" )
    for i, v in pairs ( path ) do
        p:append ( "Vertex" )[1] = b2Vec2tostring ( v )			
    end
    return p
end