AimTorqueGoal = {}
AimTorqueGoalMT = { __index = AimTorqueGoal }

setmetatable ( AimTorqueGoal, { __index = Goal } )
goals['aimTorque'] = AimTorqueGoal

function AimTorqueGoal:Create ( target, lookAhead, turnRate, maxTorque, ease, target2 )
	local goal = {}
	setmetatable ( goal, AimTorqueGoalMT )

	goal.target = target
	goal.lookAhead = lookAhead
	goal.turnRate = turnRate
	goal.maxTorque = maxTorque
	goal.ease = ease
	goal.target2 = target2

	return goal
end
function AimTorqueGoal:Destroy ( )
    self.status = nil
	self.target = nil
	self.lookAhead = nil
	self.turnRate = nil
	self.maxTorque = nil
	self.ease = nil
	self.target2 = nil
end
function AimTorqueGoal:GetType ( )
    return 'aimTorque'
end
function AimTorqueGoal:Process ( delta, owner )
    local b1 = owner.world:FindBody ( self.target )
    local b2 = owner.world:FindBody ( self.target2 )
    if b1 == nil and b2 == nil then
        return GOAL_FAILED, 0
    end

    local target
	if b1 and b2 then
	    local d1 = owner.def.position:Distance ( b1.def.position )
	    local d2 = owner.def.position:Distance ( b2.def.position )
	    if d1 <= d2 then
	        target = b1
	    else
	        target = b2
	    end
	else
	    target = b1 or b2
	end

    -- factor in lookahead
    local lv = target.b2body:GetLinearVelocity ( )
    lv.x = lv.x * self.lookAhead
    lv.y = lv.y * self.lookAhead
    local position = b2Vec2 ( target.def.position.x + lv.x, target.def.position.y + lv.y )

	local used = owner:FaceTorque ( delta, position, self.turnRate, self.maxTorque, self.ease )

	if used < delta then
		return GOAL_COMPLETED, used
	end

	return GOAL_ACTIVE, delta
end
function AimTorqueGoal:CreateXML ( goal )
	local target = goal.target
	local lookAhead = tonumber ( goal.lookAhead )
	local turnRate = tonumber ( goal.turnRate )
	local maxTorque = tonumber ( goal.maxTorque )
	local ease = toboolean ( goal.ease )

	local g = AimTorqueGoal:Create ( target, lookAhead, angularVelocity, maxTorque, ease )
	return g
end
function AimTorqueGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.target = self.target
	g.lookAhead = self.lookAhead
	g.turnRate = self.turnRate
	g.maxTorque = self.maxTorque
	g.ease = self.ease
	return g
end

