AngledGoal = {}
AngledGoalMT = { __index = AngledGoal }

setmetatable ( AngledGoal, { __index = Goal } )
goals['angled'] = AngledGoal

function AngledGoal:Create ( target, min, max, target2 )
	local goal = {}
	setmetatable ( goal, AngledGoalMT )

    goal.target = target
	goal.min = min
	goal.max = max
    goal.target2 = target2

	return goal
end
function AngledGoal:Destroy ( )
    self.target = nil
	self.min = nil
	self.max = nil
	self.target2 = nil
end
function AngledGoal:GetType ( )
    return 'angled'
end
function AngledGoal:Process ( delta, owner )
    local b
	local b1 = owner.world:FindBody ( self.target )
	local b2 = owner.world:FindBody ( self.target2 )
	if b1 == nil and b2 == nil then
	    return GOAL_FAILED, 0
	end
	if b1 and b2 then
	    local d1 = owner.def.position:Distance ( b1.def.position )
	    local d2 = owner.def.position:Distance ( b2.def.position )
	    if d1 <= d2 then
	        b = b1
	    else
	        b = b2
	    end
	else
	    b = b1 or b2
	end
	
	local angle = owner.def.position:Direction ( b.def.position )
	if angle > self.min and angle < self.max then
	    return GOAL_COMPLETED, 0
	end

	return GOAL_FAILED, 0
end
function AngledGoal:CreateXML ( goal )
	local min = tonumber ( goal.min )
	local max = tonumber ( goal.max )
	local g = AngledGoal:Create ( goal.target, min, max )
	return g
end
function AngledGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.target = self.target
	g.min = self.min
	g.max = self.max
	return g
end






