function CreateBoss1 ( world, b )
    local x = b.def.position.x
    local y = b.def.position.y

    -- boss
    local v = { b2Vec2 ( -3.2, 2.5 ), b2Vec2 ( 3.2, 2.5 ), b2Vec2 ( 3.2, -1.1 ), b2Vec2 ( -3.2, -1.1 ) }
    b:CreateShapePolygon ( v, 0, 1, 0, true )
    b.sprite.depth = -0.1
    b:SetImage ( "Images/boss/boss.png" )
    
    b:SetPosition ( b2Vec2 ( x, y + 1.1 ) )

    local m = SequenceGoal:Create ( true )
    local ps = ProbabilitySelectorGoal:Create ( false )
    ps:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( x - 2 * 3.2 - 0.5, y + 1.1 ), 9 ) )
    ps:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( x, y + 1.1 ), 9 ) )
    ps:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( x + 2 * 3.2 + 0.5, y + 1.1 ), 9 ) )
    m:PushBack ( ps )
    m:PushBack ( SetImageGoal:Create ( "Images/boss/boss.png" ) )

    m:PushBack ( WaitGoal:Create ( 1 ) )

    local ps = ProbabilitySelectorGoal:Create ( false )
    ps:PushBack ( MessageSendGoal:Create ( "flamegun", "shoot" ) )
    ps:PushBack ( WaitGoal:Create ( 1 ) )
    ps:PushBack ( WaitGoal:Create ( 3 ) )
    ps:PushBack ( WaitGoal:Create ( 3 ) )
    m:PushBack ( ps )

    m:PushBack ( StopGoal:Create ( 1 ) )
    m:PushBack ( SetImageGoal:Create ( "Images/boss/boss2.png" ) )
    m:PushBack ( WaitGoal:Create ( 0.1 ) )

    m:PushBack ( StopGoal:Create ( 0.5 ) ) 

    local sn = world:GetAvailableName ( )
    local sp = b2Vec2 ( x, y )
    local sb = world:CreateBody ( sn, sp, 0, 0, 0, true, false, false, false )
    sb:CreateShapeCircle ( 3.2 * 6, b2Vec2 ( 0, 0 ), 0, 0, 0, true )
    sb.sprite:set_scale ( 0.1, 0.1 )

    local enter = SequenceGoal:Create ( false )
    enter:PushBack ( SenseGoal:Create ( sn, 'player', true, 'player2' ) )
    enter:PushBack ( WaitGoal:Create ( 1 ) )
    enter:PushBack ( PlayMusicGoal:Create ( "Music/07 - Heaviest Shit On The Earth.ogg", true, m_volume ) )
    enter:PushBack ( MessageSendGoal:Create ( 'turretGun', 'ouch' ) )
    enter:PushBack ( FailGoal:Create ( ) )
    
    local ouch = SequenceGoal:Create ( false )
    ouch:PushBack ( MessageReceiveGoal:Create ( 'ouch' ) )
    ouch:PushBack ( MessageReceiveGoal:Create ( 'ouch' ) )
    ouch:PushBack ( MessageReceiveGoal:Create ( 'ouch' ) )
    ouch:PushBack ( FailGoal:Create ( ) )
    
    local animate = SequenceGoal:Create ( true )
    animate:PushBack ( SetImageGoal:Create ( "Images/boss/boss.png" ) )
    animate:PushBack ( WaitGoal:Create ( 0.1 ) )
    animate:PushBack ( SetImageGoal:Create ( "Images/boss/boss2.png" ) )
    animate:PushBack ( WaitGoal:Create ( 0.1 ) )
    
    local live = ParallelGoal:Create ( false )
    live:PushBack ( m )
    live:PushBack ( ouch )
    live:PushBack ( animate )
    
    local die = SequenceGoal:Create ( false )
    die:PushBack ( SetImageGoal:Create ( "Images/boss/boss3.png" ) )
    for i = 1, 50, 1 do
        local rx = math.random ( -400, 400 ) / 100
        local ry = math.random ( -100, 300 ) / 100
        die:PushBack ( ExplodeGoal:Create ( b2Vec2 ( rx, ry ), 'medium', 0.7 ) )
        local r = math.random ( 3 )
        if r == 1 then
            local r = math.random ( 4 )
            die:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med" .. r .. ".wav" ) )
        end
        die:PushBack ( WaitGoal:Create ( 0.1 ) )
    end
    die:PushBack ( FunctionGoal:Create ( 'MissionOver' ) )
    --die:PushBack ( DestroyBodyGoal:Create ( 'turretGun' ) )
    --die:PushBack ( DestroyBodyGoal:Create ( 'chains' ) )
    --die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

    local g = PrioritySelectorGoal:Create ( false )
    g:PushBack ( enter )
    g:PushBack ( live )
    g:PushBack ( die )

    b:SetGoal ( g )


    function CreateCannon ( parent, localPosition )
        local n = world:GetAvailableName ( )
        local p = parent.b2body:GetWorldPoint ( localPosition )
        local body = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
        body.sprite:set_scale ( 0.1, 0.1 )

        body:CreateShapeCircle ( 0.7, b2Vec2 ( 0, 0 ), 0.25, 0, 0, true )
        body.sprite.depth = -0.2
        body:SetImage ( "Images/boss/gun1.png" )

        world:CreateJointRevolute ( parent, body, false, p )
        
        local attack = SequenceGoal:Create ( true )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun1.png" ) )
        attack:PushBack ( WaitGoal:Create ( 2 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun2.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun3.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun4.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun5.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.5 ) )
        attack:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( 0, 0 ), 'player', 3.2 * 15, 12, 'damage', 'touch' ) )
        attack:PushBack ( WaitGoal:Create ( 1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun5.png" ) )
        attack:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( 0, 0 ), 'player', 3.2 * 15, 12, 'damage', 'touch' ) )
        attack:PushBack ( WaitGoal:Create ( 1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun5.png" ) )
        attack:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( 0, 0 ), 'player', 3.2 * 15, 12, 'damage', 'touch' ) )
        attack:PushBack ( WaitGoal:Create ( 1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun4.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun3.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/gun2.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )

        local takeHit = SequenceGoal:Create ( false )
        for i = 1, 6, 1 do
            takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
            takeHit:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
            takeHit:PushBack ( SetImageGoal:Create ( 'Images/boss/gun1F.png' ) )
            takeHit:PushBack ( WaitGoal:Create ( 0.1 ) )
            takeHit:PushBack ( SetImageGoal:Create ( 'Images/boss/gun1.png' ) )
        end
        takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.75 ) )
        takeHit:PushBack ( MessageSendGoal:Create ( parent.name, 'ouch' ) )
        takeHit:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

        local pop = SequenceGoal:Create ( true )
        pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
        pop:PushBack ( CompleteGoal:Create ( ) )

        local p = ParallelGoal:Create ( true )
        p:PushBack ( attack )
        p:PushBack ( pop )
        p:PushBack ( takeHit )

        local g = SequenceGoal:Create ( false )
        g:PushBack ( MessageReceiveGoal:Create ( 'ouch' ) )
        g:PushBack ( p )
        
        body:SetGoal ( g )
        
        return body
    end
    c1 = CreateCannon ( b, b2Vec2 ( -1.6, 1.1 ) )
    c2 = CreateCannon ( b, b2Vec2 ( 0, 1.1 ) )
    c3 = CreateCannon ( b, b2Vec2 ( 1.6, 1.1 ) )


    function CreateBossTurret ( parent, localPosition )
        local n = 'turretGun'
        local p = parent.b2body:GetWorldPoint ( localPosition )
        local body = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
        body.sprite:set_scale ( 0.1, 0.1 )
        local v = { b2Vec2 ( -1.6, 0.7 ), b2Vec2 ( 1.6, 0.7 ), b2Vec2 ( 1.6, -0.9 ), b2Vec2 ( -1.6, -0.9 ) }
        body:CreateShapePolygon ( v, 0.25, 0, 0, true )
        body.sprite.depth = -0.05
        body:SetImage ( "Images/boss/t1.png" )

        world:CreateJointRevolute ( parent, body, false, p )
        
        local attack = SequenceGoal:Create ( true )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t3.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t2.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t1.png" ) )
        attack:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med3.wav" ) )
        attack:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( -3.2, 0 ), math.pi / 2, 3.2 * 8, 12, 'damage', 'touch' ) )
        attack:PushBack ( WaitGoal:Create ( 0.6 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t1.png" ) )
        attack:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med3.wav" ) )
        attack:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( -3.2, 0 ), math.pi / 2, 3.2 * 8, 12, 'damage', 'touch' ) )
        attack:PushBack ( WaitGoal:Create ( 0.6 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t1.png" ) )
        attack:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med3.wav" ) )
        attack:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( -3.2, 0 ), math.pi / 2, 3.2 * 8, 12, 'damage', 'touch' ) )
        attack:PushBack ( WaitGoal:Create ( 2 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t2.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t3.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t4.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t5.png" ) )
        attack:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med3.wav" ) )
        attack:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( 3.2, 0 ), -math.pi / 2, 3.2 * 8, 12, 'damage', 'touch' ) )
        attack:PushBack ( WaitGoal:Create ( 0.6 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t5.png" ) )
        attack:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med3.wav" ) )
        attack:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( 3.2, 0 ), -math.pi / 2, 3.2 * 8, 12, 'damage', 'touch' ) )
        attack:PushBack ( WaitGoal:Create ( 0.6 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t5.png" ) )
        attack:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med3.wav" ) )
        attack:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( 3.2, 0 ), -math.pi / 2, 3.2 * 8, 12, 'damage', 'touch' ) )

        attack:PushBack ( WaitGoal:Create ( 4 ) )
        attack:PushBack ( SetImageGoal:Create ( "Images/boss/t4.png" ) )
        attack:PushBack ( WaitGoal:Create ( 0.1 ) )

        local takeHit = SequenceGoal:Create ( false )
        for i = 1, 12, 1 do
            takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
            takeHit:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
            takeHit:PushBack ( SetImageGoal:Create ( 'Images/boss/t2F.png' ) )
            takeHit:PushBack ( WaitGoal:Create ( 0.1 ) )
            takeHit:PushBack ( SetImageGoal:Create ( 'Images/boss/t2.png' ) )
        end
        takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.75 ) )
        takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -1, 0 ), 'small', 0.8 ) )
        takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 1, 0 ), 'small', 0.6 ) )
        takeHit:PushBack ( SetImageGoal:Create ( 'Images/boss/t5dead.png' ) )
        takeHit:PushBack ( MessageSendGoal:Create ( c1.name, 'ouch' ) )
        takeHit:PushBack ( MessageSendGoal:Create ( c2.name, 'ouch' ) )
        takeHit:PushBack ( MessageSendGoal:Create ( c3.name, 'ouch' ) )
        takeHit:PushBack ( FailGoal:Create ( ) )
        --takeHit:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

        local pop = SequenceGoal:Create ( true )
        pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
        pop:PushBack ( CompleteGoal:Create ( ) )

        local p = ParallelGoal:Create ( true )
        p:PushBack ( attack )
        p:PushBack ( pop )
        p:PushBack ( takeHit )

        local life = SequenceGoal:Create ( false )
        life:PushBack ( MessageReceiveGoal:Create ( 'ouch' ) )
        life:PushBack ( p )

        body:SetGoal ( life )
        return body
    end
    CreateBossTurret ( b, b2Vec2 ( -0.7, 4.2 ) )

    -- flame gun
    local localPosition = b2Vec2 ( -0.1, -1 )
    local n = 'flamegun'
    local p = b.b2body:GetWorldPoint ( localPosition )
    local body = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
    body:CreateShapeCircle ( 1, b2Vec2 ( 0, 0 ), 0.5, 0, 0, true )
    body.sprite:set_scale ( 0.1, 0.1 )
    body.sprite.depth = -0.3
    body:SetImage ( nil )

    world:CreateJointRevolute ( b, body, false, p )

    local g = SequenceGoal:Create ( true )
    g:PushBack ( MessageReceiveGoal:Create ( "shoot" ) )
    g:PushBack ( SetImageGoal:Create ( "Images/boss/f1.png" ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( "Images/boss/f2.png" ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( "Images/boss/f3.png" ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( "Images/boss/f4.png" ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )

    local l = SequenceGoal:Create ( false )
    local a = math.pi / 2
    local d = 40
    local s = 20
    local lp = b2Vec2 ( -1.2, 0 )
    l:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_splash.wav" ) )

    l:PushBack ( ExplodeGoal:Create ( lp, 'smokey', 0.75 ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 3, s / 2, 'damage', 'touch' ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    l:PushBack ( WaitGoal:Create ( 0.2 ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 3, s / 2, 'damage', 'touch' ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    l:PushBack ( WaitGoal:Create ( 0.2 ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 3, s / 2, 'damage', 'touch' ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    l:PushBack ( WaitGoal:Create ( 0.2 ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    l:PushBack ( WaitGoal:Create ( 0.2 ) )
    l:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )

    local r = SequenceGoal:Create ( false )
    local a = -math.pi / 2
    local d = 40
    local s = 20
    local lp = b2Vec2 ( 1.2, 0 )
    r:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_splash.wav" ) )

    r:PushBack ( ExplodeGoal:Create ( lp, 'smokey', 0.75 ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 3, s / 2, 'damage', 'touch' ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    r:PushBack ( WaitGoal:Create ( 0.2 ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 3, s / 2, 'damage', 'touch' ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    r:PushBack ( WaitGoal:Create ( 0.2 ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 3, s / 2, 'damage', 'touch' ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    r:PushBack ( WaitGoal:Create ( 0.2 ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 4, s / 1.75, 'damage', 'touch' ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )
    r:PushBack ( WaitGoal:Create ( 0.2 ) )
    r:PushBack ( ShootGoal:Create ( 'fire', lp, a, d / 5, s / 1.5, 'damage', 'touch' ) )

    local s1 = SequenceGoal:Create ( false )
    s1:PushBack ( l )
    s1:PushBack ( r )
    local s2 = SequenceGoal:Create ( false )
    s2:PushBack ( r )
    s2:PushBack ( l )

    local ps2 = ProbabilitySelectorGoal:Create ( false )
    ps2:PushBack ( s1 )
    ps2:PushBack ( s2 )
    g:PushBack ( WaitGoal:Create ( 0.5 ) )
    g:PushBack ( ps2 )

    g:PushBack ( SetImageGoal:Create ( "Images/boss/f3.png" ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( "Images/boss/f2.png" ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( "Images/boss/f1.png" ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( nil ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )

    body:SetGoal ( g )
end