function CreateBox ( world, p )
    local n = world:GetAvailableName ( )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, false, true, false )
    b.sprite:set_scale ( 0.1, 0.1 )

    local v = { b2Vec2 ( -1.6, -1.4 ), b2Vec2 ( 1.9, -1.4 ), b2Vec2 ( 1.9, 1.4 ), b2Vec2 ( -1.6, 1.4 ) }
    b:CreateShapePolygon ( v, 10, 0.5, 0, false )
    b:SetImage ( "Images/tileset2/box.png" )

    local g = SequenceGoal:Create ( false )
    for i = 1, 3, 1 do
        g:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
        g:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset2/boxF.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.1 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset2/box.png' ) )
    end

    local e = math.random ( 4 )
    g:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med" .. e .. ".wav", 0, 1, 1 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.7 ) )
    g:PushBack ( WaitGoal:Create ( 0.02 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.2, -0.8 ), 'small', 0.6 ) )
    g:PushBack ( WaitGoal:Create ( 0.01 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.4, 1.2 ), 'small', 0.8 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.6, 0.2 ), 'small', 0.8 ) )
    g:PushBack ( DegenerateGoal:Create ( ) )

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local p = ParallelGoal:Create ( false )
    p:PushBack ( g )
    p:PushBack ( pop )
    b:SetGoal ( p )
    
    return b
end

function CreateTallBox ( world, p )
    local n = world:GetAvailableName ( )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, false, true, false )
    b.sprite:set_scale ( 0.1, 0.1 )

    local v = { b2Vec2 ( -1.6, -1.4 ), b2Vec2 ( 1.6, -1.4 ), b2Vec2 ( 1.6, 1.4 ), b2Vec2 ( -1.6, 1.4 ) }
    b:CreateShapePolygon ( v, 10, 0.5, 0, false )
    b:SetImage ( "Images/tileset2/boxtall.png" )

    local g = SequenceGoal:Create ( false )
    for i = 1, 3, 1 do
        g:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
        g:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset2/boxtallF.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.1 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset2/boxtall.png' ) )
    end

    local e = math.random ( 4 )
    g:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med" .. e .. ".wav", 0, 1, 1 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.7 ) )
    g:PushBack ( WaitGoal:Create ( 0.02 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.2, -0.8 ), 'small', 0.6 ) )
    g:PushBack ( WaitGoal:Create ( 0.01 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.4, 1.2 ), 'small', 0.8 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.6, 0.2 ), 'small', 0.8 ) )
    g:PushBack ( DegenerateGoal:Create ( ) )

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local p = ParallelGoal:Create ( false )
    p:PushBack ( g )
    p:PushBack ( pop )
    b:SetGoal ( p )
    
    return b
end

function CreateMiniBox ( world, p )
    local n = world:GetAvailableName ( )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, false, true, false )
    b.sprite:set_scale ( 0.1, 0.1 )

    local v = { b2Vec2 ( -1.2, -0.5 ), b2Vec2 ( 0.9, -0.5 ), b2Vec2 ( 0.9, 0.4 ), b2Vec2 ( -1.2, 0.4 ) }
    b:CreateShapePolygon ( v, 10, 0.5, 0, false )
    b:SetImage ( "Images/tileset2/boxmini.png" )

    local g = SequenceGoal:Create ( false )
    g:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    g:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    g:PushBack ( SetImageGoal:Create ( 'Images/tileset2/boxminiF.png' ) )
    g:PushBack ( WaitGoal:Create ( 0.1 ) )
    g:PushBack ( SetImageGoal:Create ( 'Images/tileset2/boxmini.png' ) )

    local e = math.random ( 4 )
    g:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med" .. e .. ".wav", 0, 1, 1 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.7 ) )
    g:PushBack ( WaitGoal:Create ( 0.02 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.2, -0.8 ), 'small', 0.6 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.6, 0.4 ), 'small', 0.6 ) )
    g:PushBack ( WaitGoal:Create ( 0.01 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.4, 1.2 ), 'small', 0.8 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.6, 0.2 ), 'small', 0.8 ) )
    g:PushBack ( DegenerateGoal:Create ( ) )

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local p = ParallelGoal:Create ( false )
    p:PushBack ( g )
    p:PushBack ( pop )
    b:SetGoal ( p )
    
    return b
end