
function CreateChoppa ( world, x, y )
    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( x, y )
    local body = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
    body.sprite:set_scale ( 0.1, 0.1 )

    body:CreateShapeCircle ( 1.6, b2Vec2 ( 0, 0 ), 0.25, 0, 0, true )
    body.sprite.depth = -5
    body:SetImage ( "Images/tileset/choppa1.png" )

    local animate = SequenceGoal:Create ( true )
    animate:PushBack ( WaitGoal:Create ( 0.25 ) )
    animate:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.2, -1.45 ), 'smokey', 0.75 ) )
    animate:PushBack ( WaitGoal:Create ( 0.25 ) )
    animate:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 2, -1.45 ), 'smokey', 0.75 ) )
--[[
    local rock = SequenceGoal:Create ( false )
    rock:PushBack ( RotateGoal:Create ( math.rad ( 30 ), 0.3 ) )
    rock:PushBack ( RotateGoal:Create ( 0, 0.3 ) )
]]
    local left = SequenceGoal:Create ( false )
    left:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa1.png" ) )
    left:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( -3.2 * 2, 0 ), 4 ) )

    local up = SequenceGoal:Create ( false )
    up:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( 0, -0.8 ), math.pi / 2, 3.2 * 8, 12 ), 'damage', 'touch' )
    up:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa2.png" ) )
    up:PushBack ( StopGoal:Create ( 0.2 ) )
    up:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa3.png" ) )
    up:PushBack ( StopGoal:Create ( 0.2 ) )
    up:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 0, 3.2 * 0.5 ), 4 ) )
    up:PushBack ( StopGoal:Create ( 0.2 ) )
    up:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa2.png" ) )

    local down = SequenceGoal:Create ( false )
    down:PushBack ( ShootGoal:Create ( 'homingMissle', b2Vec2 ( 0, -0.8 ), math.pi / 2, 3.2 * 8, 12 ), 'damage', 'touch' )
    down:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa2.png" ) )
    down:PushBack ( StopGoal:Create ( 0.2 ) )
    down:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa3.png" ) )
    down:PushBack ( StopGoal:Create ( 0.2 ) )
    down:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 0, -3.2 * 0.5 ), 2 ) )
    down:PushBack ( StopGoal:Create ( 0.2 ) )
    down:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa2.png" ) )

    local move = ProbabilitySelectorGoal:Create ( true )
    move:PushBack ( left )
    move:PushBack ( up )
    move:PushBack ( down )
    --move:PushBack ( rock )
    
    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local explode = SequenceGoal:Create ( false )
    explode:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )    
    explode:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    explode:PushBack ( SetImageGoal:Create ( "Images/tileset/choppaF.png" ) )
    explode:PushBack ( WaitGoal:Create ( 0.1 ) )
    explode:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa2.png" ) )
    explode:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    explode:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    explode:PushBack ( SetImageGoal:Create ( "Images/tileset/choppaF.png" ) )
    explode:PushBack ( WaitGoal:Create ( 0.1 ) )
    explode:PushBack ( SetImageGoal:Create ( "Images/tileset/choppa2.png" ) )
    explode:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    explode:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )

    explode:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_nasty.wav", 0, 1, 1 ) )

    explode:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 1, -0.9 ), 'small', 0.75 ) )
    explode:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -1.5, 0.7 ), 'small', 1 ) )
    explode:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.75, -0.5 ), 'small', 0.8 ) )
    explode:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.5 ) )

    explode:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

    local p = ParallelGoal:Create ( true )
    p:PushBack ( animate )
    --p:PushBack ( rock )
    p:PushBack ( move )
    p:PushBack ( pop )
    p:PushBack ( explode )
    body:SetGoal ( p )
end

