ExplodeGoal = {}
ExplodeGoalMT = { __index = ExplodeGoal }

setmetatable ( ExplodeGoal, { __index = Goal } )
goals['explode'] = ExplodeGoal

function ExplodeGoal:Create ( localPosition, type, time, msg )
	local goal = {}
	setmetatable ( goal, ExplodeGoalMT )

	goal.localPosition = localPosition
	goal.type = type
	goal.time = time
	goal.msg = msg

	return goal
end
function ExplodeGoal:Destroy ( )
	self.localPosition = nil
	self.type = nil
	self.time = nil
	self.msg = nil
end
function ExplodeGoal:GetType ( )
    return 'explode'
end
function ExplodeGoal:Process ( delta, owner )
	local worldPosition = owner.b2body:GetWorldPoint ( self.localPosition )
	local name = owner.world:GetAvailableName ( )

	local explosion = Explosion:Create ( owner.world, name, worldPosition, self.type, self.time, self.msg )

	return GOAL_COMPLETED, 0
end
function ExplodeGoal:CreateXML ( goal )
	local localPosition = tob2Vec2 ( goal.localPosition )
	local type = goal.type
	local time = tonumber ( goal.time )
	local g = ExplodeGoal:Create ( localPosition, type, time )
	return g
end
function ExplodeGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.localPosition = b2Vec2tostring ( self.localPosition )
	g.time = self.time
	return g
end






