Explosion = {}
ExplosionMT = { __index = Explosion }

function Explosion:Create ( world, name, position, type, time, msg )

	local a = math.rad ( math.random ( 4 ) * 90 )
    local body = world:CreateBody ( name, position, a, 0, 0, false, false, false, false )

	body.sprite:set_scale ( 0.1, 0.1 )
	body.sprite.depth = -4

if type == 'bullet' then
    local live = SequenceGoal:Create ( false )
    live:PushBack ( SetImageGoal:Create ( 'Images/explosion/bullet1.png' ) )
    live:PushBack ( WaitGoal:Create ( 0.05 ) )
    live:PushBack ( SetImageGoal:Create ( 'Images/explosion/bullet2.png' ) )
    live:PushBack ( WaitGoal:Create ( 0.05 ) )
    live:PushBack ( SetImageGoal:Create ( 'Images/explosion/bullet3.png' ) )
    live:PushBack ( WaitGoal:Create ( 0.05 ) )
    live:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

	body:SetGoal ( live )
elseif type == 'small' then
local d = time / 9
    local live = SequenceGoal:Create ( false )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small1.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small2.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small3.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small4.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small5.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small6.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small7.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small8.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/small9.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

	body:SetGoal ( live )
elseif type == 'medium' then

local shape = body:CreateShapeCircle ( 1, b2Vec2 ( 0, 0 ), 0.0001, 0, 0, true )

local d = time / 8
    local live = SequenceGoal:Create ( false )
    live:PushBack ( MessageSendGoal:Create ( 'contacts', msg ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/medium1.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/medium2.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( MessageSendGoal:Create ( 'contacts', msg ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/medium3.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/medium4.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( MessageSendGoal:Create ( 'contacts', msg ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/medium5.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/medium6.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( MessageSendGoal:Create ( 'contacts', msg ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/medium7.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/medium8.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( MessageSendGoal:Create ( 'contacts', msg ) )
    live:PushBack ( SetImageGoal:Create ( nil ) )
    live:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

    local p = ParallelGoal:Create ( true )
    p:PushBack ( StopGoal:Create ( time ) )
    p:PushBack ( live )
    
	body:SetGoal ( p )
elseif type == 'smokey' then
local d = time / 9
    local live = SequenceGoal:Create ( false )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey1.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey2.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey3.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey4.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey5.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey6.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey7.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey8.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/smokey9.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

	body:SetGoal ( live )
elseif type == 'spark' then
local d = time / 8
    local live = SequenceGoal:Create ( false )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/spark1.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/spark2.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/spark3.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/spark4.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/spark5.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/spark6.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/spark7.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( SetImageGoal:Create ( "Images/explosion/spark8.png" ) )
    live:PushBack ( WaitGoal:Create ( d ) )
    live:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

	body:SetGoal ( live )
else
    assert ( false )
end


	return body
end










