function CreateSoldier ( world, x, y )
    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( x, y )
    local body = world:CreateBody ( n, p, 0, 3, 0, true, true, false, false )
	local v = {}
	v[1] = b2Vec2 ( -0.5, 0.3 )
	v[2] = b2Vec2 ( 0, 1.2 )
	v[3] = b2Vec2 ( 0.5, 0.3 )
	v[4] = b2Vec2 ( 0.2, -1.4 )
	v[5] = b2Vec2 ( -0.2, -1.4 )
	local shape = body:CreateShapePolygon ( v, 50, 0.5, 0, false )
	body:CreateShapeCircle ( 0.005, b2Vec2 ( 0.2, -1.4 ), 1, 0.5, 0, false )
	body:CreateShapeCircle ( 0.005, b2Vec2 ( -0.2, -1.4 ), 1, 0.5, 0, false )
 
    local mass = b2MassData ( )
    mass.mass = 80
    mass.center = b2Vec2 ( 0, 0 )
    body.b2body:SetMass ( mass )
    

--	shape:SetFilter ( 1, 0x0004, 65535 )
    body.sprite:set_scale ( 0.1, 0.1 )
    body.sprite.depth = -1
    body:SetImage ( "Images/soldier/stand1.png" )
body.sprite:set_scale ( -0.1, 0.1 )

    local d = 30
    local s = 10
    
    local sl = math.pi * 2 / 8 / 2

    local left = SequenceGoal:Create ( true )
    left:PushBack ( AngledGoal:Create ( 'player', -math.pi / 2 - sl, -math.pi / 2 + sl, 'player2' ) )
    left:PushBack ( SetImageGoal:Create ( "Images/soldier/stand3.png" ) )
    left:PushBack ( WaitGoal:Create ( 0.6 ) )
    left:PushBack ( SetImageGoal:Create ( "Images/soldier/stand2.png" ) )
    left:PushBack ( PlaySound2DGoal:Create ( 'Sounds/explode2.wav' ) )
    left:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -1.3, 0.85 ), math.pi / 2, d, s, 'damage', 'touch' ) )
    left:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -1.4, 0.85 ), 'spark', 0.3 ) )
    left:PushBack ( WaitGoal:Create ( 0.2 ) )
    left:PushBack ( SetImageGoal:Create ( "Images/soldier/stand1.png" ) )
    left:PushBack ( WaitGoal:Create ( 0.2 ) )

    local dl = SequenceGoal:Create ( true )
    dl:PushBack ( AngledGoal:Create ( 'player', -math.pi * 3 / 4 - sl, -math.pi * 3 / 4 + sl, 'player2' ) )
    dl:PushBack ( SetImageGoal:Create ( "Images/soldier/ddownstand3.png" ) )
    dl:PushBack ( WaitGoal:Create ( 0.2 ) )
    dl:PushBack ( SetImageGoal:Create ( "Images/soldier/ddownstand2.png" ) )
    dl:PushBack ( PlaySound2DGoal:Create ( 'Sounds/explode2.wav' ) )
    dl:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -1.3, -0.3 ), math.pi * 3 / 4, d, s, 'damage', 'touch' ) )
    dl:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -1.3, -0.3 ), 'spark', 0.3 ) )
    dl:PushBack ( WaitGoal:Create ( 0.2 ) )
    dl:PushBack ( SetImageGoal:Create ( "Images/soldier/ddownstand1.png" ) )
    dl:PushBack ( WaitGoal:Create ( 1.2 ) )

    local down = SequenceGoal:Create ( true )
    down:PushBack ( AngledGoal:Create ( 'player', -math.pi - sl, -math.pi + sl, 'player2' ) )
    down:PushBack ( SetImageGoal:Create ( "Images/soldier/downstand3.png" ) )
    down:PushBack ( WaitGoal:Create ( 0.2 ) )
    down:PushBack ( SetImageGoal:Create ( "Images/soldier/downstand2.png" ) )
    down:PushBack ( PlaySound2DGoal:Create ( 'Sounds/explode2.wav' ) )
    down:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -0.7, -0.9 ), math.pi, d, s, 'damage', 'touch' ) )
    down:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.7, -0.9 ), 'spark', 0.3 ) )
    down:PushBack ( WaitGoal:Create ( 0.2 ) )
    down:PushBack ( SetImageGoal:Create ( "Images/soldier/downstand1.png" ) )
    down:PushBack ( WaitGoal:Create ( 1.2 ) )

    local ul = SequenceGoal:Create ( true )
    ul:PushBack ( AngledGoal:Create ( 'player', -math.pi * 1 / 4 - sl, -math.pi * 1 / 4 + sl, 'player2' ) )
    ul:PushBack ( SetImageGoal:Create ( "Images/soldier/dupstand3.png" ) )
    ul:PushBack ( WaitGoal:Create ( 0.2 ) )
    ul:PushBack ( SetImageGoal:Create ( "Images/soldier/dupstand2.png" ) )
    ul:PushBack ( PlaySound2DGoal:Create ( 'Sounds/explode2.wav' ) )
    ul:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -1.1, 1.95 ), math.pi * 1 / 4, d, s, 'damage', 'touch' ) )
    ul:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -1.1, 1.95 ), 'spark', 0.3 ) )
    ul:PushBack ( WaitGoal:Create ( 0.2 ) )
    ul:PushBack ( SetImageGoal:Create ( "Images/soldier/dupstand1.png" ) )
    ul:PushBack ( WaitGoal:Create ( 1.2 ) )

    local up = SequenceGoal:Create ( true )
    up:PushBack ( AngledGoal:Create ( 'player', -sl, sl, 'player2' ) )
    up:PushBack ( SetImageGoal:Create ( "Images/soldier/upstand3.png" ) )
    up:PushBack ( WaitGoal:Create ( 0.2 ) )
    up:PushBack ( SetImageGoal:Create ( "Images/soldier/upstand2.png" ) )
    up:PushBack ( PlaySound2DGoal:Create ( 'Sounds/explode2.wav' ) )
    up:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( 0, 2.2 ), 0, d, s, 'damage', 'touch' ) )
    up:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 2.2 ), 'spark', 0.3 ) )
    up:PushBack ( WaitGoal:Create ( 0.2 ) )
    up:PushBack ( SetImageGoal:Create ( "Images/soldier/upstand1.png" ) )
    up:PushBack ( WaitGoal:Create ( 1.2 ) )

    local w = SequenceGoal:Create ( false )
    w:PushBack ( WaitGoal:Create ( 0.5 ) )
    w:PushBack ( FailGoal:Create ( ) )

    local ps = PrioritySelectorGoal:Create ( true )
    ps:PushBack ( left )
    ps:PushBack ( dl )
    ps:PushBack ( down )
    ps:PushBack ( ul )
    ps:PushBack ( up )
    ps:PushBack ( w )

    local attack = SequenceGoal:Create ( true )
    attack:PushBack ( RangeGoal:Create ( 'player', 3.2 * 7, 'player2' ) )
    attack:PushBack ( ps )

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local takeHit = SequenceGoal:Create ( false )
    for i = 1, 1, 1 do
        takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
        takeHit:PushBack ( SetImageGoal:Create ( "Images/soldier/stand1F.png" ) )
        takeHit:PushBack ( WaitGoal:Create ( 0.1 ) )
        takeHit:PushBack ( SetImageGoal:Create ( "Images/soldier/stand1.png" ) )
    end
    takeHit:PushBack ( FailGoal:Create ( ) )

    local live = ParallelGoal:Create ( false )
    live:PushBack ( attack )
    live:PushBack ( pop )
    live:PushBack ( takeHit )

    local die = SequenceGoal:Create ( false )
    die:PushBack ( ShootGoal:Create ( 'powerup', b2Vec2 ( 1, -0.4 ), 0, 0, 0, 'random', 0 ) )

    die:PushBack ( DestroyAllShapesGoal:Create ( ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die1.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die2.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die3.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die4.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die5.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die6.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die7.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die8.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.5 ) )
    die:PushBack ( FadeGoal:Create ( 0, 0.5 ) )
    die:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
die:PushBack ( FailGoal:Create ( ) )

    local g = PrioritySelectorGoal:Create ( false )
    g:PushBack ( live )
    g:PushBack ( die )

    body:SetGoal ( g )
    --body:SetGoal ( FootSoldierGoal:Create ( ) )

	return body
end



function CreateSquatSoldier ( world, p )
    local n = world:GetAvailableName ( )
    local body = world:CreateBody ( n, p, 0, 3, 0, true, true, false, false )
	local v = {}
	v[1] = b2Vec2 ( -0.5, 0 )
	v[2] = b2Vec2 ( 0, 0.4 )
	v[3] = b2Vec2 ( 0.5, 0 )
	v[4] = b2Vec2 ( 0.2, -1.4 )
	v[5] = b2Vec2 ( -0.2, -1.4 )
	local shape = body:CreateShapePolygon ( v, 50, 0.5, 0, false )
	body:CreateShapeCircle ( 0.005, b2Vec2 ( 0.2, -1.4 ), 1, 0.5, 0, false )
	body:CreateShapeCircle ( 0.005, b2Vec2 ( -0.2, -1.4 ), 1, 0.5, 0, false )

    local mass = b2MassData ( )
    mass.mass = 80
    mass.center = b2Vec2 ( 0, 0 )
    body.b2body:SetMass ( mass )

    body.sprite:set_scale ( 0.1, 0.1 )
    body.sprite.depth = -1
    body:SetImage ( "Images/soldier/stand1.png" )
body.sprite:set_scale ( -0.1, 0.1 )

    local d = 30
    local s = 10
    
    local sl = math.pi * 2 / 8 / 2

    local left = SequenceGoal:Create ( true )

    left:PushBack ( SetImageGoal:Create ( "Images/soldier/squat3.png" ) )
    left:PushBack ( WaitGoal:Create ( 0.6 ) )
    left:PushBack ( SetImageGoal:Create ( "Images/soldier/squat2.png" ) )
    left:PushBack ( PlaySound2DGoal:Create ( 'Sounds/explode2.wav' ) )
    left:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( -1.3, 0.2 ), math.pi / 2, d, s, 'damage', 'touch' ) )
    left:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -1.3, 0.2 ), 'spark', 0.3 ) )
    left:PushBack ( WaitGoal:Create ( 0.2 ) )
    left:PushBack ( SetImageGoal:Create ( "Images/soldier/squat1.png" ) )
    left:PushBack ( WaitGoal:Create ( 0.2 ) )

    local attack = SequenceGoal:Create ( true )
    attack:PushBack ( RangeGoal:Create ( 'player', 3.2 * 7, 'player2' ) )
    attack:PushBack ( left )
    
    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local takeHit = SequenceGoal:Create ( false )
    for i = 1, 1, 1 do
        takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
        takeHit:PushBack ( SetImageGoal:Create ( "Images/soldier/squat3F.png" ) )
        takeHit:PushBack ( WaitGoal:Create ( 0.1 ) )
        takeHit:PushBack ( SetImageGoal:Create ( "Images/soldier/squat3.png" ) )
    end
    takeHit:PushBack ( FailGoal:Create ( ) )

    local live = ParallelGoal:Create ( false )
    live:PushBack ( attack )
    live:PushBack ( pop )
    live:PushBack ( takeHit )
    
    local die = SequenceGoal:Create ( false )
    die:PushBack ( ShootGoal:Create ( 'powerup', b2Vec2 ( 1, -0.4 ), 0, 0, 0, 'random', 0 ) )
    die:PushBack ( DestroyAllShapesGoal:Create ( ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die1.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die2.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die3.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die4.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die5.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die6.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die7.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die8.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.5 ) )
    die:PushBack ( FadeGoal:Create ( 0, 0.5 ) )
    die:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
die:PushBack ( FailGoal:Create ( ) )

    local g = PrioritySelectorGoal:Create ( false )
    g:PushBack ( live )
    g:PushBack ( die )

    body:SetGoal ( g )

	return body
end
