HomingMissle = {}
HomingMissleMT = { __index = HomingMissle }

function HomingMissle:Create ( world, name, position, angle, distance, speed )
    local body = world:CreateBody ( name, position, angle, 0, 0, false, false, false, false )
	local shape = body:CreateShapeCircle ( 0.3, b2Vec2 ( 0, 0 ), 1, 0.5, 0.5, true )
	--shape:SetFilter ( 2, 0x0008, 65535 )

	body:SetImage ( "Images/explosion/missle.png" )
	body.sprite:set_scale ( 0.1, 0.1 )
	body.sprite.depth = -5

	local lv = b2Vec2 ( 0, speed )
	lv:SetAngle ( angle )
	body.b2body:SetLinearVelocity ( lv )

    local time = SequenceGoal:Create ( false )
    --time:PushBack ( ScaleGoal:Create ( 1, 0.25 ) )
    --time:PushBack ( WaitGoal:Create ( distance / speed - 0.5 ) )
    time:PushBack ( WaitGoal:Create ( distance / speed ) )
    time:PushBack ( FailGoal:Create ( ) )
    local attack = ParallelGoal:Create ( true )
    attack:PushBack ( SenseGoal:Create ( 'self', 'player', true, 'player2' ) )
    attack:PushBack ( AimTorqueGoal:Create ( 'player', 0, 1, 20, true, 'player2' ) )
    attack:PushBack ( MoveForceGoal:Create ( 'self', b2Vec2 ( 0, 0.8 ), speed, 80, false ) )
    local smoke = SequenceGoal:Create ( true )
    smoke:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, -0.8 ), 'smokey', 0.5 ) )
    smoke:PushBack ( WaitGoal:Create ( 0.1 ) )
    local timeAttack = ParallelGoal:Create ( false )
    timeAttack:PushBack ( time )
    timeAttack:PushBack ( attack )
    timeAttack:PushBack ( smoke )
    local die = SequenceGoal:Create ( false )
    die:PushBack ( FadeGoal:Create ( 0, 0.25 ) )
    die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
die:PushBack ( FailGoal:Create ( ) )
    local live = PrioritySelectorGoal:Create ( false )
    live:PushBack ( timeAttack )
    live:PushBack ( die )
    local hit = SequenceGoal:Create ( true )
    hit:PushBack ( MessageSendGoal:Create ( "contacts", "damage" ) )
    hit:PushBack ( CompleteGoal:Create ( ) )
    local takeHit = SequenceGoal:Create ( false )
    takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.75 ) )
    takeHit:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
takeHit:PushBack ( FailGoal:Create ( ) )
    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )
	local goal = ParallelGoal:Create ( false )
    goal:PushBack ( hit )
	goal:PushBack ( live )
	goal:PushBack ( pop )
	goal:PushBack ( takeHit )

	body:SetGoal ( goal )

	return body
end



Missle = {}
MissleMT = { __index = Missle }

function Missle:Create ( world, name, position, angle, distance, speed, msg )
    local body = world:CreateBody ( name, position, angle, 0, 0, false, false, false, false )
	local shape = body:CreateShapeCircle ( 0.3, b2Vec2 ( 0, 0 ), 1, 0.5, 0.5, true )
	--shape:SetFilter ( 2, 0x0008, 65535 )

	body:SetImage ( "Images/explosion/missle.png" )
	body.sprite:set_scale ( 0.1, 0.1 )
	body.sprite.depth = -5

	local lv = b2Vec2 ( 0, speed )
	lv:SetAngle ( angle )
	body.b2body:SetLinearVelocity ( lv )


    local hit = SequenceGoal:Create ( true )
    hit:PushBack ( MessageSendGoal:Create ( "contacts", msg ) )
    hit:PushBack ( CompleteGoal:Create ( ) )
    local takeHit = SequenceGoal:Create ( false )
    takeHit:PushBack ( MessageReceiveGoal:Create ( 'damage' ) )
    takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.6 ) )
    takeHit:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
takeHit:PushBack ( FailGoal:Create ( ) )
    local pop = SequenceGoal:Create ( false )
    pop:PushBack ( MessageReceiveGoal:Create ( 'pop' ) )
    pop:PushBack ( WaitGoal:Create ( 0.3 ) )
    pop:PushBack ( MessageReceiveGoal:Create ( 'pop' ) )
    pop:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'bullet', 0.5 ) )
    pop:PushBack ( PlaySound2DGoal:Create ( 'Sounds/shoot.wav', 0, 1, 1 ) )
    pop:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
pop:PushBack ( FailGoal:Create ( ) )
    local smoke = SequenceGoal:Create ( true )
    smoke:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, -0.8 ), 'smokey', 0.5 ) )
    smoke:PushBack ( WaitGoal:Create ( 0.1 ) )

    local attack = ParallelGoal:Create ( true )
    attack:PushBack ( MoveForceGoal:Create ( 'self', b2Vec2 ( 0, 100 ), speed, 80, false ) )
    attack:PushBack ( smoke )
    attack:PushBack ( hit )
    attack:PushBack ( takeHit )
    attack:PushBack ( pop )

    local fadeOut = SequenceGoal:Create ( false )
    fadeOut:PushBack ( WaitGoal:Create ( distance / speed ) )
    fadeOut:PushBack ( FadeGoal:Create ( 0, 0.25 ) )
    fadeOut:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
fadeOut:PushBack ( FailGoal:Create ( ) )
    local live = ParallelGoal:Create ( false )
    live:PushBack ( attack )
    live:PushBack ( fadeOut )

	body:SetGoal ( live )

	return body
end
