
function CreateLaser ( world, x, y, range, dx )
    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( x, y )
    local laser = world:CreateBody ( n, p, 0, 0, 0, true, false, false, false )
    laser.sprite:set_scale ( 0.1, 0.1 )

    local beams = {}
    local last = laser
    for i = 1, range, 1 do
        local bn = world:GetAvailableName ( )
        table.insert ( beams, bn )
        local b = world:CreateBody ( bn, b2Vec2 ( p.x, p.y - 3.2 * i ), 0, 0, 0, true, false, false, false )
        local v = { b2Vec2 ( -0.5, -1.6 ), b2Vec2 ( -0.4, -1.6 ), b2Vec2 ( -0.4, 1.6 ), b2Vec2 ( -0.5, 1.6 ) }
        --local v = { b2Vec2 ( -0.75, -1.6 ), b2Vec2 ( -0, -1.6 ), b2Vec2 ( -0, 1.6 ), b2Vec2 ( -0.75, 1.6 ) }
        b:CreateShapePolygon ( v, 0.01, 0, 0, true )
        b.sprite:set_scale ( 0.1, 0.1 )
        b.sprite.depth = -1
        b:Paint ( )
        
        world:CreateJointRevolute ( last, b, true, b2Vec2 ( p.x, p.y - 3.2 * i ), b2Vec2 ( last.def.position.x, last.def.position.y ) )
        last = b
        
        local powerUp = SequenceGoal:Create ( false )
        powerUp:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser1.png' ) )
        powerUp:PushBack ( WaitGoal:Create ( 0.075 ) )
        powerUp:PushBack ( PlaySound2DGoal:Create ( 'Sounds/explode_phaser.wav', 0, 1, 0.5 ) )

        powerUp:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        powerUp:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser2.png' ) )
        powerUp:PushBack ( WaitGoal:Create ( 0.075 ) )
        powerUp:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        powerUp:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser3.png' ) )
        powerUp:PushBack ( WaitGoal:Create ( 0.075 ) )
        powerUp:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        powerUp:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser3.png' ) )
        powerUp:PushBack ( WaitGoal:Create ( 0.075 ) )
        powerUp:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        powerUp:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser4.png' ) )

        --[[
        local power = SequenceGoal:Create ( false )
        if i == range then
            for i = 1, 10, 1 do
                power:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.4, -1.6 ), 'smokey', 0.5 ) )
                power:PushBack ( WaitGoal:Create ( 5 / 10 ) )
            end
        else
            power:PushBack ( WaitGoal:Create ( 5 ) )
        end
        ]]
            
        --local power = ParallelGoal:Create ( false )
        --power:PushBack ( WaitGoal:Create ( 5 ) )
         
        local powerDown = SequenceGoal:Create ( false )
        powerDown:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser5.png' ) )
        powerDown:PushBack ( WaitGoal:Create ( 0.05 ) )
        powerDown:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        powerDown:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser6.png' ) )
        powerDown:PushBack ( WaitGoal:Create ( 0.05 ) )
        powerDown:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        powerDown:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser7.png' ) )
        powerDown:PushBack ( WaitGoal:Create ( 0.05 ) )
        powerDown:PushBack ( SetImageGoal:Create ( 'Images/tileset/laser8.png' ) )
        powerDown:PushBack ( WaitGoal:Create ( 0.05 ) )
        powerDown:PushBack ( SetImageGoal:Create ( nil ) )

        local live = SequenceGoal:Create ( true )
        live:PushBack ( powerUp )
        live:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        live:PushBack ( powerDown )
        live:PushBack ( WaitGoal:Create ( 0.5 ) )


        local die = SequenceGoal:Create ( false )
        die:PushBack ( MessageReceiveGoal:Create ( 'die' ) )
        die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
die:PushBack ( FailGoal:Create ( ) )
        local parallel = ParallelGoal:Create ( false )
        parallel:PushBack ( live )
        parallel:PushBack ( die )
        b:SetGoal ( parallel )
    end


    local v = { b2Vec2 ( -1.6, -1 ), b2Vec2 ( 1.6, -1 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
    laser:CreateShapePolygon ( v, 0, 0, 0, false )
    laser:SetImage ( "Images/tileset/platformLaser.png" )
    laser.sprite.depth = -1

    local g = SequenceGoal:Create ( false )
    for i = 1, 5, 1 do
        g:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
        g:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/platformLaserF.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.1 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/platformLaser.png' ) )
    end
    for i, v in pairs ( beams ) do
        g:PushBack ( MessageSendGoal:Create ( v, 'die' ) )
    end
    local e = math.random ( 4 )
    g:PushBack ( PlaySoundGoal:Create ( "Sounds/explode_med" .. e .. ".wav", 0, 1, 1 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.1, 0.8 ), 'small', 0.8 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.7 ) )
    g:PushBack ( WaitGoal:Create ( 0.02 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.2, -0.8 ), 'small', 0.6 ) )
    g:PushBack ( WaitGoal:Create ( 0.01 ) )
    g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.4, 0.6 ), 'small', 0.8 ) )
    g:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
    --g:PushBack ( DegenerateGoal:Create ( ) )
g:PushBack ( FailGoal:Create ( ) )
    --g:PushBack ( SetImageGoal:Create ( "Images/tileset/platformDoorB.png" ) )

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local parallel = ParallelGoal:Create ( false )
    parallel:PushBack ( g )
    parallel:PushBack ( pop )

    if dx then
        local move = SequenceGoal:Create ( true )
        move:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( p.x + dx, p.y ), 4 ) )
        move:PushBack ( WaitGoal:Create ( 1 ) )
        move:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( p.x, p.y ), 4 ) )
        move:PushBack ( WaitGoal:Create ( 1 ) )
        parallel:PushBack ( move )
    end
    
    laser:SetGoal ( parallel )
end