

function CreateMine ( world, x, y, dx )
    local position = b2Vec2 ( x, y )
    local angle = 0
    
    local sensorName = world:GetAvailableName ( )
    local sensor = world:CreateBody ( sensorName, b2Vec2 ( position ), 0, 0, 0, false, false, true, false )
    local v = { b2Vec2 ( -1.6, -0.6 ), b2Vec2 ( dx + 1.6, -0.6 ), b2Vec2 ( dx + 1.6, -0.8 ), b2Vec2 ( -1.6, -0.8 ) }
    sensor:CreateShapePolygon ( v, 0, 0, 0, true )
sensor.sprite:set_scale ( 0.1, 0.1 )

	local bodyName = world:GetAvailableName ( )
	local body = world:CreateBody ( bodyName, b2Vec2 ( position ), 0, 0, 0, false, false, true, false )
	body:CreateShapeCircle ( 0.7, b2Vec2 ( 0, -0.8 ), 0, 0, 0, true )
body:SetImage ( "Images/mine/mine1.png" )
body.sprite:set_scale ( 0.1, 0.1 )
    
    local rotate = SequenceGoal:Create ( true )
    rotate:PushBack ( SetImageGoal:Create ( 'Images/mine/mine1.png' ) )
    rotate:PushBack ( WaitGoal:Create ( 0.075 ) )
    rotate:PushBack ( SetImageGoal:Create ( 'Images/mine/mine2.png' ) )
    rotate:PushBack ( WaitGoal:Create ( 0.075 ) )
    rotate:PushBack ( SetImageGoal:Create ( 'Images/mine/mine3.png' ) )
    rotate:PushBack ( WaitGoal:Create ( 0.075 ) )
    rotate:PushBack ( SetImageGoal:Create ( 'Images/mine/mine4.png' ) )
    rotate:PushBack ( WaitGoal:Create ( 0.075 ) )
    rotate:PushBack ( SetImageGoal:Create ( 'Images/mine/mine5.png' ) )

    local senseFail = SequenceGoal:Create ( false )
    senseFail:PushBack ( SenseGoal:Create ( sensorName, 'player', true, 'player2' ) )
    senseFail:PushBack ( PlaySound2DGoal:Create ( "Sounds/slide.wav" ) )
    senseFail:PushBack ( FailGoal:Create ( ) )

    local moveLeftFail = SequenceGoal:Create ( )
    moveLeftFail:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( x - 1.6, y ), 3 ) )
    moveLeftFail:PushBack ( FailGoal:Create ( ) )

    local moveLeftSlow = ParallelGoal:Create ( )
    moveLeftSlow:PushBack ( moveLeftFail )
    moveLeftSlow:PushBack ( senseFail )

    local moveLeft = PrioritySelectorGoal:Create ( false )
    moveLeft:PushBack ( moveLeftSlow )
    moveLeft:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( x - 1.6, y ), 12 ) )

    local senseFail = SequenceGoal:Create ( false )
    senseFail:PushBack ( SenseGoal:Create ( sensorName, 'player', true, 'player2' ) )
    senseFail:PushBack ( PlaySound2DGoal:Create ( "Sounds/slide.wav" ) )
    senseFail:PushBack ( FailGoal:Create ( ) )

    local moveRightFail = SequenceGoal:Create ( )
    moveRightFail:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( x + 1.6 + dx, y ), 3 ) )
    moveRightFail:PushBack ( FailGoal:Create ( ) )

    local moveRightSlow = ParallelGoal:Create ( false )
    moveRightSlow:PushBack ( moveRightFail )
    moveRightSlow:PushBack ( senseFail )

    local moveRight = PrioritySelectorGoal:Create ( false )
    moveRight:PushBack ( moveRightSlow )
    moveRight:PushBack ( MoveGoal:Create ( 'world', b2Vec2 ( x + 1.6 + dx, y ), 12 ) )

    local move = SequenceGoal:Create ( true )
    move:PushBack ( moveLeft )
    move:PushBack ( moveRight )
    
    local hit = SequenceGoal:Create ( true )
    hit:PushBack ( MessageSendGoal:Create ( "contacts", "damage" ) )
    hit:PushBack ( CompleteGoal:Create ( ) )

    local takeHit = SequenceGoal:Create ( false )
    takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    takeHit:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    takeHit:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_granade.wav" ) )
    --takeHit:PushBack ( SetImageGoal:Create ( 'Images/mine/mine1F.png' ) )
    --takeHit:PushBack ( WaitGoal:Create ( 0.1 ) )
    --takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    --takeHit:PushBack ( SetImageGoal:Create ( 'Images/mine/mine1F.png' ) )
    takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, -0.6 ), 'medium', 0.75 ) )

    takeHit:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )
    
    local p = ParallelGoal:Create ( true )
    p:PushBack ( rotate )
    p:PushBack ( move )
    p:PushBack ( hit )
    p:PushBack ( pop )
    p:PushBack ( takeHit )
    
    body:SetGoal ( p )
end