Player = {}
PlayerMT = { __index = Player }

function Player:Create ( world, name, position, device, device2 )
    local body = world:CreateBody ( name, position, 0, 2.5, 0, true, true, false, false )

    body.passThrough = true
    --body.agent = true
    body.sprite:set_scale ( 0.1, 0.1 )
    body.sprite.depth = -1
    body:SetImage ( "Images/commando/stand.png" )

    body:Paint ( )

    body:SetGoal ( PlayerInputGoal:Create ( device, device2 ) )
    body.goal:Stand ( body )

	return body
end




PlayerInputGoal = {}
PlayerInputGoalMT = { __index = PlayerInputGoal }

setmetatable ( PlayerInputGoal, { __index = Goal } )
goals['playerInput'] = PlayerInputGoal

function PlayerInputGoal:Create ( device, device2 )
	local goal = {}
	setmetatable ( goal, PlayerInputGoalMT )

    goal.device = device
    goal.device2 = device2
    goal.action = 'falling'
    goal.actionTime = 0
	goal.floor = false
	goal.ceil = false
	goal.weapon = 'gun'
	goal.shotInterval = 0.3

	return goal
end
function PlayerInputGoal:Destroy ( )
    self.device = nil
    self.device2 = nil
    self.action = nil
    self.actionTime = nil
	self.floor = nil
	self.ceil = nil
	self.weapon = nil
end
function PlayerInputGoal:GetType ( )
    return 'playerInput'
end
function PlayerInputGoal:Process ( delta, owner )
    if self.action == 'dead' then
        return GOAL_ACTIVE, delta
    end
    for i, v in pairs ( owner.contacts ) do
        local body = owner.world:FindBody ( i )
        if body then
            body:Message ( 'touch' )
        end
    end

    local pt = owner.def.position

    local floor = false -- both feet are touching the floor
    local ceil = false -- head is touching the ceiling

    local bl = b2Vec2 ( pt.x - 0.2, pt.y - 1.4 - 0.1 )
    local br = b2Vec2 ( pt.x + 0.2, pt.y - 1.4 - 0.1 )
    --local bt = b2Vec2 ( pt.x, pt.y - 1.45 )
    local top = b2Vec2 ( pt.x, pt.y + 1.3 )
    for i, v in pairs ( owner.contacts ) do
        local b = owner.world:FindBody ( i )
        if b and #b.shapes > 0 and b.shapes[1].def.isSensor == false then
            if b:TestPoint ( bl ) == true then floor = true end
            if b:TestPoint ( br ) == true then floor = true end
            --if b:TestPoint ( bt ) == true then floor = true end
            if b:TestPoint ( top ) == true then ceil = true end
        end
    end
    
    if self.floor == false and floor == true then
        local s = owner.world.game:FindSound ( "Sounds/land1.wav" )
        local p = audio:play ( s )
        p.volume = 1

        self:Message ( owner, 'land' )
    elseif self.floor == true and floor == false then
        self:Message ( owner, 'slip' )
    elseif self.ceil == false and ceil == true then
        self:Message ( owner, 'hit' )
    end
    self.floor = floor
    self.ceil = ceil
    if floor == true then
    end

    local left = false
    local right = false
    local down = false
    local up = false
    local jump = false
    local shoot = false

    if self.action ~= 'dying' then
        local d = self.device
        left = d.down ( BUTTON_LEFT ) == true
        right = d.down ( BUTTON_RIGHT ) == true
        down = d.down ( BUTTON_DOWN ) == true
        up = d.down ( BUTTON_UP ) == true
        jump = d.down ( BUTTON_1 ) == true
        shoot = d.down ( BUTTON_2 ) == true
        
        d = self.device2
        if d then
            left = left or d.down ( BUTTON_LEFT ) == true
            right = right or d.down ( BUTTON_RIGHT ) == true
            down = down or d.down ( BUTTON_DOWN ) == true
            up = up or d.down ( BUTTON_UP ) == true
            jump = jump or d.down ( BUTTON_1 ) == true
            shoot = shoot or d.down ( BUTTON_2 ) == true
        end
    end

    if left == true then
        owner.sprite.scalex = -0.1
        if floor == false then
            owner:ApplyForce ( b2Vec2 ( -2500, 0 ) )
        else
            owner:ApplyForce ( b2Vec2 ( -5000, 0 ) )
        end
        self:Message ( owner, 'walk' )
    elseif right == true then
        owner.sprite.scalex = 0.1
        if floor == false then
            owner:ApplyForce ( b2Vec2 ( 2500, 0 ) )
        else
            owner:ApplyForce ( b2Vec2 ( 5000, 0 ) )
        end
        self:Message ( owner, 'walk' )
    elseif down == true then
        self:Message ( owner, 'kneel' )
    else
        self:Message ( owner, 'stand' )
    end

    if jump == true then
        self:Message ( owner, 'jump' )
    else
        self:Message ( owner, 'fall' )
    end
    

    if shoot == false then
        self.lastShot = nil
    elseif shoot == true then
        if self.lastShot == nil then
            self.lastShot = 0
        end
        if self.lastShot == 0 then
            local d = 40
            local s = 25
            --local n = owner.world:GetAvailableName ( )
            local p = b2Vec2 ( )
            local a = 0
            if self.action == 'kneeling' then
                if owner.sprite.scalex < 0 then
                    p:Set ( pt.x - 1.1, pt.y - 0.2 )
                    a = math.pi / 2
                else
                    p:Set ( pt.x + 1.1, pt.y - 0.2 )
                    a = -math.pi / 2
                end
            elseif owner.sprite.scalex < 0 then
                if up == true and left == false and right == false then
                    p:Set ( pt.x, pt.y + 2.2 )
                    a = 0
                 elseif up == true then
                    p:Set ( pt.x - 1, pt.y + 1.5 )
                    a = math.pi / 4
                elseif down == true and left == false and right == false then
                    p:Set ( pt.x - 0.4, pt.y - 0.5 )
                    a = math.pi
                elseif down == true then
                    p:Set ( pt.x - 1, pt.y - 0.5 )
                    a = math.pi * ( 3 / 4 )
                else
                    p:Set ( pt.x - 0.8, pt.y + 0.5 )
                    a = math.pi / 2
                end
            else
                if up == true and left == false and right == false then
                    p:Set ( pt.x, pt.y + 2.2 )
                    a = 0
                elseif up == true then
                    p:Set ( pt.x + 1, pt.y + 1.5 )
                    a = -math.pi / 4
                elseif down == true and left == false and right == false then
                    p:Set ( pt.x + 0.4, pt.y - 0.5 )
                    a = math.pi
                elseif down == true then
                    p:Set ( pt.x + 1, pt.y - 0.5 )
                    a = -math.pi * ( 3 / 4 )
                else
                    p:Set ( pt.x + 0.8, pt.y + 0.5 )
                    a = -math.pi / 2
                end
            end
            if self.weapon == 'flamethrower' then
                Shoot ( )
                Bullet:Create ( owner.world, 'fire', p, a, d / 4, s / 1.75, 'shot', 'pop' )
                Bullet:Create ( owner.world, 'fire', p, a, d / 3, s / 2, 'shot', 'pop' )
                Bullet:Create ( owner.world, 'fire', b2Vec2 ( p.x, p.y ), a, d / 5, s / 1.5, 'shot', 'pop' )
                self.shotInterval = 0.3
                --local s = owner.world.game:FindSound ( "Sounds/explode_splash.wav" )
                --local p = audio:play ( s )
                --p.volume = 1
            elseif self.weapon == 'gun' then
                Shoot ( )
                Bullet:Create ( owner.world, 'bullet', p, a, d, s, 'shot', 'pop' )
                local r = math.random ( 7 )
                if r > 2 then r = 1 end
                local s = owner.world.game:FindSound ( "Sounds/shoot" .. r .. ".wav" )
                local p = audio:play ( s )
                p.volume = 1
                self.shotInterval = 0.3
            elseif self.weapon == 'missle' then
                Shoot ( )
                d = d / 2
                s = s / 1.5
                local n = owner.world:GetAvailableName ( )
                Missle:Create ( owner.world, n, p, a, d, s, 'shot' )
                self.shotInterval = 0.6
            elseif self.weapon == 'granade' then
                Shoot ( )
                d = d / 1.5
                local n = owner.world:GetAvailableName ( )
                Granade:Create ( owner.world, n, p, a, d, s, 'shot', 'pop' )
                local r = math.random ( 7 )
                if r > 2 then r = 1 end
                local s = owner.world.game:FindSound ( "Sounds/granade" .. r .. ".wav" )
                local p = audio:play ( s )
                p.volume = 1
                self.shotInterval = 0.6
            else
                assert ( false )
            end
        end
        
        self.lastShot = self.lastShot + delta
        if self.lastShot > self.shotInterval then
            self.lastShot = 0
        end
    end

    self.actionTime = self.actionTime + delta

    local c = "Images/commando/"
    if owner.name == 'player2' then
        c = "Images/commando2/"
    end
    if self.action == 'falling' then
        local f = math.ceil ( self.actionTime / 0.1 ) + 4
        if f > 7 then f = 7 end --- totototodo
        --if f > 4 then f = 5 end --- totototodo
        owner:SetImage ( c .. "legs_jump" .. f .. ".png" )
    elseif self.action == 'dying' then
        local f = math.ceil ( self.actionTime / 0.1 )
        if f > 7 then f = 7 end --- totototodo
        owner:SetImage ( c .. "legs_die" .. f .. ".png" )
        if self.actionTime > 1 then
            owner:Message ( 'die' )
            return GOAL_ACTIVE, delta
        end
    elseif self.action == 'kneeling' then
        owner:SetImage ( c .. "legs_kneel.png" )
    elseif self.action == 'standing' then
        owner:SetImage ( c .. "legs.png" )
    elseif self.action == 'walking' then
        self.actionTime = self.actionTime % ( 0.08 * 8 )
        local f = math.ceil ( self.actionTime / 0.08 )
        if up == true then
            owner:SetImage ( c .. "legs_run" .. f .. ".png" )
        elseif down == true then
            owner:SetImage ( c .. "legs_run" .. f .. ".png" )
        else
            owner:SetImage ( c .. "legs_run" .. f .. ".png" )
        end
    elseif self.action == 'jumping' then
        if self.actionTime <= 0.42 then
            local f = math.ceil ( self.actionTime / 0.1 ) + 1
            if f > 3 then f = 3 end --- totototodo
            owner:SetImage ( c .. "legs_jump" .. f .. ".png" )

            local r = 1 - self.actionTime / 0.42
            owner:ApplyImpulse ( b2Vec2 ( 0, 380 * r ) )
        else
            self:Message ( owner, 'fall' )
        end
    end
    
    if shoot == false then
        local i
        if self.action == 'walking' then
            local f = math.ceil ( self.actionTime / 0.1 )
            if f > 8 then f = 8 end --- totototodo
            if up == true then
                i = owner.world.game:FindImage ( "Images/commando/torsoDU_run" .. f .. ".png" )
            elseif down == true then
                i = owner.world.game:FindImage ( "Images/commando/torsoDD_run" .. f .. ".png" )
            else
                i = owner.world.game:FindImage ( "Images/commando/torso_run" .. f .. ".png" )
            end
        elseif self.action == 'dying' then
            local f = math.ceil ( self.actionTime / 0.1 )
            if f > 7 then f = 7 end --- totototodo
            i = owner.world.game:FindImage ( "Images/commando/torso_die" .. f .. ".png" )
        elseif self.action == 'kneeling' then
            i = owner.world.game:FindImage ( "Images/commando/torso_kneel.png" )
        else
            if up == true and left == false and right == false then
                i = owner.world.game:FindImage ( "Images/commando/torsoU.png" )
            elseif up == true then
                i = owner.world.game:FindImage ( "Images/commando/torsoDU.png" )
            elseif down == true and left == false and right == false then
                i = owner.world.game:FindImage ( "Images/commando/torsoD.png" )
            elseif down == true then
                i = owner.world.game:FindImage ( "Images/commando/torsoDD.png" )
            else
                i = owner.world.game:FindImage ( "Images/commando/torso1.png" )
            end
        end
        owner.sprite.canvas:set_source_image ( i )
        owner.sprite.canvas:paint ( )
    else
        local i
        local f = math.ceil ( self.lastShot / 0.04 )
        if f == 0 then f = 1 end
        if up == true and left == false and right == false then
            if f > 3 then
                i = owner.world.game:FindImage ( "Images/commando/torsoU.png" )
            else
                i = owner.world.game:FindImage ( "Images/commando/torsoU_shoot" .. f .. ".png" )
            end
        elseif up == true then
            if f > 3 then
                i = owner.world.game:FindImage ( "Images/commando/torsoDU.png" )
            else
                i = owner.world.game:FindImage ( "Images/commando/torsoDU_shoot" .. f .. ".png" )
            end
        elseif down == true and left == false and right == false then
            if self.action == 'kneeling' then
                if f > 3 then
                    i = owner.world.game:FindImage ( "Images/commando/torso_kneel.png" )
                else
                    i = owner.world.game:FindImage ( "Images/commando/torso_kneel_shoot" .. f .. ".png" )
                end
            else
                if f > 3 then
                    i = owner.world.game:FindImage ( "Images/commando/torsoD.png" )
                else
                    i = owner.world.game:FindImage ( "Images/commando/torsoD_shoot" .. f .. ".png" )
                end
            end
        elseif down == true then
            if f > 3 then
                i = owner.world.game:FindImage ( "Images/commando/torsoDD.png" )
            else
                i = owner.world.game:FindImage ( "Images/commando/torsoDD_shoot" .. f .. ".png" )
            end
        else
            if f > 3 then
                i = owner.world.game:FindImage ( "Images/commando/torso1.png" )
            else
                i = owner.world.game:FindImage ( "Images/commando/torso_shoot" .. f .. ".png" )
            end
        end
        
        owner.sprite.canvas:set_source_image ( i )
        owner.sprite.canvas:paint ( )
    end
local cmin = owner.world.game.camera.x - 6 * 3.2
local cmax = owner.world.game.camera.x + 6 * 3.2
if owner.def.position.x < cmin then
    owner:SetPositionXY ( cmin, owner.def.position.y )
end
if owner.def.position.x > cmax then
    owner:SetPositionXY ( cmax, owner.def.position.y )
end

	return GOAL_ACTIVE, delta
end
function PlayerInputGoal:Stand ( owner )
    owner:DestroyAllShapes ( )
    local v = {}
    v[1] = b2Vec2 ( -0.5, 0.4 )
    v[2] = b2Vec2 ( 0, 1.3 )
    v[3] = b2Vec2 ( 0.5, 0.4 )
    v[4] = b2Vec2 ( 0.2, -1.4 )
    v[5] = b2Vec2 ( -0.2, -1.4 )
    -- torso
    local shape1 = owner:CreateShapePolygon ( v, 1, 0, 0, false )
    -- the 'feet' of the player
    local shape2 = owner:CreateShapeCircle ( 0.005, b2Vec2 ( 0.2, -1.4 ), 1, 0.5, 0, false )
    local shape3 = owner:CreateShapeCircle ( 0.005, b2Vec2 ( -0.2, -1.4 ), 1, 0.5, 0, false )

    local mass = b2MassData ( )
    mass.mass = 80
    mass.center = b2Vec2 ( 0, 0 )
    owner.b2body:SetMass ( mass )
--[[
    shape1:SetFilter ( 1, 0x0004, 65535 )
    shape2:SetFilter ( 1, 0x0004, 65535 )
    shape3:SetFilter ( 1, 0x0004, 65535 )
    ]]
end
function PlayerInputGoal:Kneel ( owner )
    owner:DestroyAllShapes ( )
    local v = {}
    v[1] = b2Vec2 ( -0.5, 0.1 )
    v[2] = b2Vec2 ( 0, 0.6 )
    v[3] = b2Vec2 ( 0.5, 0.1 )
    v[4] = b2Vec2 ( 0.2, -1.4 )
    v[5] = b2Vec2 ( -0.2, -1.4 )
    local shape = owner:CreateShapePolygon ( v, 1, 0, 0, false )
    owner:CreateShapeCircle ( 0.005, b2Vec2 ( 0.2, -1.4 ), 1, 0.5, 0, false )
    owner:CreateShapeCircle ( 0.005, b2Vec2 ( -0.2, -1.4 ), 1, 0.5, 0, false )
    
    local mass = b2MassData ( )
    mass.mass = 80
    mass.center = b2Vec2 ( 0, 0 )
    owner.b2body:SetMass ( mass )
end
function PlayerInputGoal:Message ( owner, type, key )
    if self.action == 'dead' then
        return true
    end
    if type == 'die' then
        self.action = 'dead'
        self.actionTime = 0
        GameOver ( )
        return true
    end
    if self.action == 'dying' then
        return true
    end
    if type == 'flame' then
        self.weapon = 'flamethrower'
    elseif type == 'missle' then
        self.weapon = 'missle'
    elseif type == 'granade' then
        self.weapon = 'granade'
    elseif type == 'gun' then
        self.weapon = 'gun'
    end
    if type == 'damage' then
        self.action = 'dying'
        self.actionTime = 0
        if owner.sprite.scalex < 0 then
            owner:ApplyImpulse ( b2Vec2 ( 500, 1500 ) )
        else
            owner:ApplyImpulse ( b2Vec2 ( -500, 1500 ) )
        end
        local s = owner.world.game:FindSound ( "Sounds/announcer/ugh.wav" )
        owner.world.game.audio:play ( s )
        owner:DestroyAllShapes ( )
        return
    end
    if self.action == 'falling' then
        if type == 'land' then
            self.action = 'standing'
            self.actionTime = 0
            return true
        end
    elseif self.action == 'kneeling' then
        if type == 'walk' then
            self:Stand ( owner )
            self.action = 'walking'
            self.actionTime = 0
            return true
        elseif type == 'stand' then
            self:Stand ( owner )
            self.action = 'standing'
            self.actionTime = 0
            return true
        elseif type == 'slip' then
            self.action = 'falling'
            self.actionTime = 0
            return true
        end
    elseif self.action == 'standing' or self.action == 'walking' then
        if type == 'walk' and self.action == 'standing' then
            self.action = 'walking'
            self.actionTime = 0
            return true
        elseif type == 'stand' and self.action == 'walking' then
            self:Stand ( owner )

            self.action = 'standing'
            self.actionTime = 0
            return true
        elseif type == 'kneel' then
            self:Kneel ( owner )
        
            self.action = 'kneeling'
            self.actionTime = 0
            return true
        elseif type == 'slip' then
            self.action = 'falling'
            self.actionTime = 0
            return true
        elseif type == 'jump' then
            self.action = 'jumping'
            self.actionTime = 0
            return true
        end
    elseif self.action == 'jumping' then
        if type == 'hit' or type == 'fall' then
            self.action = 'falling'
            self.actionTime = 0
            return true
        end
    end
	return false
end
function PlayerInputGoal:CreateXML ( goal )
	local g = PlayerInputGoal:Create ( )
	return g
end
function PlayerInputGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	return g
end


