PlaySound2DGoal = {}
PlaySound2DGoalMT = { __index = PlaySound2DGoal }

setmetatable ( PlaySound2DGoal, { __index = Goal } )
goals['playSound2D'] = PlaySound2DGoal

function PlaySound2DGoal:Create ( sound, pan, pitch, volume )
	local goal = {}
	setmetatable ( goal, PlaySound2DGoalMT )

	goal.sound = sound
	goal.pan = pan or 0
	goal.pitch = pitch or 1
	goal.volume = volume or 1

	return goal
end
function PlaySound2DGoal:Destroy ( )
	self.sound = nil
	self.pan = nil
	self.pitch = nil
	self.volume = nil
end
function PlaySound2DGoal:GetType ( )
    return 'playSound2D'
end
function PlaySound2DGoal:Process ( delta, owner )
    local sound = owner.world.game:FindSound ( self.sound )
    if sound then
        local player = owner.world.game.audio:play ( sound )
        local v = owner.def.position.x - owner.world.game.camera.x
        if v < 0 then
            v = math.max ( v, -3.2 * 20 ) / ( 3.2 * 20 )
        else
            v = math.min ( v, 3.2 * 20 ) / ( 3.2 * 20 )
        end
        player.pan = v
        --p.pitch = self.pitch
        player.volume = self.volume * ( 1 - math.abs ( v ) )
    else
        owner.world.game:Log ( "Could not play sound '%s'", self.sound )
    end
	return GOAL_COMPLETED, 0
end
function PlaySound2DGoal:CreateXML ( goal )
	local sound = goal.sound
	local pan = tonumber ( goal.pan )
	local pitch = tonumber ( goal.pitch )
	local volume = tonumber ( goal.volume )
    local g = PlaySound2DGoal:Create ( sound, pan, pitch, volume )
	return g
end
function PlaySound2DGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.sound = self.sound
	g.pan = self.pan
	g.pitch = self.pitch
	g.volume = self.volume
	return g
end
