

function CreatePowerUp ( world, x, y, type )
    local position = b2Vec2 ( x, y )
    local angle = 0

	local bodyName = world:GetAvailableName ( )
	local body = world:CreateBody ( bodyName, b2Vec2 ( position ), 0, 0, 0, true, false, true, false )
	body:CreateShapeCircle ( 0.7, b2Vec2 ( 0, 0 ), 0.5, 1, 0, false )
body.sprite:set_scale ( 0.1, 0.1 )
body.sprite.depth = -2
    body:ApplyImpulse ( b2Vec2 ( 0, 15 ) )

    if type == 'random' then
        local r = math.random ( 4 )
        if r == 1 then
            type = 'flame'
        elseif r == 2 then
            type = 'missle'
        elseif r == 3 then
            type = 'granade'
        elseif r == 4 then
            type = 'gun'
        end
    end
    local msg

    local s = SequenceGoal:Create ( true )
    if type == 'flame' then
        msg = 'flame'
        for i = 1, 7, 1 do
            s:PushBack ( SetImageGoal:Create ( "Images/powerups/f" .. i .. ".png" ) )
            s:PushBack ( WaitGoal:Create ( 0.1 ) )
        end
    elseif type == 'missle' then
        msg = 'missle'
        for i = 1, 7, 1 do
            s:PushBack ( SetImageGoal:Create ( "Images/powerups/r" .. i .. ".png" ) )
            s:PushBack ( WaitGoal:Create ( 0.1 ) )
        end
    elseif type == 'granade' then
        msg = 'granade'
        for i = 1, 7, 1 do
            s:PushBack ( SetImageGoal:Create ( "Images/powerups/g" .. i .. ".png" ) )
            s:PushBack ( WaitGoal:Create ( 0.1 ) )
        end
    elseif type == 'gun' then
        msg = 'gun'
        for i = 1, 7, 1 do
            s:PushBack ( SetImageGoal:Create ( "Images/powerups/m" .. i .. ".png" ) )
            s:PushBack ( WaitGoal:Create ( 0.1 ) )
        end
    end

    local pickup = SequenceGoal:Create ( false )
    pickup:PushBack ( MessageReceiveGoal:Create ( 'touch' ) )
    pickup:PushBack ( MessageSendGoal:Create ( 'contacts', msg ) )
    pickup:PushBack ( PlaySound2DGoal:Create ( 'Sounds/powerup.wav', 0, 1, 0.5 ) )

    if type == 'flame' then
        pickup:PushBack ( PlaySoundGoal:Create ( 'Sounds/announcer/flame.wav', 0, 1, 1 ) )
    elseif type == 'missle' then
        pickup:PushBack ( PlaySoundGoal:Create ( 'Sounds/announcer/rocketlauncher.wav', 0, 1, 1 ) )
    elseif type == 'granade' then
        pickup:PushBack ( PlaySoundGoal:Create ( 'Sounds/announcer/granades.wav', 0, 1, 1 ) )
    elseif type == 'gun' then
        pickup:PushBack ( PlaySoundGoal:Create ( 'Sounds/announcer/machinegun.wav', 0, 1, 1 ) )
    end 
    pickup:PushBack ( DestroyBodyGoal:Create ( 'self' ) )

    p = ParallelGoal:Create ( true )
    p:PushBack ( s )
    p:PushBack ( touch )
    p:PushBack ( pickup )
    body:SetGoal ( p )
end


