RangeGoal = {}
RangeGoalMT = { __index = RangeGoal }

setmetatable ( RangeGoal, { __index = Goal } )
goals['range'] = RangeGoal

function RangeGoal:Create ( target, radius, target2 )
	local goal = {}
	setmetatable ( goal, RangeGoalMT )

	goal.target = target
	goal.radius = radius
	goal.target2 = target2

	return goal
end
function RangeGoal:Destroy ( )
	self.target = nil
	self.radius = nil
	self.target2 = nil
end
function RangeGoal:GetType ( )
    return 'range'
end
function RangeGoal:Process ( delta, owner )
    local b
	local b1 = owner.world:FindBody ( self.target )
	local b2 = owner.world:FindBody ( self.target2 )
	if b1 == nil and b2 == nil then
	    return GOAL_FAILED, 0
	end
	local d
	if b1 and b2 then
	    local d1 = owner.def.position:Distance ( b1.def.position )
	    local d2 = owner.def.position:Distance ( b2.def.position )
	    if d1 <= d2 then
	        d = d1
	    else
	        d = d2
	    end
	else
	    b = b1 or b2
	    d = owner.def.position:Distance ( b.def.position )
	end

	if d <= self.radius then
    	return GOAL_COMPLETED, 0
	end

	return GOAL_ACTIVE, delta
end
function RangeGoal:CreateXML ( goal )
	local target = goal.target
	local radius = tonumber ( goal.radius )
	local g = RangeGoal:Create ( target, radius )
	return g
end
function RangeGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.target = self.target
	g.radius = self.radius
	return g
end

