function CreateRSoldier ( world, x, y, s )
    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( x, y )
    RunningFootSoldier:Create ( world, n, p, s )
end


RunningFootSoldier = {}
RunningFootSoldierMT = { __index = RunningFootSoldier }

function RunningFootSoldier:Create ( world, name, position, s )
    local body = world:CreateBody ( name, position, 0, 3, 0, true, true, false, false )
body.agent = true
	local v = {}
	v[1] = b2Vec2 ( -0.5, 0.3 )
	v[2] = b2Vec2 ( 0, 1.2 )
	v[3] = b2Vec2 ( 0.5, 0.3 )
	v[4] = b2Vec2 ( 0.2, -1.4 )
	v[5] = b2Vec2 ( -0.2, -1.4 )
	local shape = body:CreateShapePolygon ( v, 50, 0.5, 0, false )
    --shape:SetFilter ( -1, 0x0004, 65535 )
    
	local shape = body:CreateShapeCircle ( 0.005, b2Vec2 ( 0.2, -1.4 ), 1, 0.5, 0, false )
	--shape:SetFilter ( -1, 0x0004, 65535 )

	local shape = body:CreateShapeCircle ( 0.005, b2Vec2 ( -0.2, -1.4 ), 1, 0.5, 0, false )
	--shape:SetFilter ( -1, 0x0004, 65535 )

    local mass = b2MassData ( )
    mass.mass = 80
    mass.center = b2Vec2 ( 0, 0 )
    body.b2body:SetMass ( mass )

    body.sprite:set_scale ( 0.1, 0.1 )
    body.sprite.depth = -1
    body:SetImage ( "Images/soldier/stand1.png" )

    body:Paint ( )

local p = world:FindBody ( "player" )
if p.def.position.x > position.x then
    s = -s
    body.sprite:set_scale ( 0.1, 0.1 )
else
    body.sprite:set_scale ( -0.1, 0.1 )
end
    local left = SequenceGoal:Create ( true )
    for i = 1, 7, 1 do
        left:PushBack ( SetImageGoal:Create ( "Images/soldier/run" .. i .. ".png" ) )
        left:PushBack ( WaitGoal:Create ( 0.1 ) )
        left:PushBack ( ApplyImpulseGoal:Create ( b2Vec2 ( -s * 10, 0 ) ) )
    end

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local takeHit = SequenceGoal:Create ( false )
    for i = 1, 1, 1 do
        takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
        takeHit:PushBack ( SetImageGoal:Create ( "Images/soldier/stand1F.png" ) )
        takeHit:PushBack ( WaitGoal:Create ( 0.1 ) )
        takeHit:PushBack ( SetImageGoal:Create ( "Images/soldier/stand1.png" ) )
    end
    takeHit:PushBack ( FailGoal:Create ( ) )

    local live = ParallelGoal:Create ( false )
    live:PushBack ( left )
    live:PushBack ( pop )
    live:PushBack ( takeHit )

    local die = SequenceGoal:Create ( false )
    die:PushBack ( DestroyAllShapesGoal:Create ( ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die1.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die2.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die3.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die4.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die5.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die6.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die7.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.075 ) )
    die:PushBack ( SetImageGoal:Create ( "Images/soldier/die8.png" ) )
    die:PushBack ( WaitGoal:Create ( 0.5 ) )
    die:PushBack ( FadeGoal:Create ( 0, 0.5 ) )
    die:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    die:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
die:PushBack ( FailGoal:Create ( ) )
    local g = PrioritySelectorGoal:Create ( false )
    g:PushBack ( live )
    g:PushBack ( die )

    body:SetGoal ( g )


    --body:SetGoal ( RunningFootSoldierGoal:Create ( ) )

	return body
end


--[[

RunningFootSoldierGoal = {}
RunningFootSoldierGoalMT = { __index = RunningFootSoldierGoal }

setmetatable ( RunningFootSoldierGoal, { __index = Goal } )
goals['footSoldier'] = RunningFootSoldierGoal

function RunningFootSoldierGoal:Create ( )
	local goal = {}
	setmetatable ( goal, RunningFootSoldierGoalMT )

    goal.action = 'falling'
    goal.actionTime = 0
	goal.floor = false
	goal.ceil = false
	goal.lastShot = 0

	return goal
end
function RunningFootSoldierGoal:Destroy ( )
    self.action = nil
    self.actionTime = nil
	self.floor = nil
	self.ceil = nil
	self.lastShot = nil
end
function RunningFootSoldierGoal:GetType ( )
    return 'footSoldier'
end
function RunningFootSoldierGoal:Process ( delta, owner )
    local pt = owner.def.position
    
    local floor = false -- both feet are touching the floor
    local ceil = false -- head is touching the ceiling

    local bl = b2Vec2 ( pt.x - 0.2, pt.y - 1.4 - 0.1 )
    local br = b2Vec2 ( pt.x + 0.2, pt.y - 1.4 - 0.1 )
    local top = b2Vec2 ( pt.x, pt.y + 0.9 )
if owner.contacts then
    for i, v in pairs ( owner.contacts ) do
        local b = owner.world:FindBody ( i )
        if b then
            if b:TestPoint ( bl ) then floor = true end
            if b:TestPoint ( br ) then floor = true end
            if b:TestPoint ( top ) then ceil = true end
        end
    end
end

    if self.floor == false and floor == true then
        self:Message ( owner, 'land' )
    elseif self.floor == true and floor == false then
        self:Message ( owner, 'slip' )
    elseif self.ceil == false and ceil == true then
        self:Message ( owner, 'hit' )
    end
    self.floor = floor
    self.ceil = ceil

    local player = owner.world:FindBody ( "player" )
    local shotInterval = 1.25--0.3--
    
    if self.direction == nil then
        if player.def.position.x < owner.def.position.x then
            self.direction = 'left'
        else
            self.direction = 'right'
        end
    end

    if owner.def.position.x > game.camera.x + 3.2 * 15 or
    owner.def.position.x < game.camera.x - 3.2 * 15 then
        owner.world:DestroyBody ( owner )
        return GOAL_COMPLETED, 0
    end
 
    local left  --= -- ( player.def.position.x + 1 ) < owner.def.position.x
    local right --= -- ( player.def.position.x - 1 ) > owner.def.position.x
    if self.direction == 'left' then
        local qpt = b2Vec2 ( owner.def.position.x - 1.6, owner.def.position.y )
        local q = owner.world:QueryPoint ( qpt, 1 )
        if #q > 0 then
            self.direction = 'right'
            right = true
        else
            left = true
        end
    else
        local qpt = b2Vec2 ( owner.def.position.x + 1.6, owner.def.position.y )
        local q = owner.world:QueryPoint ( qpt, 1 )
        if #q > 0 then
            self.direction = 'left'
            left = true
        else
            right = true
        end
    end
    --local jump = keyboard:is_down ( KEY_Z ) == true
    local down = ( player.def.position.y + 1 ) < owner.def.position.y
    local up = ( player.def.position.y - 1 ) > owner.def.position.y
    local shoot = self.action == 'standing' and player.def.position:Distance ( owner.def.position ) < 3.2 * 10


    if self.action ~= 'dying' then
        if left == true then
            owner.sprite.scalex = -0.1
            if floor == false then
                owner:ApplyForce ( b2Vec2 ( -2000, 0 ) )
            else
                owner:ApplyForce ( b2Vec2 ( -4800, 0 ) )
            end
            self:Message ( owner, 'walk' )
        elseif right == true then
            owner.sprite.scalex = 0.1
            if floor == false then
                owner:ApplyForce ( b2Vec2 ( 2000, 0 ) )
            else
                owner:ApplyForce ( b2Vec2 ( 4800, 0 ) )
            end
            self:Message ( owner, 'walk' )
        elseif down == true then
            --self:Message ( owner, 'kneel' )
        else
            self:Message ( owner, 'stand' )
        end
    end
    
    if jump == true then
        self:Message ( owner, 'jump' )
    else
        self:Message ( owner, 'fall' )
    end
    
    self.lastShot = self.lastShot + delta
    if shoot == true and self.action ~= 'dying' then
        if self.lastShot > shotInterval then
            self.lastShot = self.lastShot % shotInterval
            
            local d = 30
            local s = 10
            --local n = owner.world:GetAvailableName ( )
            local p = b2Vec2 ( )
            local a = 0
            if self.action == 'kneeling' then
                if owner.sprite.scalex < 0 then
                    p.x = pt.x - 1.1
                    p.y = pt.y - 0.2
                    a = math.pi / 2
                else
                    p.x = pt.x + 1.1
                    p.y = pt.y - 0.2
                    a = -math.pi / 2
                end
            elseif owner.sprite.scalex < 0 then
                if up == true and left == false and right == false then
                    p.x = pt.x
                    p.y = pt.y + 2.2
                    a = 0
                elseif up == true then
                    p.x = pt.x - 1.1
                    p.y = pt.y + 1.95
                    a = math.pi / 4
                elseif down == true and left == false and right == false then
                    p.x = pt.x - 0.7
                    p.y = pt.y - 0.9
                    a = math.pi
                elseif down == true then
                    p.x = pt.x - 1.3
                    p.y = pt.y - 0.3
                    a = math.pi * ( 3 / 4 )
                 else
                    p.x = pt.x - 1.6
                    p.y = pt.y + 0.85
                    a = math.pi / 2
                end
            else
                if up == true and left == false and right == false then
                    p.x = pt.x
                    p.y = pt.y + 2.2
                    a = 0
                 elseif up == true then
                    p.x = pt.x + 1.1
                    p.y = pt.y + 1.95
                    a = -math.pi / 4
                elseif down == true and left == false and right == false then
                    p.x = pt.x + 0.7
                    p.y = pt.y - 0.9
                    a = math.pi
                elseif down == true then
                    p.x = pt.x + 1.3
                    p.y = pt.y - 0.3
                    a = -math.pi * ( 3 / 4 )
                else
                    p.x = pt.x + 1.6
                    p.y = pt.y + 0.85
                    a = -math.pi / 2
                end
            end
            Bullet:Create ( owner.world, 'bullet', p, a, d, s, 'damage', 'pop' )
            --HomingMissle:Create ( owner.world, n, p, a, d, s )
        end
    end

    self.actionTime = self.actionTime + delta

    if self.action == 'falling' then
        owner:SetImage ( "Images/soldier/fall.png" )
    elseif self.action == 'kneeling' then
        owner:SetImage ( "Images/commando/kneel.png" )
    elseif self.action == 'walking' then
        self.actionTime = self.actionTime % ( 0.10 * 7 )
        local f = math.ceil ( self.actionTime / 0.10 )
        owner:SetImage ( "Images/soldier/run" .. f .. ".png" )
    elseif self.action == 'standing' then
        if up == true and ( left == true or right == true ) then
            local f = math.ceil ( self.lastShot / ( 0.25 / 3 ) )
            if f == 0 then f = 1 end --- totototodo
            if f > 3 then f = 3 end --- totototodo
            owner:SetImage ( "Images/soldier/dupstand" .. f .. ".png" )
        elseif up == true then
            local f = math.ceil ( self.lastShot / ( 0.25 / 3 ) )
            if f == 0 then f = 1 end --- totototodo
            if f > 3 then f = 3 end --- totototodo
            owner:SetImage ( "Images/soldier/upstand" .. f .. ".png" )
        elseif down == true and ( left == true or right == true ) then
            local f = math.ceil ( self.lastShot / ( 0.25 / 3 ) )
            if f == 0 then f = 1 end --- totototodo
            if f > 3 then f = 3 end --- totototodo
            owner:SetImage ( "Images/soldier/ddownstand" .. f .. ".png" )
        elseif down == true then
            local f = math.ceil ( self.lastShot / ( 0.25 / 3 ) )
            if f == 0 then f = 1 end --- totototodo
            if f > 3 then f = 3 end --- totototodo
            owner:SetImage ( "Images/soldier/downstand" .. f .. ".png" )
        else
            local f = math.ceil ( self.lastShot / ( 0.25 / 3 ) )
            if f == 0 then f = 1 end --- totototodo
            if f > 3 then f = 3 end --- totototodo
            owner:SetImage ( "Images/soldier/stand" .. f .. ".png" )
        end
    elseif self.action == 'dying' then
        local f = math.ceil ( self.actionTime / 0.075 )
        if f == 0 then f = 1 end --- totototodo
        if f > 8 then f = 8 end --- totototodo
        owner:SetImage ( "Images/soldier/die" .. f .. ".png" )   
    elseif self.action == 'walking' then
        self.actionTime = self.actionTime % ( 0.10 * 8 )
        local f = math.ceil ( self.actionTime / 0.10 )
        if f == 0 then f = 1 end --- totototodo
        if up == true then
            owner:SetImage ( "Images/commando/uprun" .. f .. ".png" )
        elseif down == true then
            owner:SetImage ( "Images/commando/downrun" .. f .. ".png" )
        else
            owner:SetImage ( "Images/commando/run" .. f .. ".png" )
        end    
    elseif self.action == 'jumping' then
        if self.actionTime <= 0.6 then
            if up == true and left == false and right == false then
                owner:SetImage ( "Images/commando/upjump.png" )
            elseif up == true then
                owner:SetImage ( "Images/commando/dupjump.png" )
            elseif down == true and left == false and right == false then
                owner:SetImage ( "Images/commando/downjump.png" )
            elseif down == true then
                owner:SetImage ( "Images/commando/ddownjump.png" )
            else
                owner:SetImage ( "Images/commando/jump.png" )
            end
            local r = 1 - self.actionTime / 0.6
            owner:ApplyImpulse ( b2Vec2 ( 0, 200 * r ) )
        else
            self:Message ( owner, 'fall' )
        end
    end

	return GOAL_ACTIVE, delta
end
function RunningFootSoldierGoal:Stand ( owner )
    owner:DestroyAllShapes ( )
    local body = world:CreateBody ( name, position, angle, 2, 0, true, true, false, false )
	local v = {}
	v[1] = b2Vec2 ( -0.5, 0.3 )
	v[2] = b2Vec2 ( 0, 1.2 )
	v[3] = b2Vec2 ( 0.5, 0.3 )
	v[4] = b2Vec2 ( 0.2, -1.4 )
	v[5] = b2Vec2 ( -0.2, -1.4 )
	local shape = body:CreateShapePolygon ( v, 50, 0.5, 0, false )

	body:CreateShapeCircle ( 0.005, b2Vec2 ( 0.2, -1.4 ), 1, 0.5, 0, false )
	body:CreateShapeCircle ( 0.005, b2Vec2 ( -0.2, -1.4 ), 1, 0.5, 0, false )
    local mass = b2MassData ( )
    mass.mass = 80
    mass.center = b2Vec2 ( 0, 0 )
    body.b2body:SetMass ( mass )
end
function RunningFootSoldierGoal:Kneel ( owner )
    owner:DestroyAllShapes ( )
    local v = {}
    v[1] = b2Vec2 ( -0.5, 0.1 )
    v[2] = b2Vec2 ( 0, 0.6 )
    v[3] = b2Vec2 ( 0.5, 0.1 )
    v[4] = b2Vec2 ( 0.2, -1.4 )
    v[5] = b2Vec2 ( -0.2, -1.4 )
    local shape = owner:CreateShapePolygon ( v, 60, 0.5, 0, false )
    owner:CreateShapeCircle ( 0.005, b2Vec2 ( 0.2, -1.4 ), 1, 0.5, 0, false )
    owner:CreateShapeCircle ( 0.005, b2Vec2 ( -0.2, -1.4 ), 1, 0.5, 0, false )
    
    local mass = b2MassData ( )
    mass.mass = 80
    mass.center = b2Vec2 ( 0, 0 )
    owner.b2body:SetMass ( mass )
end
function RunningFootSoldierGoal:Die ( owner )
    owner:DestroyAllShapes ( )
    
    local mass = b2MassData ( )
    mass.mass = 0
    mass.center = b2Vec2 ( 0, 0 )
    owner.b2body:SetMass ( mass )
end
function RunningFootSoldierGoal:Message ( owner, type, key )
    if type == 'shot' and self.action ~= 'dying' then
        self:Die ( owner )
        self.action = 'dying'
        self.actionTime = 0
        
        --local n = owner.world:GetAvailableName ( )
        --Explosion:Create ( owner.world, n, b2Vec2 ( owner.def.position ), 10, 0.5 )
        return true
    end
    if self.action == 'falling' then
        if type == 'land' then
            self.action = 'standing'
            self.actionTime = 0
            return true
        end
    elseif self.action == 'kneeling' then
        if type == 'walk' then
            self:Stand ( owner )
            self.action = 'walking'
            self.actionTime = 0
            return true
        elseif type == 'stand' then
            self:Stand ( owner )
            self.action = 'standing'
            self.actionTime = 0
            return true
        elseif type == 'slip' then
            self.action = 'falling'
            self.actionTime = 0
            return true
        end
    elseif self.action == 'standing' or self.action == 'walking' then
        if type == 'walk' and self.action == 'standing' then
            self.action = 'walking'
            self.actionTime = 0
            return true
        elseif type == 'stand' and self.action == 'walking' then
            self.action = 'standing'
            self.actionTime = 0
            return true
        elseif type == 'kneel' then
            self:Kneel ( owner )
            self.action = 'kneeling'
            self.actionTime = 0
            return true
        elseif type == 'slip' then
            self.action = 'falling'
            self.actionTime = 0
            return true
        elseif type == 'jump' then
            self.action = 'jumping'
            self.actionTime = 0
            return true
        end
    elseif self.action == 'jumping' then
        if type == 'hit' or type == 'fall' then
            self.action = 'falling'
            self.actionTime = 0
            return true
        end
    end
	return false
end
function RunningFootSoldierGoal:CreateXML ( goal )
	local g = RunningFootSoldierGoal:Create ( )
	return g
end
function FootSoldierGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	return g
end

]]
