SenseGoal = {}
SenseGoalMT = { __index = SenseGoal }

setmetatable ( SenseGoal, { __index = Goal } )
goals['sense'] = SenseGoal

function SenseGoal:Create ( sensor, target, continuous, target2 )
	local goal = {}
	setmetatable ( goal, SenseGoalMT )

	goal.sensor = sensor
	goal.target = target
	goal.continuous = continuous
	goal.target2 = target2

	return goal
end
function SenseGoal:Destroy ( )
	self.sensor = nil
	self.target = nil
	self.continuous = nil
	self.target2 = nil
end
function SenseGoal:GetType ( )
    return 'sense'
end
function SenseGoal:Process ( delta, owner )
	local sensor
    if self.sensor == 'self' then
        sensor = owner
    else
        sensor = owner.world:FindBody ( self.sensor )
    end

	if sensor then
        local t1 = owner.world:FindBody ( self.target )
        local t2 = owner.world:FindBody ( self.target2 )

        if t1 and sensor:IsTouching ( t1 ) == true then
            return GOAL_COMPLETED, 0
        end
        if t2 and sensor:IsTouching ( t2 ) == true then
            return GOAL_COMPLETED, 0
        end
	end

    if self.continuous ~= true then
        return GOAL_FAILED, 0
    end

    return GOAL_ACTIVE, delta
end
function SenseGoal:CreateXML ( goal )
	local sensor = goal.sensor
	local target = goal.target
	local continuous = toboolean ( goal.continuous )
	local g = SenseGoal:Create ( sensor, target, continuous )
	return g
end
function SenseGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.sensor = self.sensor
	g.target = self.target
	g.continuous = self.continuous
	return g
end
