ShootGoal = {}
ShootGoalMT = { __index = ShootGoal }

setmetatable ( ShootGoal, { __index = Goal } )
goals['shoot'] = ShootGoal

function ShootGoal:Create ( projectile, localPosition, localAngle, distance, speed, msg, popMSG )
	local goal = {}
	setmetatable ( goal, ShootGoalMT )

    goal.projectile = projectile
	goal.localPosition = localPosition
	goal.localAngle = localAngle
	goal.distance = distance
	goal.speed = speed
	goal.msg = msg
	goal.popMSG = popMSG

	return goal
end
function ShootGoal:Destroy ( )
    self.projectile = nil
	self.localPosition = nil
	self.localAngle = nil
	self.distance = nil
	self.speed = nil
	self.msg = nil
	self.popMSG = nil
end
function ShootGoal:GetType ( )
    return 'shoot'
end
function ShootGoal:Process ( delta, owner )
	local worldPosition = owner.b2body:GetWorldPoint ( self.localPosition )
	local name = owner.world:GetAvailableName ( )
	
	local a = self.localAngle
	if a == 'player' then
	    local b1 = owner.world:FindBody ( 'player' )
	    local b2 = owner.world:FindBody ( 'player2' )
	    if b1 == nil and b2 == nil then
	        return GOAL_FAILED, 0
	    end
        local b
        if b1 and b2 then
            local d1 = owner.def.position:Distance ( b1.def.position )
            local d2 = owner.def.position:Distance ( b2.def.position )
            if d1 <= d2 then
                b = b1
            else
                b = b2
            end
        else
            b = b1 or b2
        end
	    a = -worldPosition:Direction ( b.def.position )
	end
	if self.projectile == 'bullet' then
	    Bullet:Create ( owner.world, 'bullet', worldPosition, owner.def.angle + a, self.distance, self.speed, self.msg, self.popMSG )
	elseif self.projectile == 'fire' then
	    Bullet:Create ( owner.world, 'fire', worldPosition, owner.def.angle + a, self.distance, self.speed, self.msg, self.popMSG )
    elseif self.projectile == 'granade' then
        Granade:Create ( owner.world, name, worldPosition, owner.def.angle + a, self.distance, self.speed, self.msg, self.popMSG )
    elseif self.projectile == 'homingMissle' then
        HomingMissle:Create ( owner.world, name, worldPosition, owner.def.angle + a, self.distance, self.speed, self.msg, self.popMSG )
    elseif self.projectile == 'missle' then
        Missle:Create ( owner.world, name, worldPosition, owner.def.angle + a, self.distance, self.speed, self.msg, self.popMSG )


    elseif self.projectile == 'powerup' then
        CreatePowerUp ( owner.world, worldPosition.x, worldPosition.y, self.msg )
    end

	return GOAL_COMPLETED, 0
end
function ShootGoal:CreateXML ( goal )
	local localPosition = tob2Vec2 ( goal.localPosition )
	local localAngle = tonumber ( goal.localAngle )
	local distance = tonumber ( goal.distance )
	local speed = tonumber ( goal.speed )
	local g = ShootGoal:Create ( goal.projectile, localPosition, localAngle, distance, speed )
	return g
end
function ShootGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.projectile = self.projectile
	g.localPosition = b2Vec2tostring ( self.localPosition )
	g.localAngle = self.localAngle
	g.distance = self.distance
	g.speed = self.speed
	return g
end






