function CreateRSoldierSpawn ( world, x, y, x1, y2, s )
    local n = world:GetAvailableName ( )
    local p = b2Vec2 ( x, y )
    local p2 = b2Vec2 ( x1, y2 )
    SoldierSpawn:Create ( world, p, p2, s )
end


SoldierSpawn = {}
SoldierSpawnMT = { __index = SoldierSpawn }

function SoldierSpawn:Create ( world, position, trigger, speed )
    local triggerName = world:GetAvailableName ( )
    local body = world:CreateBody ( triggerName, trigger, 0, 0, 0, true, true, false, false )
    local v = { b2Vec2 ( -1.6, -1.6 * 10 ), b2Vec2 ( 1.6, -1.6 * 10 ), b2Vec2 ( 1.6, 1.6 * 10 ), b2Vec2 ( -1.6, 1.6 * 10 ) }
	local trigger = body:CreateShapePolygon ( v, 0, 0, 0, true )
    body:Paint ( )
    body.sprite:set_scale ( 0.1, 0.1 )

    local spawnName = world:GetAvailableName ( )
    local body = world:CreateBody ( spawnName, position, 0, 0, 0, true, true, false, false )
    body:Paint ( )
    body.sprite:set_scale ( 0.1, 0.1 )

    local s = SequenceGoal:Create ( false )
    s:PushBack ( SenseGoal:Create ( triggerName, 'player', true, 'player2' ) )
    s:PushBack ( SoldierSpawnGoal:Create ( speed ) )
    s:PushBack ( WaitGoal:Create ( 5 ) )
    body:SetGoal ( s )

	return body
end




SoldierSpawnGoal = {}
SoldierSpawnGoalMT = { __index = SoldierSpawnGoal }

setmetatable ( SoldierSpawnGoal, { __index = Goal } )
goals['solderSpawn'] = SoldierSpawnGoal

function SoldierSpawnGoal:Create ( speed )
	local goal = {}
	setmetatable ( goal, SoldierSpawnGoalMT )

    goal.speed = speed

	return goal
end
function SoldierSpawnGoal:Destroy ( )
    self.type = nil
end
function SoldierSpawnGoal:GetType ( )
    return 'solderSpawn'
end
function SoldierSpawnGoal:Process ( delta, owner )
    local pt = owner.def.position

    local n = owner.world:GetAvailableName ( )
    RunningFootSoldier:Create ( owner.world, n, b2Vec2 ( pt ), self.speed )

	return GOAL_COMPLETED, 0
end

function SoldierSpawnGoal:CreateXML ( goal )
	local g = SoldierSpawnGoal:Create ( )
	return g
end
function SoldierSpawnGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	return g
end


