SpawnGoal = {}
SpawnGoalMT = { __index = SpawnGoal }

setmetatable ( SpawnGoal, { __index = Goal } )
goals['shoot'] = SpawnGoal

function SpawnGoal:Create ( object, localPosition, localAngle )
	local goal = {}
	setmetatable ( goal, SpawnGoalMT )

    goal.object = object
	goal.localPosition = localPosition
	goal.localAngle = localAngle

	return goal
end
function SpawnGoal:Destroy ( )
    self.object = nil
	self.localPosition = nil
	self.localAngle = nil
end
function SpawnGoal:GetType ( )
    return 'spawn'
end
function SpawnGoal:Process ( delta, owner )
	local worldPosition = owner.b2body:GetWorldPoint ( self.localPosition )
	local name = owner.world:GetAvailableName ( )

	if self.object == 'health' then
	    Health:Create ( owner.world, worldPosition )
    elseif self.projectile == 'speeder' then
	    Speeder:Create ( owner.world, worldPosition )
    end

	return GOAL_COMPLETED, 0
end
function SpawnGoal:CreateXML ( goal )
	local localPosition = tob2Vec2 ( goal.localPosition )
	local localAngle = tonumber ( goal.localAngle )
	local distance = tonumber ( goal.distance )
	local speed = tonumber ( goal.speed )
	local g = SpawnGoal:Create ( goal.object, localPosition, localAngle, distance, speed )
	return g
end
function SpawnGoal:GetXML ( )
	local g = xml.new ( "Goal" )
	g.type = self:GetType ( )
	g.object = self.object
	g.localPosition = b2Vec2tostring ( self.localPosition )
	g.localAngle = self.localAngle
	g.distance = self.distance
	g.speed = self.speed
	return g
end






