
function CreateVMine ( world, x, y )
    local position = b2Vec2 ( x, y )
    local angle = 0

	local bodyName = world:GetAvailableName ( )
	local body = world:CreateBody ( bodyName, b2Vec2 ( position ), 0, 0, 0, false, false, true, false )
	body:CreateShapeCircle ( 0.7, b2Vec2 ( 0, 0 ), 0, 0, 0, true )
	
    body:SetImage ( "Images/mine/s1.png" )
    body.sprite:set_scale ( 0.1, 0.1 )
    body.sprite.depth = 2

    local takeHit = SequenceGoal:Create ( false )
    takeHit:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
    takeHit:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
    takeHit:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_granade.wav" ) )
    takeHit:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'medium', 0.75 ) )

    takeHit:PushBack ( DestroyBodyGoal:Create ( 'self' ) )
    takeHit:PushBack ( FailGoal:Create ( ) )

    local shoot = SequenceGoal:Create ( false )
    shoot:PushBack ( PlaySound2DGoal:Create ( "Sounds/whip.wav" ) )
    shoot:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( 0, -0.7 ), -math.pi * 3 / 4, 3.2 * 15, 12, 'damage', 'touch' ) )
    shoot:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( 0, -0.7 ), -math.pi, 3.2 * 15, 12, 'damage', 'touch' ) )
    shoot:PushBack ( ShootGoal:Create ( 'bullet', b2Vec2 ( 0, -0.7 ), math.pi * 3 / 4, 3.2 * 15, 12, 'damage', 'touch' ) )
    shoot:PushBack ( WaitGoal:Create ( 0.5 ) )
    shoot:PushBack ( FailGoal:Create ( ) )

    local attack = ParallelGoal:Create ( false )
    attack:PushBack ( shoot )
    attack:PushBack ( takeHit )

    local open = SequenceGoal:Create ( false )
    open:PushBack ( SetImageGoal:Create ( 'Images/mine/s1.png' ) )
    open:PushBack ( WaitGoal:Create ( 0.02 ) )
    open:PushBack ( SetImageGoal:Create ( 'Images/mine/s2.png' ) )
    open:PushBack ( WaitGoal:Create ( 0.02 ) )
    open:PushBack ( SetImageGoal:Create ( 'Images/mine/s3.png' ) )
    open:PushBack ( WaitGoal:Create ( 0.02 ) )
    open:PushBack ( SetImageGoal:Create ( 'Images/mine/s4.png' ) )
    open:PushBack ( WaitGoal:Create ( 0.02 ) )
    open:PushBack ( SetImageGoal:Create ( 'Images/mine/s5.png' ) )
    open:PushBack ( FailGoal:Create ( ) )
    
    local close = SequenceGoal:Create ( false )
    close:PushBack ( SetImageGoal:Create ( 'Images/mine/s5.png' ) )
    close:PushBack ( WaitGoal:Create ( 0.075 ) )
    close:PushBack ( SetImageGoal:Create ( 'Images/mine/s4.png' ) )
    close:PushBack ( WaitGoal:Create ( 0.075 ) )
    close:PushBack ( SetImageGoal:Create ( 'Images/mine/s3.png' ) )
    close:PushBack ( WaitGoal:Create ( 0.075 ) )
    close:PushBack ( SetImageGoal:Create ( 'Images/mine/s2.png' ) )
    close:PushBack ( WaitGoal:Create ( 0.075 ) )
    close:PushBack ( SetImageGoal:Create ( 'Images/mine/s1.png' ) )
    close:PushBack ( WaitGoal:Create ( 2 ) )
    close:PushBack ( FailGoal:Create ( ) )
    
    local range = SequenceGoal:Create ( false )
    range:PushBack ( RangeGoal:Create ( 'player', 8 * 3.2, 'player2' ) )
    range:PushBack ( FailGoal:Create ( ) )
    
    local cycle = PrioritySelectorGoal:Create ( true )
    cycle:PushBack ( range )
    cycle:PushBack ( open )
    cycle:PushBack ( attack )
    cycle:PushBack ( close )

    local pop = SequenceGoal:Create ( true )
    pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
    pop:PushBack ( CompleteGoal:Create ( ) )

    local p = ParallelGoal:Create ( false )
    p:PushBack ( pop )
    p:PushBack ( cycle )
    
    body:SetGoal ( p )
    return body
end