local level1 = game:CreateStream ( "Scripts/shmup1.xml" )

level1.OnLoad = function ( self )
	local world = level1.world

    cpoints = { 3.2 * 7, 3.2 * 84, 3.2 * 145 }
    
    local x = cpoints[checkpoint]
    game.camera.x = x
    game.camera.y = 3.2 * 5
    if mode == 1 then
        game.player = Player:Create ( world, "player", b2Vec2 ( x, 3.2 * 8 ), keyboard, joystick )
    elseif mode == 2 then
        game.player = Player:Create ( world, "player", b2Vec2 ( x, 3.2 * 8 ), keyboard )
        game.player2 = Player:Create ( world, "player2", b2Vec2 ( x + 3.2, 3.2 * 8 ), joystick )
    end

    loadedFG = {}
    for y = 1, #l1_map, 1 do
        loadedFG[y] = {}
    end
    loadedBG = {}
    for y = 1, #l2_map, 1 do
        loadedBG[y] = {}
    end
    back = 16
    forward = 12
    local x = math.floor ( game.player.def.position.x / 3.2 )
    loadedStart = math.max ( x - back, 1 )
    loadedEnd = loadedStart + back + forward
    for i = loadedStart, loadedEnd, 1 do
        LoadLine ( self, l1_map, loadedFG, i )
        LoadLine ( self, l1_map2, loadedBG, i )
    end

    game:PlayMusic ( "Music/02 - Epiclatinarabrock.ogg", true, m_volume )

    local x = 26 * 3.2
    local x2 = x - back / 2 * 3.2
    CreateRSoldierSpawn ( world, x, ( #l1_map - 10 ) * 3.2, x2, ( #l1_map - 7 ) * 3.2, 50 )
    local x = 30 * 3.2
    local x2 = x - back / 2 * 3.2
    CreateRSoldierSpawn ( world, x, ( #l1_map - 10 ) * 3.2, x2, ( #l1_map - 7 ) * 3.2, 54 )

    local x = 7 * 3.2
    local x2 = x + forward * 3.2
    CreateRSoldierSpawn ( world, x, ( #l1_map - 10 ) * 3.2, x2, ( #l1_map - 7 ) * 3.2, 59 )
    local x = 20 * 3.2
    local x2 = x + forward * 3.2
    CreateRSoldierSpawn ( world, x, ( #l1_map - 10 ) * 3.2, x2, ( #l1_map - 7 ) * 3.2, 58 )

    CreateElevatorV ( world, 88 * 3.2, ( #l1_map - 5 ) * 3.2, 0, -3.2 * 6, 5 )
    CreateElevatorV ( world, 91 * 3.2, ( #l1_map - 11 ) * 3.2, 0, 3.2 * 6, 5 )

    CreateElevatorV ( world, 100 * 3.2, ( #l1_map - 11 ) * 3.2, 0, 3.2 * 6, 5 )
    CreateElevatorV ( world, 103 * 3.2, ( #l1_map - 5 ) * 3.2, 0, -3.2 * 6, 5 )
    CreateElevatorV ( world, 106 * 3.2, ( #l1_map - 11 ) * 3.2, 0, 3.2 * 6, 5 )
    CreateElevatorV ( world, 109 * 3.2, ( #l1_map - 5 ) * 3.2, 0, -3.2 * 6, 5 )

    CreateTurret ( world, 114 * 3.2, ( #l1_map - 6 ) * 3.2 )
    CreateTurret ( world, 116 * 3.2, ( #l1_map - 6 ) * 3.2 )

    CreateLTurret ( world, 128 * 3.2, ( #l1_map - 10 ) * 3.2 )
    CreateLTurret ( world, 128 * 3.2, ( #l1_map - 8 ) * 3.2 )
    CreateLTurret ( world, 128 * 3.2, ( #l1_map - 6 ) * 3.2 )

    --CreateTurret2 ( 84 * 3.2, ( #l1_map - 9 ) * 3.2 )

    CreateMine ( world, 3.2 * 147, 3.2 * 5, 3.2 * 3 )
    CreateMine ( world, 3.2 * 147, 3.2 * 7, 3.2 * 3 )

    CreateMine ( world, 3.2 * 158, 3.2 * 3, -3.2 * 4 )
end

level1.OnSimulate = function ( self, delta )
    local world = self.world

    local x
    if mode == 1 then
        x = game.player.def.position.x
    elseif mode == 2 then
        local p1 = game.player
        local p2 = game.player2
        if p1.goal.action ~= 'dead' and p2.goal.action ~= 'dead' then
            x = ( p1.def.position.x + p2.def.position.x ) / 2
            --x = math.max ( x, game.player2.def.position.x )
        elseif p1.goal.action ~= 'dead' then
            x = p1.def.position.x
        elseif p2.goal.action ~= 'dead' then
            x = p2.def.position.x
        else
            x = game.camera.x
        end
    end
    x = math.max ( x, game.camera.x )
    x = math.max ( x, 3.2 * 7 )
    x = math.min ( x, #l1_map[1] * 3.2 - 6 * 3.2 )
    game.camera:set_position ( x, 3.2 * 5 )
    

    local x = math.floor ( x / 3.2 )
    if x - back + 1 > loadedStart then
        for i = loadedStart, x - back, 1 do
            UnLoadLine ( self, l1_map, loadedFG, i )
            UnLoadLine ( self, l1_map2, loadedBG, i )
        end
        loadedStart = x - back + 1
        for i = loadedEnd + 1, loadedStart + back + forward, 1 do
            LoadLine ( self, l1_map, loadedFG, i )
            LoadLine ( self, l1_map2, loadedBG, i )
        end
        loadedEnd = loadedStart + back + forward
    end
end

level1.CreateTileBody = function ( self, v, p )
    local world = self.world
    local n = world:GetAvailableName ( )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, false, true, true )
    b.sprite.depth = 1 - p.y / ( #l1_map * 3.2 )
    b.sprite:set_scale ( 0.1, 0.1 )
    
    if v == 106 then
        local v = { b2Vec2 ( 0, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( 0, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/ground1b.png" )
    elseif v == 107 then
        local v = { b2Vec2 ( 0, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( 0, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/ground3b.png" )
    elseif v == 108 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 0, -1.6 ), b2Vec2 ( 0, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/ground2b.png" )
    elseif v == 109 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 0, -1.6 ), b2Vec2 ( 0, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/ground4b.png" )
        
    elseif v == 110 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/ground1.png" )
        b.sprite.depth = 2
    elseif v == 111 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/ground2.png" )
        b.sprite.depth = 2
    elseif v == 112 then
        b:SetImage ( "Images/tileset/ground3.png" )
    elseif v == 113 then
        b:SetImage ( "Images/tileset/ground4.png" )

    elseif v == 115 then
        local v = { b2Vec2 ( -1.6, -1 ), b2Vec2 ( 1.6, -1 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platform1.png" )
        b.isPlatform = true
    elseif v == 116 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platform2.png" )
        b.isPlatform = true
    elseif v == 117 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platform3.png" )
        b.isPlatform = true
    elseif v == 118 then
        local v = { b2Vec2 ( -1.6, -1 ), b2Vec2 ( 1.6, -1 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platform4.png" )
        b.isPlatform = true

    elseif v == 119 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformV1.png" )
    elseif v == 120 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformV2.png" )
    elseif v == 121 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformV3.png" )
    elseif v == 122 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformV2B.png" )

        local bn = world:GetAvailableName ( )
        local b = world:CreateBody ( bn, b2Vec2 ( p.x, p.y ), 0, 0, 0, true, false, true, true )
        local v = { b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 4.8, -1.6 ), b2Vec2 ( 4.8, 1.6 ), b2Vec2 ( 1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b.sprite:set_scale ( 0.1, 0.1 )
        b:Paint ( )
        b.isPlatform = true
    elseif v == 123 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformV3B.png" )

    elseif v == 124 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformBottom.png" )
    elseif v == 125 then
        local v = { b2Vec2 ( -0.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -0.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformDoor.png" )

        local g = SequenceGoal:Create ( false )
        for i = 1, 10, 1 do
            g:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
            g:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
            g:PushBack ( SetImageGoal:Create ( 'Images/tileset/platformDoorF.png' ) )
            g:PushBack ( WaitGoal:Create ( 0.1 ) )
            g:PushBack ( SetImageGoal:Create ( 'Images/tileset/platformDoor.png' ) )
        end

        local e = math.random ( 4 )
        g:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med" .. e .. ".wav", 0, 1, 1 ) )
        g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.7 ) )
        g:PushBack ( WaitGoal:Create ( 0.02 ) )
        g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.2, -0.8 ), 'small', 0.6 ) )
        g:PushBack ( WaitGoal:Create ( 0.01 ) )
        g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.4, 1.2 ), 'small', 0.8 ) )
        g:PushBack ( DegenerateGoal:Create ( ) )
        g:PushBack ( SetImageGoal:Create ( "Images/tileset/platformDoorB.png" ) )

        local pop = SequenceGoal:Create ( true )
        pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
        pop:PushBack ( CompleteGoal:Create ( ) )

        local parallel = ParallelGoal:Create ( false )
        parallel:PushBack ( g )
        parallel:PushBack ( pop )
        b:SetGoal ( parallel )

        local bn = world:GetAvailableName ( )
        local b = world:CreateBody ( bn, b2Vec2 ( p.x, p.y ), 0, 0, 0, true, false, true, true )
        b:SetImage ( "Images/tileset/platformDoorB.png" )
        b.sprite:set_scale ( 0.1, 0.1 )
        b.sprite.depth = 1
        b:Paint ( )


    elseif v == 126 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, -1.2 ), b2Vec2 ( -1.6, -1.2 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformDoorB.png" )
     
    elseif v == 127 then
        local v = { b2Vec2 ( -1, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformDoorC.png" )

        local g = SequenceGoal:Create ( false )
        for i = 1, 10, 1 do
            g:PushBack ( MessageReceiveGoal:Create ( 'shot' ) )
            g:PushBack ( FunctionGoal:Create ( 'EnemyShot' ) )
            g:PushBack ( SetImageGoal:Create ( 'Images/tileset/platformDoorCF.png' ) )
            g:PushBack ( WaitGoal:Create ( 0.1 ) )
            g:PushBack ( SetImageGoal:Create ( 'Images/tileset/platformDoorC.png' ) )
        end

        local e = math.random ( 4 )
        g:PushBack ( PlaySound2DGoal:Create ( "Sounds/explode_med" .. e .. ".wav", 0, 1, 1 ) )
        g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0, 0 ), 'small', 0.7 ) )
        g:PushBack ( WaitGoal:Create ( 0.02 ) )
        g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( 0.2, -0.8 ), 'small', 0.6 ) )
        g:PushBack ( WaitGoal:Create ( 0.01 ) )
        g:PushBack ( ExplodeGoal:Create ( b2Vec2 ( -0.4, 1.2 ), 'small', 0.8 ) )
        g:PushBack ( DegenerateGoal:Create ( ) )

        local pop = SequenceGoal:Create ( true )
        pop:PushBack ( MessageSendGoal:Create ( 'contacts', 'pop' ) )
        pop:PushBack ( CompleteGoal:Create ( ) )

        local p = ParallelGoal:Create ( false )
        p:PushBack ( g )
        p:PushBack ( pop )
        b:SetGoal ( p )


    elseif v == 130 then
        b:SetPosition ( b2Vec2 ( p.x + 1.7, p.y + 2.1 ) )

        local g = SequenceGoal:Create ( true )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap1.png' ) )
        g:PushBack ( MessageReceiveGoal:Create ( "open" ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap2.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.025 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap3.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.025 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap4.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.025 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap5.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.025 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap6.png' ) )
        g:PushBack ( MessageReceiveGoal:Create ( "close" ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap5.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.1 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap4.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.1 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap3.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.1 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap2.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.1 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/trap1.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.5 ) )
        b:SetGoal ( g )
        b.sprite.depth = -0.5
        
        --local v = { b2Vec2 ( -3.2, -0.5 ), b2Vec2 ( 3.2, -0.5 ), b2Vec2 ( 3.2, -1.6 ), b2Vec2 ( -3.2, -1.6 ) }
        local v = { b2Vec2 ( -3.2, -0.5 ), b2Vec2 ( -2.8, -0.5 ), b2Vec2 ( -2.8, -3.1 ), b2Vec2 ( -3.2, -3.1 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        local v = { b2Vec2 ( 2.8, -0.5 ), b2Vec2 ( 3.2, -0.5 ), b2Vec2 ( 3.2, -3.1 ), b2Vec2 ( 2.8, -3.1 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b.isPlatform = true

        local bn = world:GetAvailableName ( )
        local b = world:CreateBody ( bn, b2Vec2 ( p.x, p.y ), 0, 0, 0, true, false, true, true )
        local v = { b2Vec2 ( -2.8, -0.5 ), b2Vec2 ( 2.8, -0.5 ), b2Vec2 ( 2.8, -1.6 ), b2Vec2 ( -2.8, -1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b.sprite:set_scale ( 0.1, 0.1 )
        b:Paint ( )
        b.isPlatform = true
        b:SetPosition ( b2Vec2 ( p.x + 1.7, p.y + 2.1 ) )

        local g = SequenceGoal:Create ( true )
        g:PushBack ( MessageReceiveGoal:Create ( "touch" ) )
        g:PushBack ( WaitGoal:Create ( 0.75 ) )
        g:PushBack ( MessageSendGoal:Create ( n, "open" ) )
        local r = math.random ( 5 )
        g:PushBack ( PlaySound2DGoal:Create ( "Sounds/hiss" .. r .. ".wav" ) )
        g:PushBack ( DegenerateGoal:Create ( ) )
        g:PushBack ( WaitGoal:Create ( 1.5 ) )
        g:PushBack ( MessageSendGoal:Create ( n, "close" ) )
        g:PushBack ( WaitGoal:Create ( 0.4 ) )
        g:PushBack ( GenerateGoal:Create ( ) )
        b:SetGoal ( g )

    elseif v == 148 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformV4.png" )
    elseif v == 149 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/platformV5.png" )

    elseif v == 160 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box1.png" )
    elseif v == 161 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box2.png" )
    elseif v == 162 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box3.png" )
    elseif v == 163 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box4.png" )
    elseif v == 164 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box5.png" )
    elseif v == 165 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box6.png" )
    elseif v == 166 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box7.png" )
    elseif v == 167 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box8.png" )
    elseif v == 168 then
        b:SetImage ( "Images/tileset/box9.png" )
    elseif v == 169 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 0.4, -1.6 ), b2Vec2 ( 0.4, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box10.png" )

    elseif v == 170 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box2b.png" )
    elseif v == 171 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box4b.png" )
    elseif v == 172 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box5b.png" )
    elseif v == 173 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box7b.png" )
    elseif v == 174 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box8b.png" )
    elseif v == 175 then
        b:SetImage ( "Images/tileset/boxBack1.png" )
    elseif v == 176 then
        b:SetImage ( "Images/tileset/boxBack2.png" )
    elseif v == 177 then
        b:SetImage ( "Images/tileset/boxBack3.png" )
    elseif v == 178 then
        b:SetImage ( "Images/tileset/boxBack4.png" )
    elseif v == 179 then
        b:SetImage ( "Images/tileset/boxBack5.png" )
    elseif v == 180 then
        b:SetImage ( "Images/tileset/boxBack6.png" )
    elseif v == 181 then
        b:SetImage ( "Images/tileset/boxBack7.png" )
    elseif v == 182 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 0.4, -1.6 ), b2Vec2 ( 0.4, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box11.png" )
        

    elseif v == 183 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box5c.png" )
    elseif v == 184 then
        b:SetImage ( "Images/tileset/boxBack2b.png" )
    elseif v == 185 then
        b:SetImage ( "Images/tileset/boxBack6b.png" )

    elseif v == 186 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 1.6 ), b2Vec2 ( -1.6, 1.6 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset/box4c.png" )


    elseif v == 200 then
        CreateLaser ( world, p.x, p.y, 2 )
    elseif v == 201 then
        CreateLaser ( world, p.x, p.y, 3, -3.2 * 6 )
    elseif v == 202 then
        CreateLaser ( world, p.x, p.y, 4 )
        


    elseif v == 210 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( -1.6, -0.5 ), b2Vec2 ( 1.6, -0.5 ), b2Vec2 ( 1.6, -1.6 ) }
        b:CreateShapePolygon ( v, 0, 0, 0, true )
        b:SetImage ( "Images/tileset/spikes1.png" )
        local g = SequenceGoal:Create ( true )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes1.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.01 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes2.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.01 ) )
        g:PushBack ( PlaySound2DGoal:Create ( "Sounds/spikes.wav", 0, 1, 0.5 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes3.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.01 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes4.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.01 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes5.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.01 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes6.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.01 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes7.png' ) )
        g:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        g:PushBack ( WaitGoal:Create ( 0.25 ) )
        g:PushBack ( MessageSendGoal:Create ( 'contacts', 'damage' ) )
        g:PushBack ( WaitGoal:Create ( 0.25 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes6.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.075 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes5.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.075 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes4.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.075 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes3.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.075 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes2.png' ) )
        g:PushBack ( WaitGoal:Create ( 0.075 ) )
        g:PushBack ( SetImageGoal:Create ( 'Images/tileset/spikes1.png' ) )
        g:PushBack ( WaitGoal:Create ( 1 ) )
        b:SetGoal ( g )
        b.sprite.depth = -0.5
        
    elseif v == 220 then
        b:SetImage ( "Images/tileset/elevatorVb.png" )
        b.sprite.depth = 90
    elseif v == 221 then
        b:SetImage ( "Images/tileset/elevatorVc.png" )
        b.sprite.depth = 90
    
    elseif v == 222 then
        b:SetImage ( "Images/bg/bg1.png" ) 
        b.sprite.depth = 100
    elseif v == 223 then
        b:SetImage ( "Images/bg/bg2.png" ) 
        b.sprite.depth = 100
    elseif v == 224 then
        b:SetImage ( "Images/bg/bg3.png" ) 
        b.sprite.depth = 100
    elseif v == 225 then
        b:SetImage ( "Images/bg/bg4.png" ) 
        b.sprite.depth = 100
    elseif v == 226 then
        b:SetImage ( "Images/bg/bg5.png" ) 
        b.sprite.depth = 100
    elseif v == 227 then
        b:SetImage ( "Images/bg/bg4b.png" ) 
        b.sprite.depth = 100
    elseif v == 228 then
        b:SetImage ( "Images/bg/bg5b.png" ) 
        b.sprite.depth = 100
    elseif v == 230 then
        b:SetImage ( "Images/bg/bg10.png" ) 
        b.sprite.depth = 100
    elseif v == 231 then
        b:SetImage ( "Images/bg/bg11.png" ) 
        b.sprite.depth = 100
    elseif v == 232 then
        b:SetImage ( "Images/bg/bg12.png" ) 
        b.sprite.depth = 100
    elseif v == 233 then
        b:SetImage ( "Images/bg/bg13.png" ) 
        b.sprite.depth = 100 
    elseif v == 234 then
        b:SetImage ( "Images/bg/bg14.png" ) 
        b.sprite.depth = 100 
    elseif v == 235 then
        b:SetImage ( "Images/bg/bg15.png" ) 
        b.sprite.depth = 100 
    elseif v == 236 then
        b:SetImage ( "Images/bg/bg15b.png" ) 
        b.sprite.depth = 100 
    elseif v == 237 then
        b:SetImage ( "Images/bg/bg15c.png" ) 
        b.sprite.depth = 100 
    elseif v == 238 then
        b:SetImage ( "Images/bg/bg15d.png" ) 
        b.sprite.depth = 100 
    elseif v == 239 then
        b:SetImage ( "Images/bg/bg16.png" ) 
        b.sprite.depth = 100 
    elseif v == 240 then
        b:SetImage ( "Images/bg/bg17.png" ) 
        b.sprite.depth = 100 
        
        
    elseif v == 250 then
        b:SetImage ( "Images/bg/bgTube1.png" ) 
        b.sprite.depth = 100
    elseif v == 251 then
        b:SetImage ( "Images/bg/bgTube2.png" ) 
        b.sprite.depth = 100
    elseif v == 252 then
        b:SetImage ( "Images/bg/bgTube3.png" ) 
        b.sprite.depth = 100
    elseif v == 253 then
        b:SetImage ( "Images/bg/bgTube4.png" ) 
        b.sprite.depth = 100
    elseif v == 254 then
        b:SetImage ( "Images/bg/bgTube5.png" ) 
        b.sprite.depth = 100
    elseif v == 255 then
        b:SetImage ( "Images/bg/bgTube6.png" ) 
        b.sprite.depth = 100
    elseif v == 256 then
        b:SetImage ( "Images/bg/bgTube7.png" ) 
        b.sprite.depth = 100
    elseif v == 257 then
        b:SetImage ( "Images/bg/bgTube8.png" ) 
        b.sprite.depth = 100
        
    elseif v == 260 then
        b:SetImage ( "Images/bg/bgc1.png" ) 
        b.sprite.depth = 100
    elseif v == 261 then
        b:SetImage ( "Images/bg/bgc2.png" ) 
        b.sprite.depth = 100
    elseif v == 262 then
        b:SetImage ( "Images/bg/bgc3.png" ) 
        b.sprite.depth = 100

    elseif v == 270 then
        b:SetImage ( "Images/bg/bgV1.png" ) 
        b.sprite.depth = 100 
    elseif v == 271 then
        b:SetImage ( "Images/bg/bgV2.png" ) 
        b.sprite.depth = 100 
    elseif v == 272 then
        b:SetImage ( "Images/bg/bgV3.png" ) 
        b.sprite.depth = 100 
    elseif v == 273 then
        b:SetImage ( "Images/bg/bgV1b.png" ) 
        b.sprite.depth = 100 
    elseif v == 274 then
        b:SetImage ( "Images/bg/bgV2b.png" ) 
        b.sprite.depth = 100 
    elseif v == 275 then
        b:SetImage ( "Images/bg/bgV3b.png" ) 
        b.sprite.depth = 100 
    elseif v == 276 then
        b:SetImage ( "Images/bg/bgV4b.png" ) 
        b.sprite.depth = 100 
    elseif v == 277 then
        b:SetImage ( "Images/bg/bgV1c.png" ) 
        b.sprite.depth = 100 
    elseif v == 278 then
        b:SetImage ( "Images/bg/bgV2c.png" ) 
        b.sprite.depth = 100 
    elseif v == 279 then
        b:SetImage ( "Images/bg/bgV3c.png" ) 
        b.sprite.depth = 100 
        
    elseif v == 280 then
        b:SetImage ( "Images/bg/bgcv1.png" ) 
        b.sprite.depth = 100 
    elseif v == 281 then
        b:SetImage ( "Images/bg/bgcv2.png" ) 
        b.sprite.depth = 100 
    elseif v == 282 then
        b:SetImage ( "Images/bg/bgcv3.png" ) 
        b.sprite.depth = 100 
    elseif v == 283 then
        b:SetImage ( "Images/bg/bgcv4.png" ) 
        b.sprite.depth = 100 
    elseif v == 284 then
        b:SetImage ( "Images/bg/bgcv5.png" ) 
        b.sprite.depth = 100 
    elseif v == 285 then
        b:SetImage ( "Images/bg/bgcv6.png" ) 
        b.sprite.depth = 100 

    elseif v == 290 then
        b:SetImage ( "Images/bg/bglamp.png" ) 
        b.sprite.depth = 100 

    elseif v == 295 then
        b:SetImage ( "Images/bg/support.png" ) 
        b.sprite.depth = 100 

    elseif v == 400 then
        CreatePowerUp ( world, p.x, p.y, 'flame' )
        
    elseif v == 899 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( -1.6, -0.5 ), b2Vec2 ( 1.6, -0.5 ), b2Vec2 ( 1.6, -1.6 ) }
        b:CreateShapePolygon ( v, 0, 0, 0, true )
        local d = SequenceGoal:Create ( true )
        d:PushBack ( MessageSendGoal:Create ( 'contacts', 'die' ) )
        d:PushBack ( CompleteGoal:Create ( ) )
        b:SetGoal ( d )
        
    elseif v == 900 then
        CreateSoldier ( world, p.x, p.y )

    elseif v == 901 then
        CreateChoppa ( world, p.x, p.y )
    elseif v == 902 then
        --b:SetPositionXY ( 3.2 * x, 3.2 * ( #l1_map - y ) + 1.5 )
        --CreateVMine ( b )
        CreateVMine ( world, p.x, p.y + 1.5 )
    elseif v == 903 then
        CreateMachineGunner ( world, b, p )

    elseif v == 999 then
        CreateBoss1 ( world, b )
    end

	return b
end