local level2 = game:CreateStream ( "Scripts/shmup2.xml" )

function CreateLayer ( image, depth, xskip )
  local layer = Layer ( )
  layer.depth = depth
  for x = -16, 16, 1 do
    local s = Sprite ( x * xskip or image.width, 0 )
    s.canvas:set_source_image ( image )
    s.canvas:paint ( )
    layer:add_child ( s )
  end
  return layer
end

level2.OnLoad = function ( self )
    game:PlayMusic ( "Music/02 - Epiclatinarabrock.ogg", true, m_volume )

	local world = level2.world

    cpoints = { 3.2 * 35, 3.2 * 23 }
    
    local x = cpoints[checkpoint]
    --x = math.min ( x, #l2_map[1] * 3.2 - 6 * 3.2 )
    game.camera.x = x
    game.camera.y = 3.2 * 5
    if mode == 1 then
        game.player = Player:Create ( world, "player", b2Vec2 ( x, 3.2 * 8 ), keyboard, joystick )
    elseif mode == 2 then
        game.player = Player:Create ( world, "player", b2Vec2 ( x, 3.2 * 8 ), keyboard )
        game.player2 = Player:Create ( world, "player2", b2Vec2 ( x + 3.2, 3.2 * 8 ), joystick )
    end

    loadedFG = {}
    for y = 1, #l2_map, 1 do
        loadedFG[y] = {}
    end
    back = 16
    forward = 12
    local x = math.floor ( game.player.def.position.x / 3.2 )
    loadedStart = math.max ( x - back, 1 )
    loadedEnd = loadedStart + back + forward
    for i = loadedStart, loadedEnd, 1 do
        LoadLine ( self, l2_map, loadedFG, i )
    end

    local i = game:FindImage ( "Images/tileset2/tracks1.png" )
    tracks = CreateLayer ( i, 15, 32 )
    tracks:set_scale ( 0.1, 0.1 )
    tracks.y = 3.2 * 2

    local i = game:FindImage ( "Images/tileset2/pole1.png" )
    poles = CreateLayer ( i, 16, 256 )
    poles:set_scale ( 0.1, 0.1 )
    poles.y = 3.2 * 6

    local i = game:FindImage ( "Images/tileset2/bg2.png" )
    bg0 = CreateLayer ( i, 17, 192 )
    bg0:set_scale ( 0.1, 0.1 )
    bg0.y = 3.2 * 3.5

    local i = game:FindImage ( "Images/tileset2/bg2.png" )
    bg1 = CreateLayer ( i, 18, 192 )
    bg1:set_scale ( 0.1, 0.1 )
    bg1.y = 3.2 * 3.75

    local i = game:FindImage ( "Images/tileset2/bg1.png" )
    bg2 = CreateLayer ( i, 19, 192 )
    bg2:set_scale ( 0.1, 0.1 )
    bg2.y = 3.2 * 4.5

    local i = game:FindImage ( "Images/tileset2/bg1.png" )
    bg3 = CreateLayer ( i, 20, 192 )
    bg3:set_scale ( 0.1, 0.1 )
    bg3.y = 3.2 * 4.8
    
    local i = game:FindImage ( "Images/tileset2/bg3.png" )
    bg4 = CreateLayer ( i, 21, 192 )
    bg4:set_scale ( 0.1, 0.1 )
    bg4.y = 3.2 * 5.1
    
    local i = game:FindImage ( "Images/tileset2/bg4.png" )
    bg5 = CreateLayer ( i, 22, 192 )
    bg5:set_scale ( 0.1, 0.1 )
    bg5.y = 3.2 * 5.75

    local i = game:FindImage ( "Images/tileset2/bg5.png" )
    bg6 = CreateLayer ( i, 23, 192 )
    bg6:set_scale ( 0.1, 0.1 )
    bg6.y = 3.2 * 9

    local i = game:FindImage ( "Images/tileset2/bg6.png" )
    bg7 = CreateLayer ( i, 24, 192 )
    bg7:set_scale ( 0.1, 0.1 )
    bg7.y = 3.2 * 8.2

    world.layer:add_child ( tracks )
    world.layer:add_child ( poles )
    world.layer:add_child ( bg0 )
    --world.layer:add_child ( bg1 )
    world.layer:add_child ( bg2 )
    --world.layer:add_child ( bg3 )
    world.layer:add_child ( bg4 )
    world.layer:add_child ( bg5 )
    world.layer:add_child ( bg6 )
    world.layer:add_child ( bg7 )
end

level2.OnDeselect = function ( self )
    local world = self.world
    world.layer:remove_child ( tracks )
    world.layer:remove_child ( poles )
    world.layer:remove_child ( bg0 )
    world.layer:remove_child ( bg1 )
    world.layer:remove_child ( bg2 )
    world.layer:remove_child ( bg3 )
    world.layer:remove_child ( bg4 )
    world.layer:remove_child ( bg5 )
    world.layer:remove_child ( bg6 )
    world.layer:remove_child ( bg7 )
end

level2.OnSimulate = function ( self, delta )
    local world = self.world

    tracks.x = tracks.x - delta * 20
    if tracks.x < game.camera.x - 8 * 3.2 then
        tracks.x = game.camera.x + 8 * 3.2
    end
    poles.x = poles.x - delta * 15
    if poles.x < game.camera.x - 8 * 3.2 then
        poles.x = game.camera.x + 8 * 3.2 
    end
    bg0.x = bg0.x - delta * 13
    if bg0.x < game.camera.x - 8 * 19.2 then
        bg0.x = game.camera.x + 8 * 19.2 
    end
    bg1.x = bg1.x - delta * 10
    if bg1.x < game.camera.x - 8 * 19.2 then
        bg1.x = game.camera.x + 8 * 19.2 
    end
    bg2.x = bg2.x - delta * 8
    if bg2.x < game.camera.x - 8 * 19.2 then
        bg2.x = game.camera.x + 8 * 19.2 
    end
    bg3.x = bg3.x - delta * 6
    if bg3.x < game.camera.x - 8 * 19.2 then
        bg3.x = game.camera.x + 8 * 19.2 
    end
    bg4.x = bg4.x - delta * 3
    if bg4.x < game.camera.x - 8 * 19.2 then
        bg4.x = game.camera.x + 8 * 19.2 
    end
    bg5.x = bg5.x - delta * 2
    if bg5.x < game.camera.x - 8 * 19.2 then
        bg5.x = game.camera.x + 8 * 19.2 
    end
    bg6.x = bg6.x - delta * 1.75
    if bg6.x < game.camera.x - 8 * 19.2 then
        bg6.x = game.camera.x + 8 * 19.2 
    end
    bg7.x = bg7.x - delta * 1.4
    if bg7.x < game.camera.x - 8 * 19.2 then
        bg7.x = game.camera.x + 8 * 19.2 
    end

    local x
    if mode == 1 then
        x = game.player.def.position.x
    elseif mode == 2 then
        local p1 = game.player
        local p2 = game.player2
        if p1.goal.action ~= 'dead' and p2.goal.action ~= 'dead' then
            x = ( p1.def.position.x + p2.def.position.x ) / 2
            --x = math.max ( x, game.player2.def.position.x )
        elseif p1.goal.action ~= 'dead' then
            x = p1.def.position.x
        elseif p2.goal.action ~= 'dead' then
            x = p2.def.position.x
        else
            x = game.camera.x
        end
    end
    x = math.max ( x, game.camera.x )
    x = math.max ( x, 3.2 * 7 )
    x = math.min ( x, #l2_map[1] * 3.2 - 6 * 3.2 )
    game.camera:set_position ( x, 3.2 * 5 )


    local x = math.floor ( x / 3.2 )
    if x - back + 1 > loadedStart then
        for i = loadedStart, x - back, 1 do
            UnLoadLine ( self, l2_map, loadedFG, i )
        end
        loadedStart = x - back + 1
        for i = loadedEnd + 1, loadedStart + back + forward, 1 do
            LoadLine ( self, l2_map, loadedFG, i )
        end
        loadedEnd = loadedStart + back + forward
    end
end

level2.CreateTileBody = function ( self, v, p )
    local world = self.world
    local n = world:GetAvailableName ( )
    local b = world:CreateBody ( n, p, 0, 0, 0, true, false, true, true )
    b.sprite.depth = 1 - p.y / ( #l2_map * 3.2 )
    b.sprite:set_scale ( 0.1, 0.1 )

    if v == 101 then
        local s = SequenceGoal:Create ( true )
        s:PushBack ( SetImageGoal:Create ( "Images/tileset2/wheels1a.png" ) )
        s:PushBack ( WaitGoal:Create ( 0.1 ) )
        s:PushBack ( SetImageGoal:Create ( "Images/tileset2/wheels1b.png" ) )
        s:PushBack ( WaitGoal:Create ( 0.1 ) )
        b:SetGoal ( s )
        
    elseif v == 102 then
        b:SetImage ( "Images/tileset2/wheels2.png" )
    elseif v == 103 then
        b:SetImage ( "Images/tileset2/wheels3.png" )
    elseif v == 104 then

        local s = SequenceGoal:Create ( true )
        s:PushBack ( SetImageGoal:Create ( "Images/tileset2/wheels4a.png" ) )
        s:PushBack ( WaitGoal:Create ( 0.1 ) )
        s:PushBack ( SetImageGoal:Create ( "Images/tileset2/wheels4b.png" ) )
        s:PushBack ( WaitGoal:Create ( 0.1 ) )
        b:SetGoal ( s )
        
    elseif v == 111 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 3.5 ), b2Vec2 ( -1.6, 3.5 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/train1.png" )
        local wp = b2Vec2 ( p.x, p.y + 0.8 )
        CreateSmallWindow ( world, wp )
    elseif v == 112 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 3.5 ), b2Vec2 ( -1.6, 3.5 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/train2.png" )
    elseif v == 113 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 3.5 ), b2Vec2 ( -1.6, 3.5 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/train3.png" )
        local wp = b2Vec2 ( p.x - 0.8, p.y + 1 )
        CreateWindow ( world, wp )
        local wp = b2Vec2 ( p.x + 0.8, p.y + 1 )
        CreateWindow ( world, wp )
    elseif v == 114 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 3.5 ), b2Vec2 ( -1.6, 3.5 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/train4.png" )
    elseif v == 115 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 3.5 ), b2Vec2 ( -1.6, 3.5 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/train5.png" )

    elseif v == 121 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, -0.8 ), b2Vec2 ( -1.6, -0.8 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/trainb1.png" )
    elseif v == 122 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, -0.8 ), b2Vec2 ( -1.6, -0.8 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/trainb2.png" )
    elseif v == 123 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, -0.8 ), b2Vec2 ( -1.6, -0.8 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/trainb3.png" )
    elseif v == 124 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, -0.8 ), b2Vec2 ( -1.6, -0.8 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/trainb2b.png" )

    elseif v == 125 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 3.8 ), b2Vec2 ( -1.6, 3.8 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/loco1.png" )
    elseif v == 126 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 4.4 ), b2Vec2 ( -1, 4.4 ), b2Vec2 ( -1, 3.8 ), b2Vec2 ( -1.6, 3.8 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/loco2.png" )
    elseif v == 127 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 4.4 ), b2Vec2 ( -1.6, 4.4 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/loco3.png" )
    elseif v == 128 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.6, -1.6 ), b2Vec2 ( 1.6, 4.4 ), b2Vec2 ( -1.6, 4.4 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/loco4.png" )
    elseif v == 129 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( 1.9, -1.6 ), b2Vec2 ( 1.9, 3.8 ), b2Vec2 ( -1.6, 3.8 ) }
        b:CreateShapePolygon ( v, 0, 0.5, 0, false )
        b:SetImage ( "Images/tileset2/loco5.png" )



    elseif v == 199 then
        local p = b2Vec2 ( p.x, p.y - 1.4 )
        b:SetPosition ( p )
        CreateTurboGunner ( world, b, p )
    elseif v == 200 then
        local p = b2Vec2 ( p.x, p.y + 2.1 )
        b:SetPosition ( p )
        CreateTurboGunner ( world, b, p )
    elseif v == 201 then
        local p = b2Vec2 ( p.x - 0.8, p.y - 2.2 )
        b:SetPosition ( p )
        CreateWindowSoldier ( world, b, p )
        b.sprite.depth = -1
    elseif v == 202 then
        local p = b2Vec2 ( p.x + 0.8, p.y - 2.2 )
        b:SetPosition ( p )
        CreateWindowSoldier ( world, b, p )
        b.sprite.depth = -1
    elseif v == 203 then
        CreateSquatSoldier ( world, b2Vec2 ( p.x, p.y + 1.3 ) )

    elseif v == 300 then
        local b = CreateBox ( world, p )
        b.sprite.depth = 1 - p.y / ( #l2_map * 3.2 )

    elseif v == 301 then
        local b = CreateMiniBox ( world, b2Vec2 ( p.x - 0.8, p.y ) )
        b.sprite.depth = 1 - p.y / ( #l2_map * 3.2 )
        local b = CreateMiniBox ( world, b2Vec2 ( p.x + 0.8, p.y ) )
        b.sprite.depth = 1 - p.y / ( #l2_map * 3.2 )
    elseif v == 302 then
        local b = CreateMiniBox ( world, p )
        b.sprite.depth = 1 - p.y / ( #l2_map * 3.2 )
    elseif v == 303 then
        local b = CreateTallBox ( world, p )
        b.sprite.depth = 1 - p.y / ( #l2_map * 3.2 )

    elseif v == 899 then
        local v = { b2Vec2 ( -1.6, -1.6 ), b2Vec2 ( -1.6, -0.5 ), b2Vec2 ( 1.6, -0.5 ), b2Vec2 ( 1.6, -1.6 ) }
        b:CreateShapePolygon ( v, 0, 0, 0, true )
        local d = SequenceGoal:Create ( true )
        d:PushBack ( MessageSendGoal:Create ( 'contacts', 'die' ) )
        d:PushBack ( CompleteGoal:Create ( ) )
        b:SetGoal ( d )
        
    end

	return b
end