-- require ( "strict" )
--jit.off ( )

dofile ( "Scripts/utilities.lua" )
dofile ( "Scripts/B2DX/framework.lua" )

-- psp res is 480 x 272 ( 960, 544 )
game = Game:Create ( "8-Bit Commando", 800, 600, 32, true )
--game = Game:Create ( "Shmup", 1024, 768, 32, true )
--game = Game:Create ( "Shmup", 960, 544, 32, true )

goals = {}
dodir ( lfs.currentdir ( ) .. "/Scripts/B2DX/Goals", false )
dodir ( lfs.currentdir ( ) .. "/Scripts/B2DX/Goals/Conditions", false )
dodir ( lfs.currentdir ( ) .. "/Scripts/B2DX/Goals/Behaviors", false )
dodir ( lfs.currentdir ( ) .. "/Scripts/B2DX/Goals/Effects", false )

dodir ( lfs.currentdir ( ) .. "/Scripts/Objects", true )

game:DemandSoundDirectory ( "Sounds", true )
game:DemandImageDirectory ( "Images", true )


--[[
game:Log ( "A GAME BY IVAN TRAYKOV\n" )
game:Log ( "Programming: Philip Traykov\n" )
game:Log ( "Music: Daniel Bautista\n" )
game:Log ( "Theme song: Ogrebane\n" )
game:Log ( "Sound effects: Tomas Pettersson\n" )
game:Log ( "Physics: Erin Catto\n" )
game:Log ( "Beta testing:\n" )
]]

g_volume = 0.75
m_volume = 0.25

audio.volume = g_volume

--game.viewport.bgcolor = Color ( 32, 32, 32 )
--game.viewport.bgcolor = DODGERBLUE 
--game.viewport.bgcolor = DARKBLUE 

showBoxes = false

dofile ( "Scripts/shmup2_utils.lua" )
dofile ( "Scripts/shmup2_english.lua" )

dofile ( "Scripts/level1.lua" )
dofile ( "Scripts/map1.lua" )
dofile ( "Scripts/level2.lua" )
dofile ( "Scripts/map2.lua" )

stream = 'Scripts/shmup2.xml'

BUTTON_UP = 1
BUTTON_DOWN = 2
BUTTON_LEFT = 3
BUTTON_RIGHT = 4
BUTTON_1 = 5
BUTTON_2 = 6

SENSITIVITY = 0.5

if joystick then
    joystick.buttons = {}
    joystick.buttons[BUTTON_1] = JBUTTON_2
    joystick.buttons[BUTTON_2] = JBUTTON_1
    joystick.down = function ( b )
        if b == BUTTON_DOWN then
            return joystick.yaxis < -SENSITIVITY
        elseif b == BUTTON_UP then
            return joystick.yaxis > SENSITIVITY
        elseif b == BUTTON_LEFT then
            return joystick.xaxis < -SENSITIVITY
        elseif b == BUTTON_RIGHT then
            return joystick.xaxis > SENSITIVITY
        end
        return joystick:is_down ( joystick.buttons[b] )
    end
    --[[
    joystick.on_move = function ( x, y )
        if game.player == nil or screen ~= 'game' then
            return
        end
        if mode == 1 then
            game.player:Message ( 'joystickmove', x, y )
        else
            game.player2:Message ( 'joystickmove', x, y )
        end
    end
    joystick.on_press = function ( button )
        if game.player == nil or screen ~= 'game' then
            return
        end
        if mode == 1 then
            game.player:Message ( 'joystickpress', button )
        else
            game.player2:Message ( 'joystickpress', button )
        end
    end
    joystick.on_release = function ( button )
        if game.player == nil or screen ~= 'game' then
            return
        end
        if mode == 1 then
            game.player:Message ( 'joystickrelease', button )
        else
            game.player2:Message ( 'joystickrelease', button )
        end
    end
    ]]
end

if keyboard then
    keyboard.keys = {}
    keyboard.keys[BUTTON_UP] = KEY_UP
    keyboard.keys[BUTTON_DOWN] = KEY_DOWN
    keyboard.keys[BUTTON_LEFT] = KEY_LEFT
    keyboard.keys[BUTTON_RIGHT] = KEY_RIGHT
    keyboard.keys[BUTTON_1] = KEY_X
    keyboard.keys[BUTTON_2] = KEY_Z
  
    keyboard.down = function ( b )
        return keyboard:is_down ( keyboard.keys[b] )
    end
    keyboard.on_press = function ( key )
        if key == KEY_ENTER and ( keyboard:is_down ( KEY_RALT ) or keyboard:is_down ( KEY_LALT ) ) then
            local dm = DisplayMode ( )
            display:get_mode ( dm )
            dm.windowed = not dm.windowed
            display:set_mode ( dm )
            if dm.windowed == false then
                mouse:hide_cursor ( )
            else
                mouse:show_cursor ( )
            end
        end
        if game.player == nil or screen ~= 'game' then
            return
        end
        if key == KEY_S then
            --game.player.world:SaveXML ( "./test_shmup.xml" )
        elseif key == KEY_1 then
            --game.camera:set_scale ( 0.1, 0.1 )
        elseif key == KEY_F12 then
            showBoxes = not showBoxes
            for i, v in pairs ( world.bodies ) do
                v:Paint ( )
            end
        elseif key == KEY_ESCAPE then
            if game.state == 'playing' then
                game:Pause ( )
            else
                game:Play ( )
            end
        end

        game.player:Message ( 'keypress', key )
    end
--[[
    keyboard.on_release = function ( key )
        if game.player == nil or screen ~= 'game' then
            return
        end
        game.player:Message ( 'keyrelease', key )
    end
    ]]
end
--[[
mouse.on_press = function ( button )
	local x = mouse.xaxis
	local y = mouse.yaxis
    if game.player ~= nil then
        local ptx, pty = game.camera:get_world_point ( x, y )
        local r = game.player.world:QueryPoint ( b2Vec2 ( ptx, pty ), 1 )
        if #r == 0 then
            game.query = nil
            return
        end
        game.query = r[1].body.name
    end
end

-- allow zooming the camera via the wheel
mouse.on_wheelmove = function ( z )
	if ( z > 0 ) then
		z = 0.9
	else
		z = 1.1
	end
	game.camera:change_scale ( z, z )
end
]]

game.camera:set_scale ( 0.05, 0.05 )
--game.camera:set_scale ( 0.1, 0.1 )
--game.camera:set_scale ( 0.075, 0.075 )

fontbig = Font ( )
fontbig:load_file ( "Fonts/joystix.ttf", 18 )

function SelectScreen ( s )
    if screen == 'title' then
        game:StopMusic ( )
        
        display.viewport:remove_child ( title_layer )
        title_layer = nil
    elseif screen == 'warning' then
        display.viewport:remove_child ( ws )
        ws = nil
    elseif screen == 'levelselect' then
        display.viewport:remove_child ( ls )
        ls = nil
        display.viewport:remove_child ( sel )
        sel = nil
        
        selected = nil
        wasdown = nil
    elseif screen == 'game' then
        local cp = 0
        local x = game.player.def.position.x
        if mode == 2 then
            x = math.max ( x, game.player2.def.position.x )
        end
        for i, v in pairs ( cpoints ) do
            if x > v then
                cp = cp + 1
            end
        end
        checkpoint = math.max ( cp, checkpoint ) 
        display.viewport:remove_child ( hud )
        hud = nil
        
        game:Pause ( )
        game.camera.visible = false
        game:StopMusic ( )
        
        level.world.layer.visible = false
        level:DeSelect ( )
        level = nil
        game:Update ( 0 )
    elseif screen == 'gameover' then
        display.viewport:remove_child ( go )
        go = nil
        display.viewport:remove_child ( sel )
        sel = nil
        
        selected = nil
        wasdown = nil
        
        game:StopMusic ( )
    elseif screen == 'complete' then
        display.viewport:remove_child ( complete )
        complete = nil
    end

    screen = s
    screen_time = 0
    
    if s == 'title' then
        checkpoint = 1
        wasdown = nil
        
        title_layer = Layer ( )
        display.viewport:add_child ( title_layer )
        local img = game:FindImage ( "Images/title.png" )
        title = Sprite ( )
        title:set_scale ( 2, 2 )
        title.canvas:set_source_image ( img, 0, 20 )
        title.canvas:paint ( )
        title_layer:add_child ( title )

        press = Sprite ( )
        press.canvas:set_font ( fontbig )
        local w = fontbig:get_width ( lang.singlePlayer )
        press.canvas:move_to ( -w / 2, -230 )
        press.canvas:write ( lang.singlePlayer )
        press.canvas:move_to ( -w / 2, -260 )
        press.canvas:write ( lang.coopMode )
        title_layer:add_child ( press )

        credits = Sprite ( )
        title_layer:add_child ( credits )
        
        sel = Sprite ( )
        title_layer:add_child ( sel )
        mode = 1
        
        game:PlayMusic ( "Music/Action Game Theme.ogg", true, m_volume )
    elseif s == 'warning' then
        ws = Sprite ( )
        display.viewport:add_child ( ws )

        ws.canvas:set_font ( fontbig )
        local w = fontbig:get_width ( lang.noJoystick )
        ws.canvas:move_to ( -w / 2, 0 )
        ws.canvas:write ( lang.noJoystick )

        ws.canvas:set_font ( game.font )
        local w = game.font:get_width ( lang.attachJoystick )
        ws.canvas:move_to ( -w / 2, -60 )
        ws.canvas:write ( lang.attachJoystick )

    elseif s == 'levelselect' then
        ls = Sprite ( )
        display.viewport:add_child ( ls )

        ls.canvas:set_font ( fontbig )
        local w = game.font:get_width ( lang.missionSelect )
        ls.canvas:move_to ( -w / 2, 0 )
        ls.canvas:write ( lang.missionSelect )

        ls.canvas:set_font ( game.font )
        ls.canvas:move_to ( -50, -60 )
        ls.canvas:write ( lang.militaryCompound )
--[[
        ls.canvas:move_to ( -50, -80 )
        ls.canvas:write ( lang.trainRide )
]]
        sel = Sprite ( )
        display.viewport:add_child ( sel )
        selected = 1
        wasdown = nil
        
        game:PlayMusic ( "Music/10 - The Death Of Aase (Grieg).ogg", true, m_volume )
    elseif s == 'game' then
        enemiesshot = 0
        shots = 0

        level = game:FindStream ( stream )
        level:Select ( )
        world = level.world
        world:SetGravity ( b2Vec2 ( 0, -70 ) )
        world.b2world:SetContactFilter ( cf )
        game.elapsed = 0

        game.camera.visible = true

        hud = Sprite ( )
        display.viewport:add_child ( hud )
        
        local s = game:FindSound ( "Sounds/announcer/ready.wav" )
        game.audio:play ( s )

        game:Play ( )
    elseif s == 'gameover' then
        go = Sprite ( )
        display.viewport:add_child ( go )
        
        go.canvas:set_font ( fontbig )
        local w = game.font:get_width ( lang.gameOver )
        go.canvas:move_to ( -w / 2, 0 )
        go.canvas:write ( lang.gameOver )

        go.canvas:set_font ( game.font )
        go.canvas:move_to ( -50, -60 )
        go.canvas:write ( lang.continue )
        go.canvas:move_to ( -50, -80 )
        go.canvas:write ( lang.quit )

        sel = Sprite ( )
        display.viewport:add_child ( sel )
        
        selected = 1
        wasdown = nil
        
        game:PlayMusic ( "Music/10 - The Death Of Aase (Grieg).ogg", true, m_volume )
    elseif s == 'complete' then
        complete = Sprite ( )
        display.viewport:add_child ( complete )
        
        complete.canvas:set_font ( fontbig )
        local w = game.font:get_width ( lang.missionComplete )
        complete.canvas:move_to ( -w / 2, 0 )
        complete.canvas:write ( lang.missionComplete )
 
        complete.canvas:set_font ( game.font )
        complete.canvas:move_to ( -50, -60 )
        local sz = GetTimeSZ ( game.elapsed )
        complete.canvas:write ( lang.time .. sz )
        complete.canvas:move_to ( -50, -80 )
        complete.canvas:write ( lang.shots .. shots )
        complete.canvas:move_to ( -50, -100 )
        complete.canvas:write ( lang.onTarget .. enemiesshot )
        complete.canvas:move_to ( -50, -120 )
        complete.canvas:write ( lang.accuracy .. math.floor ( enemiesshot / shots * 100 ) .. '%' )
    end
end

function GetTimeSZ ( e )
    local m = math.floor ( e / 60 )
    local s = math.floor ( e - ( m * 60 ) )
    local ms = math.floor ( ( e - ( m * 60 ) - s ) * 100 )
    m = string.format("%.2d", m)
    s = string.format("%.2d", s)
    ms = string.format("%.2d", ms)
    return m .. ':' .. s .. ':' .. ms
end

SelectScreen ( 'title' )

timer = Timer ( )
timer:start ( 16, true )
timer.on_tick = function ( timer )
    screen_time = screen_time + timer:get_delta_ms ( )
    
    if screen == 'title' then
        credits.canvas:clear ( )
        credits.canvas:set_font ( game.font )
        local sz = ""
        if screen_time > 26500 then
            sz = ( lang.credits1 )
        elseif screen_time > 23000 then
            sz = ( lang.credits8 )
        elseif screen_time > 21000 then
            sz = ( lang.credits7 )
        elseif screen_time > 17750 then
            sz = ( lang.credits6 )
        elseif screen_time > 16000 then
            sz = ( lang.credits5 )
        elseif screen_time > 12500 then
            sz = ( lang.credits4 )
        elseif screen_time > 9000 then
            sz = ( lang.credits3 )
        elseif screen_time > 5500 then
            sz = ( lang.credits2 )
        else
            sz = ( lang.credits1 )
        end
        local w = game.font:get_width ( sz )
        credits.canvas:move_to ( -w / 2, -190 )
        credits.canvas:write ( sz )

        if mode == 1 then
            sel.canvas:clear ( )
            sel.canvas:move_to ( -125, -218 )
        elseif mode == 2 then
            sel.canvas:clear ( )
            sel.canvas:move_to ( -125, -248 )
        end
        sel.canvas:rel_line_to ( -5, 5 )
        sel.canvas:rel_line_to ( 0, -10 )
        sel.canvas:close_path ( )
        sel.canvas:fill ( )
        
        if keyboard.down ( BUTTON_UP ) == true or
        ( joystick and joystick.down ( BUTTON_UP ) ) then
            mode = 1
        elseif keyboard.down ( BUTTON_DOWN ) == true or
        ( joystick and joystick.down ( BUTTON_DOWN ) ) then
            mode = 2
        end

        local isdown = false
        isdown = isdown or keyboard.down ( BUTTON_1 ) 
        isdown = isdown or keyboard.down ( BUTTON_2 )
        if joystick then 
            isdown = isdown or joystick.down ( BUTTON_1 ) 
            isdown = isdown or joystick.down ( BUTTON_2 ) 
        end

        if wasdown == false and isdown == true then
            local s = game:FindSound ( "Sounds/select.wav" )
            game.audio:play ( s ) 
            if mode == 2 and joystick == nil then
                SelectScreen ( 'warning' )
            else
                SelectScreen ( 'levelselect' )
            end
        else
            wasdown = isdown
        end
    elseif screen == 'levelselect' then
        if selected == 1 then
            sel.canvas:clear ( )
            sel.canvas:move_to ( -55, -52 )
        elseif selected == 2 then
            sel.canvas:clear ( )
            sel.canvas:move_to ( -55, -72 )
        end
        sel.canvas:rel_line_to ( -5, 5 )
        sel.canvas:rel_line_to ( 0, -10 )
        sel.canvas:close_path ( )
        sel.canvas:fill ( )

        if keyboard.down ( BUTTON_UP ) == true or
        ( joystick and joystick.down ( BUTTON_UP ) ) then
            selected = math.max ( selected - 1, 1 )
        elseif keyboard.down ( BUTTON_DOWN ) == true or
        ( joystick and joystick.down ( BUTTON_DOWN ) ) then
            --selected = math.min ( selected + 1, 2 )
        end

        local isdown = false
        isdown = isdown or keyboard.down ( BUTTON_1 ) 
        isdown = isdown or keyboard.down ( BUTTON_2 )
        if joystick then 
            isdown = isdown or joystick.down ( BUTTON_1 ) 
            isdown = isdown or joystick.down ( BUTTON_2 ) 
        end
        
        if wasdown == false and isdown == true then
            stream = 'Scripts/shmup' .. selected .. '.xml'
            SelectScreen ( 'game' )
        else
            wasdown = isdown
        end
    elseif screen == 'game' then
        hud.canvas:set_font ( game.font )
        hud.canvas:clear ( )
        hud.canvas:move_to ( -380, 270 )
        local sz = GetTimeSZ ( game.elapsed )
        hud.canvas:write ( sz )
    elseif screen == 'gameover' then
        if selected == 1 then
            sel.canvas:clear ( )
            sel.canvas:move_to ( -55, -52 )
        elseif selected == 2 then
            sel.canvas:clear ( )
            sel.canvas:move_to ( -55, -72 )
        end
        sel.canvas:rel_line_to ( -5, 5 )
        sel.canvas:rel_line_to ( 0, -10 )
        sel.canvas:close_path ( )
        sel.canvas:fill ( )

        if screen_time < 1000 then
            return
        end

        if keyboard.down ( BUTTON_UP ) == true or
        ( joystick and joystick.down ( BUTTON_UP ) ) then
            selected = 1
        elseif keyboard.down ( BUTTON_DOWN ) == true or
        ( joystick and joystick.down ( BUTTON_DOWN ) ) then
            selected = 2
        end

        local isdown = false
        isdown = isdown or keyboard.down ( BUTTON_1 ) 
        isdown = isdown or keyboard.down ( BUTTON_2 )
        if joystick then 
            isdown = isdown or joystick.down ( BUTTON_1 ) 
            isdown = isdown or joystick.down ( BUTTON_2 ) 
        end
        
        if wasdown == false and isdown == true then
            if selected == 1 then
                SelectScreen ( 'game' )
            elseif selected == 2 then
                SelectScreen ( 'title' )
            end
        else
            wasdown = isdown
        end
    elseif screen == 'warning' then
        if screen_time > 1000 then
            if keyboard.down ( BUTTON_1 ) == true or
            keyboard.down ( BUTTON_2 ) == true or
            ( joystick and joystick.down ( BUTTON_1 ) == true ) then
                SelectScreen ( 'title' )
            end
        end
    elseif screen == 'complete' then
        if screen_time > 1000 then
            if keyboard.down ( BUTTON_1 ) == true or
            keyboard.down ( BUTTON_2 ) == true or
            ( joystick and joystick.down ( BUTTON_1 ) == true ) then
                SelectScreen ( 'title' )
            end
        end
    end
end


function GameOver ( )
    if mode == 1 then
        SelectScreen ( 'gameover' )
    elseif mode == 2 then
        if game.player.goal.action == 'dead' and
        game.player2.goal.action == 'dead' then
            SelectScreen ( 'gameover' )
        end
    end
end
function MissionOver ( )
    SelectScreen ( 'complete' )
end

function EnemyShot ( )
    enemiesshot = enemiesshot + 1
end
function Shoot ( )
    shots = shots + 1
end

--[[
-- track FPS
timer = Timer ( )
timer:start ( 16, true )
timer.on_tick = function ( timer )
	local fps = 1 / timer:get_delta ( ) * 60
	display:set_title( "FPS:" .. fps .. " Elapsed:" .. timer:get_elapsed ( ) / 1000 )
end
]]

--[[
local hud = Sprite ( )
hud.depth = -100
display.viewport:add_child ( hud )
local i = game:FindImage ( "Images/tileset/overlayC.png" )
for x = -400, 400, 64 do
    for y = -300, 300, 64 do
        hud.canvas:set_source_image ( i, x, y )
        hud.canvas:paint ( )
    end
end

local i = game:FindImage ( "Images/tileset/gradient.png" )
for y = -300, 300, 64 do
    local s = Sprite ( -400 + 32, y )
    s.depth = -101
    s.canvas:set_source_image ( i )
    s.canvas:paint ( )
    display.viewport:add_child ( s )
    
    local s = Sprite ( 400 - 32, y )
    s.depth = -101
    s.rotation = 180
    s.canvas:set_source_image ( i )
    s.canvas:paint ( )
    display.viewport:add_child ( s )
end
for x = -400, 400, 64 do
    local s = Sprite ( x, -300 + 32 )
    s.depth = -101
    s.rotation = 270
    s.canvas:set_source_image ( i )
    s.canvas:paint ( )
    display.viewport:add_child ( s )
    
    local s = Sprite ( x, 300 - 32 )
    s.depth = -101
    s.rotation = 90
    s.canvas:set_source_image ( i )
    s.canvas:paint ( )
    display.viewport:add_child ( s )
end
]]