dofile ( "Scripts/B2DX/framework.lua" )
dofile ( "Scripts/utilities.lua" )

goals = {}
dodir ( lfs.currentdir ( ) .. "/Scripts/B2DX/Goals", false )
dodir ( lfs.currentdir ( ) .. "/Scripts/B2DX/Goals/Conditions", false )
dodir ( lfs.currentdir ( ) .. "/Scripts/B2DX/Goals/Behaviors", false )
dodir ( lfs.currentdir ( ) .. "/Scripts/B2DX/Goals/Effects", false )

g_volume = 0.75
m_volume = 0.25

showBoxes = true

game = Game:Create ( "Shmup", 960, 544, 32, true )
game:DemandSoundDirectory ( "Loops", true )

audio.volume = 1
game.camera:set_scale ( 0.1, 0.1 )

s = game:CreateStream ( "Scripts/shmup1.xml" )
s:Select ( )
w = s.world

function CreateWobbler ( p )
local n = w:GetAvailableName ( )
local b = w:CreateBody ( n, p, 0, 0, 0, true, true, false, false )
b:CreateShapeCircle ( 1.5, b2Vec2 ( 0, 0 ), 1, 0.5, 0, true )
b:Paint ( )
b.sprite:set_scale ( 0.1, 0.1 )

s = SequenceGoal:Create ( true )
-- 5.4856
s:PushBack ( PlaySoundGoal:Create ( 'Loops/Wobble.wav' ) )

-- 1.5

local ps = ProbabilitySelectorGoal:Create ( true )
ps:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 22.5, 0 ), 15 ) )
ps:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( -22.5, 0 ), 15 ) )
s:PushBack ( ps )

s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 0, -7.5 ), 15 ) )

s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( -1, -1 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 1, -1 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( -1, -1 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 1, -1 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( -1, -1 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 1, -1 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( -1, -1 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 1, -1 ), 15 ) )

local ps = ProbabilitySelectorGoal:Create ( true )
ps:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 22.5, 0 ), 15 ) )
ps:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( -22.5, 0 ), 15 ) )
s:PushBack ( ps )

s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 2, 2 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 2, -2 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 2, 2 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 2, -2 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 2, 2 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 2, -2 ), 15 ) )
s:PushBack ( MoveGoal:Create ( 'self', b2Vec2 ( 2, 2 ), 15 ) )

s:PushBack ( WaitGoal:Create ( 0.02 ) )

b:SetGoal ( s )
return b
end

CreateWobbler ( b2Vec2 ( 0, 30 ) )
CreateWobbler ( b2Vec2 ( 0, 25 ) )
CreateWobbler ( b2Vec2 ( 0, 20 ) )
CreateWobbler ( b2Vec2 ( 0, 15 ) )
CreateWobbler ( b2Vec2 ( 0, 10 ) )
CreateWobbler ( b2Vec2 ( 0, 5 ) )
CreateWobbler ( b2Vec2 ( 0, 0 ) )

game:Play ( )